# ibl_ai_data_manager_sdk (EXPERIMENTAL)
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 2.0.12-ai-plus
- Build package: org.openapitools.codegen.languages.DartDioClientCodegen

## Requirements

* Dart 2.15.0+ or Flutter 2.8.0+
* Dio 5.0.0+ (https://pub.dev/packages/dio)

## Installation & Usage

### pub.dev
To use the package from [pub.dev](https://pub.dev), please include the following in pubspec.yaml
```yaml
dependencies:
  ibl_ai_data_manager_sdk: 1.0.0
```

### Github
If this Dart package is published to Github, please include the following in pubspec.yaml
```yaml
dependencies:
  ibl_ai_data_manager_sdk:
    git:
      url: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
      #ref: main
```

### Local development
To use the package from your local drive, please include the following in pubspec.yaml
```yaml
dependencies:
  ibl_ai_data_manager_sdk:
    path: /path/to/ibl_ai_data_manager_sdk
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:ibl_ai_data_manager_sdk/ibl_ai_data_manager_sdk.dart';


final api = IblAiDataManagerSdk().getAiAccountApi();
final String org = org_example; // String | 
final CredentialRequest credentialRequest = ; // CredentialRequest | 

try {
    final response = await api.aiAccountOrgsCredentialCreate(org, credentialRequest);
    print(response);
} catch on DioException (e) {
    print("Exception when calling AiAccountApi->aiAccountOrgsCredentialCreate: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
[*AiAccountApi*](doc/AiAccountApi.md) | [**aiAccountOrgsCredentialCreate**](doc/AiAccountApi.md#aiaccountorgscredentialcreate) | **POST** /api/ai-account/orgs/{org}/credential/ | 
[*AiAccountApi*](doc/AiAccountApi.md) | [**aiAccountOrgsCredentialPartialUpdate**](doc/AiAccountApi.md#aiaccountorgscredentialpartialupdate) | **PATCH** /api/ai-account/orgs/{org}/credential/ | 
[*AiAccountApi*](doc/AiAccountApi.md) | [**aiAccountOrgsCredentialRetrieve**](doc/AiAccountApi.md#aiaccountorgscredentialretrieve) | **GET** /api/ai-account/orgs/{org}/credential/ | 
[*AiAccountApi*](doc/AiAccountApi.md) | [**aiAccountOrgsIntegrationCredentialCreate**](doc/AiAccountApi.md#aiaccountorgsintegrationcredentialcreate) | **POST** /api/ai-account/orgs/{org}/integration-credential/ | 
[*AiAccountApi*](doc/AiAccountApi.md) | [**aiAccountOrgsIntegrationCredentialPartialUpdate**](doc/AiAccountApi.md#aiaccountorgsintegrationcredentialpartialupdate) | **PATCH** /api/ai-account/orgs/{org}/integration-credential/ | 
[*AiAccountApi*](doc/AiAccountApi.md) | [**aiAccountOrgsIntegrationCredentialRetrieve**](doc/AiAccountApi.md#aiaccountorgsintegrationcredentialretrieve) | **GET** /api/ai-account/orgs/{org}/integration-credential/ | 
[*AiAccountApi*](doc/AiAccountApi.md) | [**aiAccountOrgsPlatformMetadataCreate**](doc/AiAccountApi.md#aiaccountorgsplatformmetadatacreate) | **POST** /api/ai-account/orgs/{org}/platform-metadata/ | 
[*AiAccountApi*](doc/AiAccountApi.md) | [**aiAccountOrgsPlatformMetadataList**](doc/AiAccountApi.md#aiaccountorgsplatformmetadatalist) | **GET** /api/ai-account/orgs/{org}/platform-metadata/ | 
[*AiAccountApi*](doc/AiAccountApi.md) | [**aiAccountOrgsPlatformMetadataUpdate**](doc/AiAccountApi.md#aiaccountorgsplatformmetadataupdate) | **PUT** /api/ai-account/orgs/{org}/platform-metadata/ | 
[*AiAccountApi*](doc/AiAccountApi.md) | [**aiAccountOrgsTokensList**](doc/AiAccountApi.md#aiaccountorgstokenslist) | **GET** /api/ai-account/orgs/{org}/tokens/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsBotCommandsCreate**](doc/AiBotApi.md#aibotv1botsbotcommandscreate) | **POST** /api/ai-bot/v1/bots/{org}/bot-commands/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsBotCommandsDestroy**](doc/AiBotApi.md#aibotv1botsbotcommandsdestroy) | **DELETE** /api/ai-bot/v1/bots/{org}/bot-commands/{id}/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsBotCommandsList**](doc/AiBotApi.md#aibotv1botsbotcommandslist) | **GET** /api/ai-bot/v1/bots/{org}/bot-commands/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsBotCommandsPartialUpdate**](doc/AiBotApi.md#aibotv1botsbotcommandspartialupdate) | **PATCH** /api/ai-bot/v1/bots/{org}/bot-commands/{id}/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsBotCommandsRetrieve**](doc/AiBotApi.md#aibotv1botsbotcommandsretrieve) | **GET** /api/ai-bot/v1/bots/{org}/bot-commands/{id}/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsBotCommandsUpdate**](doc/AiBotApi.md#aibotv1botsbotcommandsupdate) | **PUT** /api/ai-bot/v1/bots/{org}/bot-commands/{id}/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsBotCreate**](doc/AiBotApi.md#aibotv1botsbotcreate) | **POST** /api/ai-bot/v1/bots/{org}/bot/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsBotDestroy**](doc/AiBotApi.md#aibotv1botsbotdestroy) | **DELETE** /api/ai-bot/v1/bots/{org}/bot/{id}/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsBotList**](doc/AiBotApi.md#aibotv1botsbotlist) | **GET** /api/ai-bot/v1/bots/{org}/bot/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsBotPartialUpdate**](doc/AiBotApi.md#aibotv1botsbotpartialupdate) | **PATCH** /api/ai-bot/v1/bots/{org}/bot/{id}/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsBotRetrieve**](doc/AiBotApi.md#aibotv1botsbotretrieve) | **GET** /api/ai-bot/v1/bots/{org}/bot/{id}/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsBotUpdate**](doc/AiBotApi.md#aibotv1botsbotupdate) | **PUT** /api/ai-bot/v1/bots/{org}/bot/{id}/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsWebhooksDiscordCreate**](doc/AiBotApi.md#aibotv1botswebhooksdiscordcreate) | **POST** /api/ai-bot/v1/bots/webhooks/{org}/discord/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsWebhooksSlackCreate**](doc/AiBotApi.md#aibotv1botswebhooksslackcreate) | **POST** /api/ai-bot/v1/bots/webhooks/{org}/slack/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsWebhooksWebexCreate**](doc/AiBotApi.md#aibotv1botswebhookswebexcreate) | **POST** /api/ai-bot/v1/bots/webhooks/{org}/webex/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsWebhooksWhatsappCreate**](doc/AiBotApi.md#aibotv1botswebhookswhatsappcreate) | **POST** /api/ai-bot/v1/bots/webhooks/{org}/whatsapp/ | 
[*AiBotApi*](doc/AiBotApi.md) | [**aiBotV1BotsWebhooksWhatsappRetrieve**](doc/AiBotApi.md#aibotv1botswebhookswhatsappretrieve) | **GET** /api/ai-bot/v1/bots/webhooks/{org}/whatsapp/ | 
[*AiIndexApi*](doc/AiIndexApi.md) | [**aiIndexOrgsUsersDocumentsPathwaysRetrieve**](doc/AiIndexApi.md#aiindexorgsusersdocumentspathwaysretrieve) | **GET** /api/ai-index/orgs/{org}/users/{user_id}/documents/pathways/{pathway}/ | 
[*AiIndexApi*](doc/AiIndexApi.md) | [**aiIndexOrgsUsersDocumentsRetrieve**](doc/AiIndexApi.md#aiindexorgsusersdocumentsretrieve) | **GET** /api/ai-index/orgs/{org}/users/{user_id}/documents/{document_id}/ | 
[*AiIndexApi*](doc/AiIndexApi.md) | [**aiIndexOrgsUsersDocumentsSearchCreate**](doc/AiIndexApi.md#aiindexorgsusersdocumentssearchcreate) | **POST** /api/ai-index/orgs/{org}/users/{user_id}/documents/search/ | 
[*AiIndexApi*](doc/AiIndexApi.md) | [**aiIndexOrgsUsersDocumentsSourcesCreate**](doc/AiIndexApi.md#aiindexorgsusersdocumentssourcescreate) | **POST** /api/ai-index/orgs/{org}/users/{user_id}/documents/sources/ | 
[*AiIndexApi*](doc/AiIndexApi.md) | [**aiIndexOrgsUsersDocumentsTasksRetrieve**](doc/AiIndexApi.md#aiindexorgsusersdocumentstasksretrieve) | **GET** /api/ai-index/orgs/{org}/users/{user_id}/documents/tasks/{task_id}/ | 
[*AiIndexApi*](doc/AiIndexApi.md) | [**aiIndexOrgsUsersDocumentsTrainCreate**](doc/AiIndexApi.md#aiindexorgsusersdocumentstraincreate) | **POST** /api/ai-index/orgs/{org}/users/{user_id}/documents/train/ | 
[*AiIndexApi*](doc/AiIndexApi.md) | [**aiIndexOrgsUsersDocumentsTrainMultilingualRetrieverCreate**](doc/AiIndexApi.md#aiindexorgsusersdocumentstrainmultilingualretrievercreate) | **POST** /api/ai-index/orgs/{org}/users/{user_id}/documents/train/multilingual-retriever/ | 
[*AiIndexApi*](doc/AiIndexApi.md) | [**aiIndexOrgsUsersDocumentsTrainRetrieverCreate**](doc/AiIndexApi.md#aiindexorgsusersdocumentstrainretrievercreate) | **POST** /api/ai-index/orgs/{org}/users/{user_id}/documents/train/retriever/ | 
[*AiIndexApi*](doc/AiIndexApi.md) | [**aiIndexOrgsUsersDocumentsTrainSessionsCreate**](doc/AiIndexApi.md#aiindexorgsusersdocumentstrainsessionscreate) | **POST** /api/ai-index/orgs/{org}/users/{user_id}/documents/train/sessions/{session_id}/ | 
[*AiIndexApi*](doc/AiIndexApi.md) | [**aiIndexOrgsUsersDocumentsUpdate**](doc/AiIndexApi.md#aiindexorgsusersdocumentsupdate) | **PUT** /api/ai-index/orgs/{org}/users/{user_id}/documents/{document_id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathMathStudentsCreate**](doc/AiMathApi.md#aimathmathmathstudentscreate) | **POST** /api/ai-math/math/{org}/math-students/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathMathStudentsDestroy**](doc/AiMathApi.md#aimathmathmathstudentsdestroy) | **DELETE** /api/ai-math/math/{org}/math-students/{id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathMathStudentsList**](doc/AiMathApi.md#aimathmathmathstudentslist) | **GET** /api/ai-math/math/{org}/math-students/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathMathStudentsPartialUpdate**](doc/AiMathApi.md#aimathmathmathstudentspartialupdate) | **PATCH** /api/ai-math/math/{org}/math-students/{id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathMathStudentsRetrieve**](doc/AiMathApi.md#aimathmathmathstudentsretrieve) | **GET** /api/ai-math/math/{org}/math-students/{id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathMathStudentsUpdate**](doc/AiMathApi.md#aimathmathmathstudentsupdate) | **PUT** /api/ai-math/math/{org}/math-students/{id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathQuestionsDestroy**](doc/AiMathApi.md#aimathmathquestionsdestroy) | **DELETE** /api/ai-math/math/{org}/questions/{id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathQuestionsList**](doc/AiMathApi.md#aimathmathquestionslist) | **GET** /api/ai-math/math/{org}/questions/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathQuestionsPartialUpdate**](doc/AiMathApi.md#aimathmathquestionspartialupdate) | **PATCH** /api/ai-math/math/{org}/questions/{id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathQuestionsRetrieve**](doc/AiMathApi.md#aimathmathquestionsretrieve) | **GET** /api/ai-math/math/{org}/questions/{id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathSampleQuestionsCreate**](doc/AiMathApi.md#aimathmathsamplequestionscreate) | **POST** /api/ai-math/math/{org}/sample-questions/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathSampleQuestionsDestroy**](doc/AiMathApi.md#aimathmathsamplequestionsdestroy) | **DELETE** /api/ai-math/math/{org}/sample-questions/{id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathSampleQuestionsList**](doc/AiMathApi.md#aimathmathsamplequestionslist) | **GET** /api/ai-math/math/{org}/sample-questions/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathSampleQuestionsRetrieve**](doc/AiMathApi.md#aimathmathsamplequestionsretrieve) | **GET** /api/ai-math/math/{org}/sample-questions/{id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathSkillsCreate**](doc/AiMathApi.md#aimathmathskillscreate) | **POST** /api/ai-math/math/{org}/skills/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathSkillsDestroy**](doc/AiMathApi.md#aimathmathskillsdestroy) | **DELETE** /api/ai-math/math/{org}/skills/{id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathSkillsList**](doc/AiMathApi.md#aimathmathskillslist) | **GET** /api/ai-math/math/{org}/skills/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathSkillsPartialUpdate**](doc/AiMathApi.md#aimathmathskillspartialupdate) | **PATCH** /api/ai-math/math/{org}/skills/{id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathSkillsRetrieve**](doc/AiMathApi.md#aimathmathskillsretrieve) | **GET** /api/ai-math/math/{org}/skills/{id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathSkillsUpdate**](doc/AiMathApi.md#aimathmathskillsupdate) | **PUT** /api/ai-math/math/{org}/skills/{id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathStudentAnswersCreate**](doc/AiMathApi.md#aimathmathstudentanswerscreate) | **POST** /api/ai-math/math/{org}/student-answers/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathStudentAnswersDestroy**](doc/AiMathApi.md#aimathmathstudentanswersdestroy) | **DELETE** /api/ai-math/math/{org}/student-answers/{id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathStudentAnswersList**](doc/AiMathApi.md#aimathmathstudentanswerslist) | **GET** /api/ai-math/math/{org}/student-answers/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathStudentAnswersPartialUpdate**](doc/AiMathApi.md#aimathmathstudentanswerspartialupdate) | **PATCH** /api/ai-math/math/{org}/student-answers/{id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathStudentAnswersRetrieve**](doc/AiMathApi.md#aimathmathstudentanswersretrieve) | **GET** /api/ai-math/math/{org}/student-answers/{id}/ | 
[*AiMathApi*](doc/AiMathApi.md) | [**aiMathMathStudentAnswersUpdate**](doc/AiMathApi.md#aimathmathstudentanswersupdate) | **PUT** /api/ai-math/math/{org}/student-answers/{id}/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorGenerationsStopGenerationCreate**](doc/AiMentorApi.md#aimentorgenerationsstopgenerationcreate) | **POST** /api/ai-mentor/generations/{generation_id}/stop-generation/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsSessionsCreate**](doc/AiMentorApi.md#aimentororgssessionscreate) | **POST** /api/ai-mentor/orgs/{org}/sessions/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersAudioToTextCreate**](doc/AiMentorApi.md#aimentororgsusersaudiototextcreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/audio-to-text/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersCategoryCreate**](doc/AiMentorApi.md#aimentororgsuserscategorycreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/category | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersCategoryDestroy**](doc/AiMentorApi.md#aimentororgsuserscategorydestroy) | **DELETE** /api/ai-mentor/orgs/{org}/users/{user_id}/category | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersCategoryRetrieve**](doc/AiMentorApi.md#aimentororgsuserscategoryretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/category | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersCreate**](doc/AiMentorApi.md#aimentororgsuserscreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersDestroy**](doc/AiMentorApi.md#aimentororgsusersdestroy) | **DELETE** /api/ai-mentor/orgs/{org}/users/{user_id}/{name}/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersFreeUsageCountRetrieve**](doc/AiMentorApi.md#aimentororgsusersfreeusagecountretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/free-usage-count/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersList**](doc/AiMentorApi.md#aimentororgsuserslist) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersMentorFeedbackCreateCreate**](doc/AiMentorApi.md#aimentororgsusersmentorfeedbackcreatecreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/mentor-feedback/create/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersMentorFeedbackRetrieve**](doc/AiMentorApi.md#aimentororgsusersmentorfeedbackretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/mentor-feedback/{feedback_id}/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersMentorFeedbackUpdate**](doc/AiMentorApi.md#aimentororgsusersmentorfeedbackupdate) | **PUT** /api/ai-mentor/orgs/{org}/users/{user_id}/mentor-feedback/{feedback_id}/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersMentorFromTemplateCreate**](doc/AiMentorApi.md#aimentororgsusersmentorfromtemplatecreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/mentor-from-template/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersMentorLlmsRetrieve**](doc/AiMentorApi.md#aimentororgsusersmentorllmsretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/mentor-llms/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersMentorWithSettingsCreate**](doc/AiMentorApi.md#aimentororgsusersmentorwithsettingscreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/mentor-with-settings/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersMentorsPublicSettingsRetrieve**](doc/AiMentorApi.md#aimentororgsusersmentorspublicsettingsretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/public-settings/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersMentorsRetrieve**](doc/AiMentorApi.md#aimentororgsusersmentorsretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersMentorsSettingsRetrieve**](doc/AiMentorApi.md#aimentororgsusersmentorssettingsretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/settings/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersMentorsSettingsUpdate**](doc/AiMentorApi.md#aimentororgsusersmentorssettingsupdate) | **PUT** /api/ai-mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/settings/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersPartialUpdate**](doc/AiMentorApi.md#aimentororgsuserspartialupdate) | **PATCH** /api/ai-mentor/orgs/{org}/users/{user_id}/{name}/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersPinMessageCreate**](doc/AiMentorApi.md#aimentororgsuserspinmessagecreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/pin-message/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersPinMessageDestroy**](doc/AiMentorApi.md#aimentororgsuserspinmessagedestroy) | **DELETE** /api/ai-mentor/orgs/{org}/users/{user_id}/pin-message/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersPinMessageRetrieve**](doc/AiMentorApi.md#aimentororgsuserspinmessageretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/pin-message/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersPredictiveAnalyticsCreate**](doc/AiMentorApi.md#aimentororgsuserspredictiveanalyticscreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/predictive-analytics/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersRecentMessagesRetrieve**](doc/AiMentorApi.md#aimentororgsusersrecentmessagesretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/recent-messages/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersRecommendCoursesRetrieve**](doc/AiMentorApi.md#aimentororgsusersrecommendcoursesretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/recommend-courses/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersRetrieve**](doc/AiMentorApi.md#aimentororgsusersretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/{name}/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersSessionidList**](doc/AiMentorApi.md#aimentororgsuserssessionidlist) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/sessionid/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersSessionsCreate**](doc/AiMentorApi.md#aimentororgsuserssessionscreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/sessions/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersSessionsDestroy**](doc/AiMentorApi.md#aimentororgsuserssessionsdestroy) | **DELETE** /api/ai-mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersSessionsDownloadSessionRetrieve**](doc/AiMentorApi.md#aimentororgsuserssessionsdownloadsessionretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/download-session | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersSessionsRetrieve**](doc/AiMentorApi.md#aimentororgsuserssessionsretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersSessionsSuggestionRetrieve**](doc/AiMentorApi.md#aimentororgsuserssessionssuggestionretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/suggestion | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersSessionsTasksRetrieve**](doc/AiMentorApi.md#aimentororgsuserssessionstasksretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/tasks/{task_id}/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersSessionsUpdate**](doc/AiMentorApi.md#aimentororgsuserssessionsupdate) | **PUT** /api/ai-mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersTasksRetrieve**](doc/AiMentorApi.md#aimentororgsuserstasksretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/tasks/{task_id} | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersTasksSessionsCreate**](doc/AiMentorApi.md#aimentororgsuserstaskssessionscreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/tasks/sessions/{session_id}/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersUpdate**](doc/AiMentorApi.md#aimentororgsusersupdate) | **PUT** /api/ai-mentor/orgs/{org}/users/{user_id}/{name}/ | 
[*AiMentorApi*](doc/AiMentorApi.md) | [**aiMentorOrgsUsersUsageRetrieve**](doc/AiMentorApi.md#aimentororgsusersusageretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/usage/ | 
[*AiPromptApi*](doc/AiPromptApi.md) | [**aiPromptOrgsUsersMentorsSuggestedPromptsCreate**](doc/AiPromptApi.md#aipromptorgsusersmentorssuggestedpromptscreate) | **POST** /api/ai-prompt/orgs/{org}/users/{user_id}/mentors/{mentor}/suggested-prompts/ | 
[*AiPromptApi*](doc/AiPromptApi.md) | [**aiPromptOrgsUsersMentorsSuggestedPromptsDestroy**](doc/AiPromptApi.md#aipromptorgsusersmentorssuggestedpromptsdestroy) | **DELETE** /api/ai-prompt/orgs/{org}/users/{user_id}/mentors/{mentor}/suggested-prompts/ | 
[*AiPromptApi*](doc/AiPromptApi.md) | [**aiPromptOrgsUsersMentorsSuggestedPromptsRetrieve**](doc/AiPromptApi.md#aipromptorgsusersmentorssuggestedpromptsretrieve) | **GET** /api/ai-prompt/orgs/{org}/users/{user_id}/mentors/{mentor}/suggested-prompts/ | 
[*AiPromptApi*](doc/AiPromptApi.md) | [**aiPromptOrgsUsersMentorsSuggestedPromptsUpdate**](doc/AiPromptApi.md#aipromptorgsusersmentorssuggestedpromptsupdate) | **PUT** /api/ai-prompt/orgs/{org}/users/{user_id}/mentors/{mentor}/suggested-prompts/ | 
[*AiPromptApi*](doc/AiPromptApi.md) | [**aiPromptOrgsUsersPromptCreate**](doc/AiPromptApi.md#aipromptorgsuserspromptcreate) | **POST** /api/ai-prompt/orgs/{org}/users/{user_id}/prompt/ | 
[*AiPromptApi*](doc/AiPromptApi.md) | [**aiPromptOrgsUsersPromptDestroy**](doc/AiPromptApi.md#aipromptorgsuserspromptdestroy) | **DELETE** /api/ai-prompt/orgs/{org}/users/{user_id}/prompt/{id}/ | 
[*AiPromptApi*](doc/AiPromptApi.md) | [**aiPromptOrgsUsersPromptList**](doc/AiPromptApi.md#aipromptorgsuserspromptlist) | **GET** /api/ai-prompt/orgs/{org}/users/{user_id}/prompt/ | 
[*AiPromptApi*](doc/AiPromptApi.md) | [**aiPromptOrgsUsersPromptPartialUpdate**](doc/AiPromptApi.md#aipromptorgsuserspromptpartialupdate) | **PATCH** /api/ai-prompt/orgs/{org}/users/{user_id}/prompt/{id}/ | 
[*AiPromptApi*](doc/AiPromptApi.md) | [**aiPromptOrgsUsersPromptRetrieve**](doc/AiPromptApi.md#aipromptorgsuserspromptretrieve) | **GET** /api/ai-prompt/orgs/{org}/users/{user_id}/prompt/{id}/ | 
[*AiPromptApi*](doc/AiPromptApi.md) | [**aiPromptOrgsUsersPromptUpdate**](doc/AiPromptApi.md#aipromptorgsuserspromptupdate) | **PUT** /api/ai-prompt/orgs/{org}/users/{user_id}/prompt/{id}/ | 
[*AiPromptApi*](doc/AiPromptApi.md) | [**aiPromptOrgsUsersPromptsCategoryCreate**](doc/AiPromptApi.md#aipromptorgsuserspromptscategorycreate) | **POST** /api/ai-prompt/orgs/{org}/users/{user_id}/prompts/category/ | 
[*AiPromptApi*](doc/AiPromptApi.md) | [**aiPromptOrgsUsersPromptsCategoryDestroy**](doc/AiPromptApi.md#aipromptorgsuserspromptscategorydestroy) | **DELETE** /api/ai-prompt/orgs/{org}/users/{user_id}/prompts/category/ | 
[*AiPromptApi*](doc/AiPromptApi.md) | [**aiPromptOrgsUsersPromptsCategoryRetrieve**](doc/AiPromptApi.md#aipromptorgsuserspromptscategoryretrieve) | **GET** /api/ai-prompt/orgs/{org}/users/{user_id}/prompts/category/ | 
[*AiPromptApi*](doc/AiPromptApi.md) | [**aiPromptOrgsUsersSessionsGuidedPromptsRetrieve**](doc/AiPromptApi.md#aipromptorgsuserssessionsguidedpromptsretrieve) | **GET** /api/ai-prompt/orgs/{org}/users/{user_id}/sessions/{session_id}/guided-prompts/ | 
[*AudienceApi*](doc/AudienceApi.md) | [**audienceOrgsActiveUsersOverTimeRetrieve**](doc/AudienceApi.md#audienceorgsactiveusersovertimeretrieve) | **GET** /api/audience/orgs/{org}/active-users/over-time | 
[*AudienceApi*](doc/AudienceApi.md) | [**audienceOrgsActiveUsersPerCourseRetrieve**](doc/AudienceApi.md#audienceorgsactiveuserspercourseretrieve) | **GET** /api/audience/orgs/{org}/active-users/per-course | 
[*AudienceApi*](doc/AudienceApi.md) | [**audienceOrgsActiveUsersUsersRetrieve**](doc/AudienceApi.md#audienceorgsactiveusersusersretrieve) | **GET** /api/audience/orgs/{org}/active-users/users | 
[*AudienceApi*](doc/AudienceApi.md) | [**audienceOrgsEnrollmentsCoursesOverTimeRetrieve**](doc/AudienceApi.md#audienceorgsenrollmentscoursesovertimeretrieve) | **GET** /api/audience/orgs/{org}/enrollments/courses/{course_id}/over-time | 
[*AudienceApi*](doc/AudienceApi.md) | [**audienceOrgsEnrollmentsCoursesUsersRetrieve**](doc/AudienceApi.md#audienceorgsenrollmentscoursesusersretrieve) | **GET** /api/audience/orgs/{org}/enrollments/courses/{course_id}/users | 
[*AudienceApi*](doc/AudienceApi.md) | [**audienceOrgsEnrollmentsOverTimeRetrieve**](doc/AudienceApi.md#audienceorgsenrollmentsovertimeretrieve) | **GET** /api/audience/orgs/{org}/enrollments/over-time | 
[*AudienceApi*](doc/AudienceApi.md) | [**audienceOrgsEnrollmentsPerCourseRetrieve**](doc/AudienceApi.md#audienceorgsenrollmentspercourseretrieve) | **GET** /api/audience/orgs/{org}/enrollments/per-course | 
[*AudienceApi*](doc/AudienceApi.md) | [**audienceOrgsRegisteredUsersOverTimeRetrieve**](doc/AudienceApi.md#audienceorgsregisteredusersovertimeretrieve) | **GET** /api/audience/orgs/{org}/registered-users/over-time | 
[*AudienceApi*](doc/AudienceApi.md) | [**audienceOrgsRegisteredUsersPerCourseRetrieve**](doc/AudienceApi.md#audienceorgsregistereduserspercourseretrieve) | **GET** /api/audience/orgs/{org}/registered-users/per-course | 
[*AudienceApi*](doc/AudienceApi.md) | [**audienceOrgsRegisteredUsersRetrieve**](doc/AudienceApi.md#audienceorgsregisteredusersretrieve) | **GET** /api/audience/orgs/{org}/registered-users/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogConditionalsCourseEligibilityRetrieve**](doc/CatalogApi.md#catalogconditionalscourseeligibilityretrieve) | **GET** /api/catalog/conditionals/course/eligibility/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogConditionalsCoursePrerequisitesManageBulkCreate**](doc/CatalogApi.md#catalogconditionalscourseprerequisitesmanagebulkcreate) | **POST** /api/catalog/conditionals/course/prerequisites/manage/bulk/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogConditionalsCoursePrerequisitesManageRetrieve**](doc/CatalogApi.md#catalogconditionalscourseprerequisitesmanageretrieve) | **GET** /api/catalog/conditionals/course/prerequisites/manage/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogCoursesCreate**](doc/CatalogApi.md#catalogcoursescreate) | **POST** /api/catalog/courses/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogCoursesDestroy**](doc/CatalogApi.md#catalogcoursesdestroy) | **DELETE** /api/catalog/courses/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogCoursesRetrieve**](doc/CatalogApi.md#catalogcoursesretrieve) | **GET** /api/catalog/courses/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogEligibilityCoursesCheckRetrieve**](doc/CatalogApi.md#catalogeligibilitycoursescheckretrieve) | **GET** /api/catalog/eligibility/courses/check/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogEligibilityCoursesRetrieve**](doc/CatalogApi.md#catalogeligibilitycoursesretrieve) | **GET** /api/catalog/eligibility/courses/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogEnrollmentCoursesSearchRetrieve**](doc/CatalogApi.md#catalogenrollmentcoursessearchretrieve) | **GET** /api/catalog/enrollment/courses/search/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogEnrollmentProgramsCreate**](doc/CatalogApi.md#catalogenrollmentprogramscreate) | **POST** /api/catalog/enrollment/programs/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogEnrollmentProgramsDestroy**](doc/CatalogApi.md#catalogenrollmentprogramsdestroy) | **DELETE** /api/catalog/enrollment/programs/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogEnrollmentProgramsRetrieve**](doc/CatalogApi.md#catalogenrollmentprogramsretrieve) | **GET** /api/catalog/enrollment/programs/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogIncrementCreate**](doc/CatalogApi.md#catalogincrementcreate) | **POST** /api/catalog/increment/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogIncrementRetrieve**](doc/CatalogApi.md#catalogincrementretrieve) | **GET** /api/catalog/increment/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogInvitationsCourseBulkCreate**](doc/CatalogApi.md#cataloginvitationscoursebulkcreate) | **POST** /api/catalog/invitations/course/bulk/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogInvitationsCourseCreate**](doc/CatalogApi.md#cataloginvitationscoursecreate) | **POST** /api/catalog/invitations/course/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogInvitationsCourseDestroy**](doc/CatalogApi.md#cataloginvitationscoursedestroy) | **DELETE** /api/catalog/invitations/course/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogInvitationsCourseRedeemCreate**](doc/CatalogApi.md#cataloginvitationscourseredeemcreate) | **POST** /api/catalog/invitations/course/redeem/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogInvitationsCourseRetrieve**](doc/CatalogApi.md#cataloginvitationscourseretrieve) | **GET** /api/catalog/invitations/course/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogInvitationsPlatformBulkCreate**](doc/CatalogApi.md#cataloginvitationsplatformbulkcreate) | **POST** /api/catalog/invitations/platform/bulk/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogInvitationsPlatformCreate**](doc/CatalogApi.md#cataloginvitationsplatformcreate) | **POST** /api/catalog/invitations/platform/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogInvitationsPlatformDestroy**](doc/CatalogApi.md#cataloginvitationsplatformdestroy) | **DELETE** /api/catalog/invitations/platform/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogInvitationsPlatformRedeemCreate**](doc/CatalogApi.md#cataloginvitationsplatformredeemcreate) | **POST** /api/catalog/invitations/platform/redeem/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogInvitationsPlatformRetrieve**](doc/CatalogApi.md#cataloginvitationsplatformretrieve) | **GET** /api/catalog/invitations/platform/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogInvitationsProgramBulkCreate**](doc/CatalogApi.md#cataloginvitationsprogrambulkcreate) | **POST** /api/catalog/invitations/program/bulk/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogInvitationsProgramCreate**](doc/CatalogApi.md#cataloginvitationsprogramcreate) | **POST** /api/catalog/invitations/program/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogInvitationsProgramDestroy**](doc/CatalogApi.md#cataloginvitationsprogramdestroy) | **DELETE** /api/catalog/invitations/program/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogInvitationsProgramRedeemCreate**](doc/CatalogApi.md#cataloginvitationsprogramredeemcreate) | **POST** /api/catalog/invitations/program/redeem/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogInvitationsProgramRetrieve**](doc/CatalogApi.md#cataloginvitationsprogramretrieve) | **GET** /api/catalog/invitations/program/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMetadataChoicesRetrieve**](doc/CatalogApi.md#catalogmetadatachoicesretrieve) | **GET** /api/catalog/metadata/choices/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMetadataCourseCreate**](doc/CatalogApi.md#catalogmetadatacoursecreate) | **POST** /api/catalog/metadata/course/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMetadataCourseCreate2**](doc/CatalogApi.md#catalogmetadatacoursecreate2) | **POST** /api/catalog/metadata/course/{field}/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMetadataCoursePublicRetrieve**](doc/CatalogApi.md#catalogmetadatacoursepublicretrieve) | **GET** /api/catalog/metadata/course-public/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMetadataCoursePublicRetrieve2**](doc/CatalogApi.md#catalogmetadatacoursepublicretrieve2) | **GET** /api/catalog/metadata/course-public/{field}/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMetadataCourseRetrieve**](doc/CatalogApi.md#catalogmetadatacourseretrieve) | **GET** /api/catalog/metadata/course/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMetadataCourseRetrieve2**](doc/CatalogApi.md#catalogmetadatacourseretrieve2) | **GET** /api/catalog/metadata/course/{field}/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMetadataProgramCreate**](doc/CatalogApi.md#catalogmetadataprogramcreate) | **POST** /api/catalog/metadata/program/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMetadataProgramCreate2**](doc/CatalogApi.md#catalogmetadataprogramcreate2) | **POST** /api/catalog/metadata/program/{field}/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMetadataProgramPublicRetrieve**](doc/CatalogApi.md#catalogmetadataprogrampublicretrieve) | **GET** /api/catalog/metadata/program-public/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMetadataProgramPublicRetrieve2**](doc/CatalogApi.md#catalogmetadataprogrampublicretrieve2) | **GET** /api/catalog/metadata/program-public/{field}/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMetadataProgramRetrieve**](doc/CatalogApi.md#catalogmetadataprogramretrieve) | **GET** /api/catalog/metadata/program/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMetadataProgramRetrieve2**](doc/CatalogApi.md#catalogmetadataprogramretrieve2) | **GET** /api/catalog/metadata/program/{field}/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMilestonesCompletionsCourseCatalogRetrieve**](doc/CatalogApi.md#catalogmilestonescompletionscoursecatalogretrieve) | **GET** /api/catalog/milestones/completions/course/catalog/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMilestonesCompletionsCourseManageCreate**](doc/CatalogApi.md#catalogmilestonescompletionscoursemanagecreate) | **POST** /api/catalog/milestones/completions/course/manage/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMilestonesCompletionsCourseManageRetrieve**](doc/CatalogApi.md#catalogmilestonescompletionscoursemanageretrieve) | **GET** /api/catalog/milestones/completions/course/manage/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMilestonesCompletionsResourceManageCreate**](doc/CatalogApi.md#catalogmilestonescompletionsresourcemanagecreate) | **POST** /api/catalog/milestones/completions/resource/manage/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMilestonesCompletionsResourceManageRetrieve**](doc/CatalogApi.md#catalogmilestonescompletionsresourcemanageretrieve) | **GET** /api/catalog/milestones/completions/resource/manage/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMilestonesSkillPointsBlockCreate**](doc/CatalogApi.md#catalogmilestonesskillpointsblockcreate) | **POST** /api/catalog/milestones/skill_points/block/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMilestonesSkillPointsBlockRetrieve**](doc/CatalogApi.md#catalogmilestonesskillpointsblockretrieve) | **GET** /api/catalog/milestones/skill_points/block/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMilestonesSkillPointsCourseCreate**](doc/CatalogApi.md#catalogmilestonesskillpointscoursecreate) | **POST** /api/catalog/milestones/skill_points/course/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMilestonesSkillPointsCourseRetrieve**](doc/CatalogApi.md#catalogmilestonesskillpointscourseretrieve) | **GET** /api/catalog/milestones/skill_points/course/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogMilestonesSkillPointsUserRetrieve**](doc/CatalogApi.md#catalogmilestonesskillpointsuserretrieve) | **GET** /api/catalog/milestones/skill_points/user/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogPathwaysCreate**](doc/CatalogApi.md#catalogpathwayscreate) | **POST** /api/catalog/pathways/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogPathwaysDestroy**](doc/CatalogApi.md#catalogpathwaysdestroy) | **DELETE** /api/catalog/pathways/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogPathwaysRetrieve**](doc/CatalogApi.md#catalogpathwaysretrieve) | **GET** /api/catalog/pathways/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogProgramsCreate**](doc/CatalogApi.md#catalogprogramscreate) | **POST** /api/catalog/programs/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogProgramsDestroy**](doc/CatalogApi.md#catalogprogramsdestroy) | **DELETE** /api/catalog/programs/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogProgramsRetrieve**](doc/CatalogApi.md#catalogprogramsretrieve) | **GET** /api/catalog/programs/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogRecommendationCoursesRetrieve**](doc/CatalogApi.md#catalogrecommendationcoursesretrieve) | **GET** /api/catalog/recommendation/courses/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogResourcesCreate**](doc/CatalogApi.md#catalogresourcescreate) | **POST** /api/catalog/resources/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogResourcesDestroy**](doc/CatalogApi.md#catalogresourcesdestroy) | **DELETE** /api/catalog/resources/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogResourcesRetrieve**](doc/CatalogApi.md#catalogresourcesretrieve) | **GET** /api/catalog/resources/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogReviewsCoursesCreate**](doc/CatalogApi.md#catalogreviewscoursescreate) | **POST** /api/catalog/reviews/courses/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogReviewsCoursesRetrieve**](doc/CatalogApi.md#catalogreviewscoursesretrieve) | **GET** /api/catalog/reviews/courses/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogRolesCreate**](doc/CatalogApi.md#catalogrolescreate) | **POST** /api/catalog/roles/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogRolesDesiredCreate**](doc/CatalogApi.md#catalogrolesdesiredcreate) | **POST** /api/catalog/roles/desired/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogRolesDesiredRetrieve**](doc/CatalogApi.md#catalogrolesdesiredretrieve) | **GET** /api/catalog/roles/desired/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogRolesReportedCreate**](doc/CatalogApi.md#catalogrolesreportedcreate) | **POST** /api/catalog/roles/reported/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogRolesReportedRetrieve**](doc/CatalogApi.md#catalogrolesreportedretrieve) | **GET** /api/catalog/roles/reported/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogRolesRetrieve**](doc/CatalogApi.md#catalogrolesretrieve) | **GET** /api/catalog/roles/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogSearchProgramsCreate**](doc/CatalogApi.md#catalogsearchprogramscreate) | **POST** /api/catalog/search/programs/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogSkillsCreate**](doc/CatalogApi.md#catalogskillscreate) | **POST** /api/catalog/skills/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogSkillsDesiredCreate**](doc/CatalogApi.md#catalogskillsdesiredcreate) | **POST** /api/catalog/skills/desired/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogSkillsDesiredRetrieve**](doc/CatalogApi.md#catalogskillsdesiredretrieve) | **GET** /api/catalog/skills/desired/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogSkillsReportedCreate**](doc/CatalogApi.md#catalogskillsreportedcreate) | **POST** /api/catalog/skills/reported/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogSkillsReportedRetrieve**](doc/CatalogApi.md#catalogskillsreportedretrieve) | **GET** /api/catalog/skills/reported/ | 
[*CatalogApi*](doc/CatalogApi.md) | [**catalogSkillsRetrieve**](doc/CatalogApi.md#catalogskillsretrieve) | **GET** /api/catalog/skills/ | 
[*CoreApi*](doc/CoreApi.md) | [**coreLauncherCreate**](doc/CoreApi.md#corelaunchercreate) | **POST** /api/core/launcher/ | 
[*CoreApi*](doc/CoreApi.md) | [**coreLauncherRetrieve**](doc/CoreApi.md#corelauncherretrieve) | **GET** /api/core/launcher/ | 
[*CoreApi*](doc/CoreApi.md) | [**corePlatformConfigSiteCreate**](doc/CoreApi.md#coreplatformconfigsitecreate) | **POST** /api/core/platform/config/site/ | 
[*CoreApi*](doc/CoreApi.md) | [**corePlatformConfigSiteRetrieve**](doc/CoreApi.md#coreplatformconfigsiteretrieve) | **GET** /api/core/platform/config/site/ | 
[*CoreApi*](doc/CoreApi.md) | [**corePlatformCreate**](doc/CoreApi.md#coreplatformcreate) | **POST** /api/core/platform/ | 
[*CoreApi*](doc/CoreApi.md) | [**corePlatformRetrieve**](doc/CoreApi.md#coreplatformretrieve) | **GET** /api/core/platform/ | 
[*CoreApi*](doc/CoreApi.md) | [**corePlatformUsersRetrieve**](doc/CoreApi.md#coreplatformusersretrieve) | **GET** /api/core/platform/users/ | 
[*CoreApi*](doc/CoreApi.md) | [**coreSignalsEdxCreate**](doc/CoreApi.md#coresignalsedxcreate) | **POST** /api/core/signals/edx/ | 
[*CoreApi*](doc/CoreApi.md) | [**coreUsersPlatformsCreate**](doc/CoreApi.md#coreusersplatformscreate) | **POST** /api/core/users/platforms/ | 
[*CoreApi*](doc/CoreApi.md) | [**coreUsersPlatformsList**](doc/CoreApi.md#coreusersplatformslist) | **GET** /api/core/users/platforms/ | 
[*CoreApi*](doc/CoreApi.md) | [**coreUsersProxyBulkCreate**](doc/CoreApi.md#coreusersproxybulkcreate) | **POST** /api/core/users/proxy/bulk/ | 
[*CoreApi*](doc/CoreApi.md) | [**coreUsersProxyCreate**](doc/CoreApi.md#coreusersproxycreate) | **POST** /api/core/users/proxy/ | 
[*CoreApi*](doc/CoreApi.md) | [**coreUsersProxyRetrieve**](doc/CoreApi.md#coreusersproxyretrieve) | **GET** /api/core/users/proxy/ | 
[*CoreApi*](doc/CoreApi.md) | [**coreUsersSearchRetrieve**](doc/CoreApi.md#coreuserssearchretrieve) | **GET** /api/core/users/search | 
[*CredApi*](doc/CredApi.md) | [**credV2AssertionsRetrieve**](doc/CredApi.md#credv2assertionsretrieve) | **GET** /api/cred/v2/assertions/ | 
[*CredApi*](doc/CredApi.md) | [**credV2AssertionsRetrieve2**](doc/CredApi.md#credv2assertionsretrieve2) | **GET** /api/cred/v2/assertions/{entity_id} | 
[*CredApi*](doc/CredApi.md) | [**credV2AssertionsUpdate**](doc/CredApi.md#credv2assertionsupdate) | **PUT** /api/cred/v2/assertions/{entity_id} | 
[*CredApi*](doc/CredApi.md) | [**credV2CredentialsAssertionsBulkCreate**](doc/CredApi.md#credv2credentialsassertionsbulkcreate) | **POST** /api/cred/v2/credentials/{entity_id}/assertions/bulk/ | 
[*CredApi*](doc/CredApi.md) | [**credV2CredentialsAssertionsCreate**](doc/CredApi.md#credv2credentialsassertionscreate) | **POST** /api/cred/v2/credentials/{entity_id}/assertions/ | 
[*CredApi*](doc/CredApi.md) | [**credV2CredentialsAssertionsRetrieve**](doc/CredApi.md#credv2credentialsassertionsretrieve) | **GET** /api/cred/v2/credentials/{entity_id}/assertions/ | 
[*CredApi*](doc/CredApi.md) | [**credV2CredentialsCreate**](doc/CredApi.md#credv2credentialscreate) | **POST** /api/cred/v2/credentials/ | 
[*CredApi*](doc/CredApi.md) | [**credV2CredentialsDestroy**](doc/CredApi.md#credv2credentialsdestroy) | **DELETE** /api/cred/v2/credentials/{entity_id} | 
[*CredApi*](doc/CredApi.md) | [**credV2CredentialsRetrieve**](doc/CredApi.md#credv2credentialsretrieve) | **GET** /api/cred/v2/credentials/ | 
[*CredApi*](doc/CredApi.md) | [**credV2CredentialsRetrieve2**](doc/CredApi.md#credv2credentialsretrieve2) | **GET** /api/cred/v2/credentials/{entity_id} | 
[*CredApi*](doc/CredApi.md) | [**credV2CredentialsUpdate**](doc/CredApi.md#credv2credentialsupdate) | **PUT** /api/cred/v2/credentials/{entity_id} | 
[*CredApi*](doc/CredApi.md) | [**credV2IssuersAuthorityCreate**](doc/CredApi.md#credv2issuersauthoritycreate) | **POST** /api/cred/v2/issuers/authority/ | 
[*CredApi*](doc/CredApi.md) | [**credV2IssuersCreate**](doc/CredApi.md#credv2issuerscreate) | **POST** /api/cred/v2/issuers/ | 
[*CredApi*](doc/CredApi.md) | [**credV2IssuersDestroy**](doc/CredApi.md#credv2issuersdestroy) | **DELETE** /api/cred/v2/issuers/{entity_id} | 
[*CredApi*](doc/CredApi.md) | [**credV2IssuersRetrieve**](doc/CredApi.md#credv2issuersretrieve) | **GET** /api/cred/v2/issuers/ | 
[*CredApi*](doc/CredApi.md) | [**credV2IssuersRetrieve2**](doc/CredApi.md#credv2issuersretrieve2) | **GET** /api/cred/v2/issuers/{entity_id} | 
[*CredApi*](doc/CredApi.md) | [**credV2IssuersUpdate**](doc/CredApi.md#credv2issuersupdate) | **PUT** /api/cred/v2/issuers/{entity_id} | 
[*CredentialsApi*](doc/CredentialsApi.md) | [**credentialsOrgsAssertionsList**](doc/CredentialsApi.md#credentialsorgsassertionslist) | **GET** /api/credentials/orgs/{org}/assertions/ | 
[*CredentialsApi*](doc/CredentialsApi.md) | [**credentialsOrgsAssertionsOverTimeRetrieve**](doc/CredentialsApi.md#credentialsorgsassertionsovertimeretrieve) | **GET** /api/credentials/orgs/{org}/assertions-over-time/ | 
[*CredentialsApi*](doc/CredentialsApi.md) | [**credentialsOrgsCourseAssertionsOverTimeRetrieve**](doc/CredentialsApi.md#credentialsorgscourseassertionsovertimeretrieve) | **GET** /api/credentials/orgs/{org}/course-assertions-over-time/ | 
[*CredentialsApi*](doc/CredentialsApi.md) | [**credentialsOrgsCourseCredentialsList**](doc/CredentialsApi.md#credentialsorgscoursecredentialslist) | **GET** /api/credentials/orgs/{org}/course-credentials/ | 
[*CredentialsApi*](doc/CredentialsApi.md) | [**credentialsOrgsCredentialsOverTimeRetrieve**](doc/CredentialsApi.md#credentialsorgscredentialsovertimeretrieve) | **GET** /api/credentials/orgs/{org}/credentials-over-time/ | 
[*CredentialsApi*](doc/CredentialsApi.md) | [**credentialsOrgsCredentialsRetrieve**](doc/CredentialsApi.md#credentialsorgscredentialsretrieve) | **GET** /api/credentials/orgs/{org}/credentials/{id}/ | 
[*CredentialsApi*](doc/CredentialsApi.md) | [**credentialsOrgsList**](doc/CredentialsApi.md#credentialsorgslist) | **GET** /api/credentials/orgs/{org}/ | 
[*DocumentsearchApi*](doc/DocumentsearchApi.md) | [**documentsearchRetrieve**](doc/DocumentsearchApi.md#documentsearchretrieve) | **GET** /documentsearch/ | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsActivityRetrieve**](doc/EngagementApi.md#engagementorgsactivityretrieve) | **GET** /api/engagement/orgs/{org}/activity | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsCourseCompletionPerCourseRetrieve**](doc/EngagementApi.md#engagementorgscoursecompletionpercourseretrieve) | **GET** /api/engagement/orgs/{org}/course_completion/per-course | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsCoursesTimeAverageRetrieve**](doc/EngagementApi.md#engagementorgscoursestimeaverageretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/time/average | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsCoursesTimeDetailRetrieve**](doc/EngagementApi.md#engagementorgscoursestimedetailretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/time/detail | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsCoursesTimeOverTimeRetrieve**](doc/EngagementApi.md#engagementorgscoursestimeovertimeretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/time/over-time | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsCoursesTimeUsersDetailRetrieve**](doc/EngagementApi.md#engagementorgscoursestimeusersdetailretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/time/users/{user_id}/detail | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsCoursesTimeUsersOverTimeRetrieve**](doc/EngagementApi.md#engagementorgscoursestimeusersovertimeretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/time/users/{user_id}/over-time | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsCoursesTimeUsersRetrieve**](doc/EngagementApi.md#engagementorgscoursestimeusersretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/time/users | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsCoursesVideosOverTimeRetrieve**](doc/EngagementApi.md#engagementorgscoursesvideosovertimeretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/videos/over-time | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsCoursesVideosRetrieve**](doc/EngagementApi.md#engagementorgscoursesvideosretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/videos/ | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsCoursesVideosSummaryRetrieve**](doc/EngagementApi.md#engagementorgscoursesvideossummaryretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/videos/summary | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsCoursesVideosUsersRetrieve**](doc/EngagementApi.md#engagementorgscoursesvideosusersretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/videos/users | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsTimeAveragePerlearnerPercourseRetrieve**](doc/EngagementApi.md#engagementorgstimeaverageperlearnerpercourseretrieve) | **GET** /api/engagement/orgs/{org}/time/average-perlearner-percourse | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsTimeAverageWithOverTimeRetrieve**](doc/EngagementApi.md#engagementorgstimeaveragewithovertimeretrieve) | **GET** /api/engagement/orgs/{org}/time/average-with-over-time | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsTimeOverTimeRetrieve**](doc/EngagementApi.md#engagementorgstimeovertimeretrieve) | **GET** /api/engagement/orgs/{org}/time/over-time | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsTimePerCourseRetrieve**](doc/EngagementApi.md#engagementorgstimepercourseretrieve) | **GET** /api/engagement/orgs/{org}/time/per-course | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsVideosOverTimeRetrieve**](doc/EngagementApi.md#engagementorgsvideosovertimeretrieve) | **GET** /api/engagement/orgs/{org}/videos/over-time | 
[*EngagementApi*](doc/EngagementApi.md) | [**engagementOrgsVideosRetrieve**](doc/EngagementApi.md#engagementorgsvideosretrieve) | **GET** /api/engagement/orgs/{org}/videos/ | 
[*EsHealthApi*](doc/EsHealthApi.md) | [**esHealthRetrieve**](doc/EsHealthApi.md#eshealthretrieve) | **GET** /es-health/ | 
[*FinanceApi*](doc/FinanceApi.md) | [**financeOrgsProductsOrdersRetrieve**](doc/FinanceApi.md#financeorgsproductsordersretrieve) | **GET** /api/finance/orgs/{org}/products/{item_id}/orders | 
[*FinanceApi*](doc/FinanceApi.md) | [**financeOrgsProductsRetrieve**](doc/FinanceApi.md#financeorgsproductsretrieve) | **GET** /api/finance/orgs/{org}/products | 
[*FinanceApi*](doc/FinanceApi.md) | [**financeOrgsProductsSalesOverTimeRetrieve**](doc/FinanceApi.md#financeorgsproductssalesovertimeretrieve) | **GET** /api/finance/orgs/{org}/products/{item_id}/sales-over-time | 
[*FinanceApi*](doc/FinanceApi.md) | [**financeOrgsRevenueNetOverTimeRetrieve**](doc/FinanceApi.md#financeorgsrevenuenetovertimeretrieve) | **GET** /api/finance/orgs/{org}/revenue/net-over-time | 
[*FinanceApi*](doc/FinanceApi.md) | [**financeOrgsRevenueProductsRetrieve**](doc/FinanceApi.md#financeorgsrevenueproductsretrieve) | **GET** /api/finance/orgs/{org}/revenue/products | 
[*MonitoringApi*](doc/MonitoringApi.md) | [**monitoringConnectorsRetrieve**](doc/MonitoringApi.md#monitoringconnectorsretrieve) | **GET** /monitoring/connectors/ | 
[*OverviewApi*](doc/OverviewApi.md) | [**overviewOrgsActiveUsersRetrieve**](doc/OverviewApi.md#overvieworgsactiveusersretrieve) | **GET** /api/overview/orgs/{org}/active-users | 
[*OverviewApi*](doc/OverviewApi.md) | [**overviewOrgsAverageGradeRetrieve**](doc/OverviewApi.md#overvieworgsaveragegraderetrieve) | **GET** /api/overview/orgs/{org}/average-grade | 
[*OverviewApi*](doc/OverviewApi.md) | [**overviewOrgsCoursesCompletionsRetrieve**](doc/OverviewApi.md#overvieworgscoursescompletionsretrieve) | **GET** /api/overview/orgs/{org}/courses/completions | 
[*OverviewApi*](doc/OverviewApi.md) | [**overviewOrgsLearnersRetrieve**](doc/OverviewApi.md#overvieworgslearnersretrieve) | **GET** /api/overview/orgs/{org}/learners | 
[*OverviewApi*](doc/OverviewApi.md) | [**overviewOrgsMostActiveCoursesRetrieve**](doc/OverviewApi.md#overvieworgsmostactivecoursesretrieve) | **GET** /api/overview/orgs/{org}/most-active-courses | 
[*OverviewApi*](doc/OverviewApi.md) | [**overviewOrgsRegisteredUsersRetrieve**](doc/OverviewApi.md#overvieworgsregisteredusersretrieve) | **GET** /api/overview/orgs/{org}/registered-users | 
[*PerformanceApi*](doc/PerformanceApi.md) | [**performanceOrgsCoursesGradingAverageRetrieve**](doc/PerformanceApi.md#performanceorgscoursesgradingaverageretrieve) | **GET** /api/performance/orgs/{org}/courses/{course_id}/grading/average | 
[*PerformanceApi*](doc/PerformanceApi.md) | [**performanceOrgsCoursesGradingAverageWithCutoffRetrieve**](doc/PerformanceApi.md#performanceorgscoursesgradingaveragewithcutoffretrieve) | **GET** /api/performance/orgs/{org}/courses/{course_id}/grading/average-with-cutoff | 
[*PerformanceApi*](doc/PerformanceApi.md) | [**performanceOrgsCoursesGradingDetailRetrieve**](doc/PerformanceApi.md#performanceorgscoursesgradingdetailretrieve) | **GET** /api/performance/orgs/{org}/courses/{course_id}/grading/detail | 
[*PerformanceApi*](doc/PerformanceApi.md) | [**performanceOrgsCoursesGradingPerLearnerRetrieve**](doc/PerformanceApi.md#performanceorgscoursesgradingperlearnerretrieve) | **GET** /api/performance/orgs/{org}/courses/{course_id}/grading/per-learner | 
[*PerformanceApi*](doc/PerformanceApi.md) | [**performanceOrgsCoursesGradingSummaryRetrieve**](doc/PerformanceApi.md#performanceorgscoursesgradingsummaryretrieve) | **GET** /api/performance/orgs/{org}/courses/{course_id}/grading/summary | 
[*PerformanceApi*](doc/PerformanceApi.md) | [**performanceOrgsGradingAverageRetrieve**](doc/PerformanceApi.md#performanceorgsgradingaverageretrieve) | **GET** /api/performance/orgs/{org}/grading/average | 
[*PerformanceApi*](doc/PerformanceApi.md) | [**performanceOrgsGradingPerCourseRetrieve**](doc/PerformanceApi.md#performanceorgsgradingpercourseretrieve) | **GET** /api/performance/orgs/{org}/grading/per-course | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersActivityRetrieve**](doc/PerlearnerApi.md#perlearnerorgsusersactivityretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/activity/ | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersCoursesGradingCutoffsRetrieve**](doc/PerlearnerApi.md#perlearnerorgsuserscoursesgradingcutoffsretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/grading/cutoffs | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersCoursesGradingDetailRetrieve**](doc/PerlearnerApi.md#perlearnerorgsuserscoursesgradingdetailretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/grading/detail | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersCoursesGradingSummaryRetrieve**](doc/PerlearnerApi.md#perlearnerorgsuserscoursesgradingsummaryretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/grading/summary | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersCoursesOverviewEngagementIndexRetrieve**](doc/PerlearnerApi.md#perlearnerorgsuserscoursesoverviewengagementindexretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/overview/engagement-index | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersCoursesOverviewGradeRetrieve**](doc/PerlearnerApi.md#perlearnerorgsuserscoursesoverviewgraderetrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/overview/grade | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersCoursesOverviewPerformanceIndexRetrieve**](doc/PerlearnerApi.md#perlearnerorgsuserscoursesoverviewperformanceindexretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/overview/performance-index | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersCoursesOverviewTimeOverTimeRetrieve**](doc/PerlearnerApi.md#perlearnerorgsuserscoursesoverviewtimeovertimeretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/overview/time/over-time | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersCoursesVideosOverTimeRetrieve**](doc/PerlearnerApi.md#perlearnerorgsuserscoursesvideosovertimeretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/videos/over-time | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersCoursesVideosRetrieve**](doc/PerlearnerApi.md#perlearnerorgsuserscoursesvideosretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/videos | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersGradesPerCourseRetrieve**](doc/PerlearnerApi.md#perlearnerorgsusersgradespercourseretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/grades/per-course | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersInfoRetrieve**](doc/PerlearnerApi.md#perlearnerorgsusersinforetrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/info | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersLastAccessRetrieve**](doc/PerlearnerApi.md#perlearnerorgsuserslastaccessretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/last-access | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersOverviewEngagementIndexRetrieve**](doc/PerlearnerApi.md#perlearnerorgsusersoverviewengagementindexretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/overview/engagement-index | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersOverviewGradesAverageRetrieve**](doc/PerlearnerApi.md#perlearnerorgsusersoverviewgradesaverageretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/overview/grades/average | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersOverviewPerformanceIndexRetrieve**](doc/PerlearnerApi.md#perlearnerorgsusersoverviewperformanceindexretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/overview/performance-index | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersOverviewTimeOverTimeRetrieve**](doc/PerlearnerApi.md#perlearnerorgsusersoverviewtimeovertimeretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/overview/time/over-time | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersRetrieve**](doc/PerlearnerApi.md#perlearnerorgsusersretrieve) | **GET** /api/perlearner/orgs/{org}/users | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersVideosOverTimeRetrieve**](doc/PerlearnerApi.md#perlearnerorgsusersvideosovertimeretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/videos/over-time | 
[*PerlearnerApi*](doc/PerlearnerApi.md) | [**perlearnerOrgsUsersVideosPerCourseRetrieve**](doc/PerlearnerApi.md#perlearnerorgsusersvideospercourseretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/videos/per-course | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsCoursesCountRetrieve**](doc/PlatformApi.md#platformorgscoursescountretrieve) | **GET** /api/platform/orgs/{org}/courses/count | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsCoursesGradesRetrieve**](doc/PlatformApi.md#platformorgscoursesgradesretrieve) | **GET** /api/platform/orgs/{org}/courses/grades | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsCoursesProgressAverageDaysToCompleteRetrieve**](doc/PlatformApi.md#platformorgscoursesprogressaveragedaystocompleteretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/progress/average-days-to-complete | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsCoursesProgressAverageTimeToCompleteRetrieve**](doc/PlatformApi.md#platformorgscoursesprogressaveragetimetocompleteretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/progress/average-time-to-complete | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsCoursesProgressCompletedRetrieve**](doc/PlatformApi.md#platformorgscoursesprogresscompletedretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/progress/completed | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsCoursesProgressCompletionRateRetrieve**](doc/PlatformApi.md#platformorgscoursesprogresscompletionrateretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/progress/completion-rate | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsCoursesProgressInProgressRetrieve**](doc/PlatformApi.md#platformorgscoursesprogressinprogressretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/progress/in-progress | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsCoursesProgressRetrieve**](doc/PlatformApi.md#platformorgscoursesprogressretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/progress/ | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsCoursesProgressStartedRetrieve**](doc/PlatformApi.md#platformorgscoursesprogressstartedretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/progress/started | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsCoursesUsersGradesPassedRetrieve**](doc/PlatformApi.md#platformorgscoursesusersgradespassedretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/users/{user_id}/grades/passed | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsCoursesUsersProgressDaysToCompleteRetrieve**](doc/PlatformApi.md#platformorgscoursesusersprogressdaystocompleteretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/users/{user_id}/progress/days-to-complete | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsCoursesUsersProgressRetrieve**](doc/PlatformApi.md#platformorgscoursesusersprogressretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/users/{user_id}/progress | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsCoursesUsersTimeCountRetrieve**](doc/PlatformApi.md#platformorgscoursesuserstimecountretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/users/{user_id}/time/count | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsCoursesUsersVideosCountRetrieve**](doc/PlatformApi.md#platformorgscoursesusersvideoscountretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/users/{user_id}/videos/count | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsCoursesVideosRetrieve**](doc/PlatformApi.md#platformorgscoursesvideosretrieve) | **GET** /api/platform/orgs/{org}/courses/videos | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsCoursesVideosRetrieve2**](doc/PlatformApi.md#platformorgscoursesvideosretrieve2) | **GET** /api/platform/orgs/{org}/courses/{course_id}/videos/ | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsProgressCompletedRetrieve**](doc/PlatformApi.md#platformorgsprogresscompletedretrieve) | **GET** /api/platform/orgs/{org}/progress/completed | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsProgressCompletionRateRetrieve**](doc/PlatformApi.md#platformorgsprogresscompletionrateretrieve) | **GET** /api/platform/orgs/{org}/progress/completion-rate | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsProgressInProgressRetrieve**](doc/PlatformApi.md#platformorgsprogressinprogressretrieve) | **GET** /api/platform/orgs/{org}/progress/in-progress | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsProgressStartedRetrieve**](doc/PlatformApi.md#platformorgsprogressstartedretrieve) | **GET** /api/platform/orgs/{org}/progress/started | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsRetrieve**](doc/PlatformApi.md#platformorgsretrieve) | **GET** /api/platform/orgs/{org}/ | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsTimeCountRetrieve**](doc/PlatformApi.md#platformorgstimecountretrieve) | **GET** /api/platform/orgs/{org}/time/count | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsUsersActiveCountRetrieve**](doc/PlatformApi.md#platformorgsusersactivecountretrieve) | **GET** /api/platform/orgs/{org}/users/active/count | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsUsersCountRetrieve**](doc/PlatformApi.md#platformorgsuserscountretrieve) | **GET** /api/platform/orgs/{org}/users/count | 
[*PlatformApi*](doc/PlatformApi.md) | [**platformOrgsUsersCoursesCompletedCountRetrieve**](doc/PlatformApi.md#platformorgsuserscoursescompletedcountretrieve) | **GET** /api/platform/orgs/{org}/users/courses-completed/count | 
[*RecommendationsApi*](doc/RecommendationsApi.md) | [**recommendationsOrgsUsersRetrieve**](doc/RecommendationsApi.md#recommendationsorgsusersretrieve) | **GET** /api/recommendations/orgs/{org}/users/{user_id}/ | 
[*ReportsApi*](doc/ReportsApi.md) | [**reportsOrgsList**](doc/ReportsApi.md#reportsorgslist) | **GET** /api/reports/orgs/{org}/ | 
[*ReportsApi*](doc/ReportsApi.md) | [**reportsOrgsNewCreate**](doc/ReportsApi.md#reportsorgsnewcreate) | **POST** /api/reports/orgs/{org}/new | 
[*RolesApi*](doc/RolesApi.md) | [**rolesPlatformOrgsRolesUsersDesiredRolesRetrieve**](doc/RolesApi.md#rolesplatformorgsrolesusersdesiredrolesretrieve) | **GET** /api/roles/platform/orgs/{org}/roles/users/{username}/desired-roles/ | 
[*RolesApi*](doc/RolesApi.md) | [**rolesPlatformOrgsRolesUsersReportedRolesRetrieve**](doc/RolesApi.md#rolesplatformorgsrolesusersreportedrolesretrieve) | **GET** /api/roles/platform/orgs/{org}/roles/users/{username}/reported-roles/ | 
[*SaasApi*](doc/SaasApi.md) | [**saasAwsSubscriptionExpiryWebhookCreate**](doc/SaasApi.md#saasawssubscriptionexpirywebhookcreate) | **POST** /api/saas/aws/subscription/expiry/webhook/ | 
[*SaasApi*](doc/SaasApi.md) | [**saasCreateStripeCustomerCreate**](doc/SaasApi.md#saascreatestripecustomercreate) | **POST** /api/saas/create/stripe/customer/ | 
[*SaasApi*](doc/SaasApi.md) | [**saasCreateStripeCustomerPortalCreate**](doc/SaasApi.md#saascreatestripecustomerportalcreate) | **POST** /api/saas/create/stripe/customer/portal/ | 
[*SaasApi*](doc/SaasApi.md) | [**saasCreateSubscriptionRetrieve**](doc/SaasApi.md#saascreatesubscriptionretrieve) | **GET** /api/saas/create/subscription/ | 
[*SaasApi*](doc/SaasApi.md) | [**saasCustomerPortalWebhookRetrieve**](doc/SaasApi.md#saascustomerportalwebhookretrieve) | **GET** /api/saas/customer/portal/webhook/ | 
[*SaasApi*](doc/SaasApi.md) | [**saasLaunchTenantCreate**](doc/SaasApi.md#saaslaunchtenantcreate) | **POST** /api/saas/launch/tenant/ | 
[*SaasApi*](doc/SaasApi.md) | [**saasPaymentCancelRetrieve**](doc/SaasApi.md#saaspaymentcancelretrieve) | **GET** /api/saas/payment/cancel/ | 
[*SaasApi*](doc/SaasApi.md) | [**saasPaymentSuccessRetrieve**](doc/SaasApi.md#saaspaymentsuccessretrieve) | **GET** /api/saas/payment/success/ | 
[*SaasApi*](doc/SaasApi.md) | [**saasStripeProductPurchaseRetrieve**](doc/SaasApi.md#saasstripeproductpurchaseretrieve) | **GET** /api/saas/stripe/product/purchase/ | 
[*SaasApi*](doc/SaasApi.md) | [**saasSubscriptionCancelRetrieve**](doc/SaasApi.md#saassubscriptioncancelretrieve) | **GET** /api/saas/subscription/cancel/ | 
[*SaasApi*](doc/SaasApi.md) | [**saasSubscriptionSuccessRetrieve**](doc/SaasApi.md#saassubscriptionsuccessretrieve) | **GET** /api/saas/subscription/success/ | 
[*SearchApi*](doc/SearchApi.md) | [**searchDocumentsearchRetrieve**](doc/SearchApi.md#searchdocumentsearchretrieve) | **GET** /api/search/documentsearch/ | 
[*SearchApi*](doc/SearchApi.md) | [**searchEsHealthRetrieve**](doc/SearchApi.md#searcheshealthretrieve) | **GET** /api/search/es-health/ | 
[*SearchApi*](doc/SearchApi.md) | [**searchRetrieve**](doc/SearchApi.md#searchretrieve) | **GET** /search/ | 
[*SearchApi*](doc/SearchApi.md) | [**searchSearchRetrieve**](doc/SearchApi.md#searchsearchretrieve) | **GET** /api/search/search/ | 
[*ServiceApi*](doc/ServiceApi.md) | [**serviceLaunchTenantCreate**](doc/ServiceApi.md#servicelaunchtenantcreate) | **POST** /api/service/launch/tenant/ | 
[*ServiceApi*](doc/ServiceApi.md) | [**serviceManageUserCreate**](doc/ServiceApi.md#servicemanageusercreate) | **POST** /api/service/manage/user/ | 
[*ServiceApi*](doc/ServiceApi.md) | [**serviceManageUserRoleCreate**](doc/ServiceApi.md#servicemanageuserrolecreate) | **POST** /api/service/manage/user/role/ | 
[*ServiceApi*](doc/ServiceApi.md) | [**serviceTenantValidationCreate**](doc/ServiceApi.md#servicetenantvalidationcreate) | **POST** /api/service/tenant/validation/ | 
[*ServiceApi*](doc/ServiceApi.md) | [**serviceTokenRetrieve**](doc/ServiceApi.md#servicetokenretrieve) | **GET** /api/service/token/ | 
[*ServiceApi*](doc/ServiceApi.md) | [**serviceUserValidationCreate**](doc/ServiceApi.md#serviceuservalidationcreate) | **POST** /api/service/user/validation/ | 
[*SkillsApi*](doc/SkillsApi.md) | [**skillsOrgsSkillsList**](doc/SkillsApi.md#skillsorgsskillslist) | **GET** /api/skills/orgs/{org}/skills | 
[*SkillsApi*](doc/SkillsApi.md) | [**skillsOrgsSkillsPercentileList**](doc/SkillsApi.md#skillsorgsskillspercentilelist) | **GET** /api/skills/orgs/{org}/skills/percentile/ | 
[*SkillsApi*](doc/SkillsApi.md) | [**skillsOrgsSkillsPercentileRetrieve**](doc/SkillsApi.md#skillsorgsskillspercentileretrieve) | **GET** /api/skills/orgs/{org}/skills/{skill_id}/percentile/ | 
[*SkillsApi*](doc/SkillsApi.md) | [**skillsOrgsSkillsRetrieve**](doc/SkillsApi.md#skillsorgsskillsretrieve) | **GET** /api/skills/orgs/{org}/skills/{skill_name}/ | 
[*SkillsApi*](doc/SkillsApi.md) | [**skillsOrgsSkillsThresholdsCreate**](doc/SkillsApi.md#skillsorgsskillsthresholdscreate) | **POST** /api/skills/orgs/{org}/skills/thresholds/ | 
[*SkillsApi*](doc/SkillsApi.md) | [**skillsOrgsSkillsThresholdsDestroy**](doc/SkillsApi.md#skillsorgsskillsthresholdsdestroy) | **DELETE** /api/skills/orgs/{org}/skills/thresholds/ | 
[*SkillsApi*](doc/SkillsApi.md) | [**skillsOrgsSkillsThresholdsPartialUpdate**](doc/SkillsApi.md#skillsorgsskillsthresholdspartialupdate) | **PATCH** /api/skills/orgs/{org}/skills/thresholds/ | 
[*SkillsApi*](doc/SkillsApi.md) | [**skillsOrgsSkillsThresholdsRetrieve**](doc/SkillsApi.md#skillsorgsskillsthresholdsretrieve) | **GET** /api/skills/orgs/{org}/skills/thresholds/ | 
[*SkillsApi*](doc/SkillsApi.md) | [**skillsOrgsSkillsUsersDesiredSkillsRetrieve**](doc/SkillsApi.md#skillsorgsskillsusersdesiredskillsretrieve) | **GET** /api/skills/orgs/{org}/skills/users/{user_id}/desired-skills/ | 
[*SkillsApi*](doc/SkillsApi.md) | [**skillsOrgsSkillsUsersPointPercentileRetrieve**](doc/SkillsApi.md#skillsorgsskillsuserspointpercentileretrieve) | **GET** /api/skills/orgs/{org}/skills/users/{user_id}/point-percentile/ | 
[*SkillsApi*](doc/SkillsApi.md) | [**skillsOrgsSkillsUsersReportedSkillsRetrieve**](doc/SkillsApi.md#skillsorgsskillsusersreportedskillsretrieve) | **GET** /api/skills/orgs/{org}/skills/users/{user_id}/reported-skills/ | 
[*SkillsApi*](doc/SkillsApi.md) | [**skillsOrgsSkillsUsersRetrieve**](doc/SkillsApi.md#skillsorgsskillsusersretrieve) | **GET** /api/skills/orgs/{org}/skills/users/{user_id}/ | 


## Documentation For Models

 - [APITokenCost](doc/APITokenCost.md)
 - [AcceptanceEnum](doc/AcceptanceEnum.md)
 - [ActiveUsersData](doc/ActiveUsersData.md)
 - [ActiveUsersList](doc/ActiveUsersList.md)
 - [ActiveUsersPerCourse](doc/ActiveUsersPerCourse.md)
 - [ActiveUsersPerCourseData](doc/ActiveUsersPerCourseData.md)
 - [ActivityAPI](doc/ActivityAPI.md)
 - [ActivityData](doc/ActivityData.md)
 - [AlignMentorBubbleEnum](doc/AlignMentorBubbleEnum.md)
 - [Assertions](doc/Assertions.md)
 - [AudioToTextRequest](doc/AudioToTextRequest.md)
 - [AudioToTextResponse](doc/AudioToTextResponse.md)
 - [Average](doc/Average.md)
 - [AverageData](doc/AverageData.md)
 - [AverageOvertime](doc/AverageOvertime.md)
 - [AvgCourseGradeWithCutoff](doc/AvgCourseGradeWithCutoff.md)
 - [AvgCourseGradeWithCutoffData](doc/AvgCourseGradeWithCutoffData.md)
 - [BlankEnum](doc/BlankEnum.md)
 - [Bot](doc/Bot.md)
 - [BotCommand](doc/BotCommand.md)
 - [BotCreate](doc/BotCreate.md)
 - [ChatHistory](doc/ChatHistory.md)
 - [ChatHistoryItem](doc/ChatHistoryItem.md)
 - [ChatHistorySessionId](doc/ChatHistorySessionId.md)
 - [ChatSessionRequest](doc/ChatSessionRequest.md)
 - [ChatSessionResponse](doc/ChatSessionResponse.md)
 - [ChatSessionWithMessage](doc/ChatSessionWithMessage.md)
 - [CheckDocumentTrainingStatus](doc/CheckDocumentTrainingStatus.md)
 - [CognitiveSkillsEnum](doc/CognitiveSkillsEnum.md)
 - [Count](doc/Count.md)
 - [CountData](doc/CountData.md)
 - [CourseCompletionPerCourse](doc/CourseCompletionPerCourse.md)
 - [CourseCompletionPerCourseData](doc/CourseCompletionPerCourseData.md)
 - [CourseCompletionSummaryDataOvertime](doc/CourseCompletionSummaryDataOvertime.md)
 - [CourseCompletionSummaryOvertime](doc/CourseCompletionSummaryOvertime.md)
 - [CourseGradeDetailBlock](doc/CourseGradeDetailBlock.md)
 - [CourseGradeDetailSubSection](doc/CourseGradeDetailSubSection.md)
 - [CourseGradeSummary](doc/CourseGradeSummary.md)
 - [CourseGradeSummaryData](doc/CourseGradeSummaryData.md)
 - [CourseGradingDetail](doc/CourseGradingDetail.md)
 - [CourseGradingDetailData](doc/CourseGradingDetailData.md)
 - [CoursePoint](doc/CoursePoint.md)
 - [CourseSkill](doc/CourseSkill.md)
 - [Credential](doc/Credential.md)
 - [CredentialRequest](doc/CredentialRequest.md)
 - [DefaultResponse](doc/DefaultResponse.md)
 - [DesiredRole](doc/DesiredRole.md)
 - [DesiredSkill](doc/DesiredSkill.md)
 - [DetailedGradeSubsection](doc/DetailedGradeSubsection.md)
 - [DetailedGradeView](doc/DetailedGradeView.md)
 - [DetailedGradeViewData](doc/DetailedGradeViewData.md)
 - [DiscordWebhook](doc/DiscordWebhook.md)
 - [EdxSignalReceiverRequest](doc/EdxSignalReceiverRequest.md)
 - [EngagementPerCourse](doc/EngagementPerCourse.md)
 - [EngagementPerCourseData](doc/EngagementPerCourseData.md)
 - [Enrollments](doc/Enrollments.md)
 - [EnrollmentsData](doc/EnrollmentsData.md)
 - [EnrollmentsPerUser](doc/EnrollmentsPerUser.md)
 - [EnrollmentsPerUserData](doc/EnrollmentsPerUserData.md)
 - [FloatOverTime](doc/FloatOverTime.md)
 - [FreeUsageCount](doc/FreeUsageCount.md)
 - [GradingPerUser](doc/GradingPerUser.md)
 - [GradingPerUserData](doc/GradingPerUserData.md)
 - [GuidedPromptsResponse](doc/GuidedPromptsResponse.md)
 - [IBLAIPlatformMeta](doc/IBLAIPlatformMeta.md)
 - [IBLAIPlatformMetaRequest](doc/IBLAIPlatformMetaRequest.md)
 - [IBLAIPlatformMetaUpdateRequest](doc/IBLAIPlatformMetaUpdateRequest.md)
 - [IntegrationCredential](doc/IntegrationCredential.md)
 - [LauncherViewPostRequest](doc/LauncherViewPostRequest.md)
 - [LearnerInformationAPI](doc/LearnerInformationAPI.md)
 - [LearnerInformationAPIData](doc/LearnerInformationAPIData.md)
 - [MathQuestion](doc/MathQuestion.md)
 - [MathQuestionCognitiveSkills](doc/MathQuestionCognitiveSkills.md)
 - [MathQuestionWithAnswer](doc/MathQuestionWithAnswer.md)
 - [MathStudent](doc/MathStudent.md)
 - [Mentor](doc/Mentor.md)
 - [MentorFromTemplateRequest](doc/MentorFromTemplateRequest.md)
 - [MentorFromTemplateWithSettingRequest](doc/MentorFromTemplateWithSettingRequest.md)
 - [MentorLLMFlowResponse](doc/MentorLLMFlowResponse.md)
 - [MentorSettings](doc/MentorSettings.md)
 - [MentorSettingsMentorVisibility](doc/MentorSettingsMentorVisibility.md)
 - [MentorSettingsRequest](doc/MentorSettingsRequest.md)
 - [MentorVisibilityEnum](doc/MentorVisibilityEnum.md)
 - [MessageView](doc/MessageView.md)
 - [MessageViewRequest](doc/MessageViewRequest.md)
 - [MessageViewUpdatResponse](doc/MessageViewUpdatResponse.md)
 - [NetRevenueOverTime](doc/NetRevenueOverTime.md)
 - [NullEnum](doc/NullEnum.md)
 - [Order](doc/Order.md)
 - [OverTime](doc/OverTime.md)
 - [Overtime](doc/Overtime.md)
 - [OvertimeMeta](doc/OvertimeMeta.md)
 - [OvertimeWithChangeInfo](doc/OvertimeWithChangeInfo.md)
 - [PageContent](doc/PageContent.md)
 - [PaginatedAssertionsList](doc/PaginatedAssertionsList.md)
 - [PaginatedCredentialList](doc/PaginatedCredentialList.md)
 - [PaginatedMentorList](doc/PaginatedMentorList.md)
 - [Pagination](doc/Pagination.md)
 - [PatchedBotCommand](doc/PatchedBotCommand.md)
 - [PatchedBotCreate](doc/PatchedBotCreate.md)
 - [PatchedCredentialRequest](doc/PatchedCredentialRequest.md)
 - [PatchedMathQuestion](doc/PatchedMathQuestion.md)
 - [PatchedMathStudent](doc/PatchedMathStudent.md)
 - [PatchedMentor](doc/PatchedMentor.md)
 - [PatchedPrompt](doc/PatchedPrompt.md)
 - [PatchedSkill](doc/PatchedSkill.md)
 - [PatchedSkillThreshold](doc/PatchedSkillThreshold.md)
 - [PatchedStudentAnswer](doc/PatchedStudentAnswer.md)
 - [PerLearnerCourseLastAccessData](doc/PerLearnerCourseLastAccessData.md)
 - [PerLearnerCourseVideosWatched](doc/PerLearnerCourseVideosWatched.md)
 - [PerLearnerCourseVideosWatchedData](doc/PerLearnerCourseVideosWatchedData.md)
 - [PerLearnerLastAccess](doc/PerLearnerLastAccess.md)
 - [PerLearnerLastAccessData](doc/PerLearnerLastAccessData.md)
 - [PerLearnerTimeSpentInCourseTree](doc/PerLearnerTimeSpentInCourseTree.md)
 - [PerformanceGradesPerCourse](doc/PerformanceGradesPerCourse.md)
 - [PerformanceGradesPerCourseData](doc/PerformanceGradesPerCourseData.md)
 - [PerlearnerCourseProgress](doc/PerlearnerCourseProgress.md)
 - [PerlearnerCourseProgressData](doc/PerlearnerCourseProgressData.md)
 - [PerlearnerEngagementVideosData](doc/PerlearnerEngagementVideosData.md)
 - [PerlearnerEngagementVideosWatchedPerCourse](doc/PerlearnerEngagementVideosWatchedPerCourse.md)
 - [PerlearnerGradeSummary](doc/PerlearnerGradeSummary.md)
 - [PerlearnerGradeSummaryData](doc/PerlearnerGradeSummaryData.md)
 - [PerlearnerGradeWithCutOff](doc/PerlearnerGradeWithCutOff.md)
 - [PerlearnerGradeWithCutOffData](doc/PerlearnerGradeWithCutOffData.md)
 - [PerlearnerGradingPerCourseAPI](doc/PerlearnerGradingPerCourseAPI.md)
 - [PerlearnerGradingPerCourseAPIData](doc/PerlearnerGradingPerCourseAPIData.md)
 - [PerlearnerUserList](doc/PerlearnerUserList.md)
 - [PerlearnerUserListData](doc/PerlearnerUserListData.md)
 - [PinnedMessageCreate](doc/PinnedMessageCreate.md)
 - [PlatformList](doc/PlatformList.md)
 - [PlatformListStatusEnum](doc/PlatformListStatusEnum.md)
 - [PlatformUpdatePostRequest](doc/PlatformUpdatePostRequest.md)
 - [PointsPercentile](doc/PointsPercentile.md)
 - [PredictiveAnalyticsRequest](doc/PredictiveAnalyticsRequest.md)
 - [PredictiveAnalyticsResponse](doc/PredictiveAnalyticsResponse.md)
 - [Product](doc/Product.md)
 - [ProductTable](doc/ProductTable.md)
 - [Prompt](doc/Prompt.md)
 - [PromptCategory](doc/PromptCategory.md)
 - [ProviderEnum](doc/ProviderEnum.md)
 - [QueryEndpoint](doc/QueryEndpoint.md)
 - [RatingEnum](doc/RatingEnum.md)
 - [RecommendCourseResponse](doc/RecommendCourseResponse.md)
 - [RecommendationSearchAPI](doc/RecommendationSearchAPI.md)
 - [RelatedText](doc/RelatedText.md)
 - [ReportCreate](doc/ReportCreate.md)
 - [ReportData](doc/ReportData.md)
 - [ReportList](doc/ReportList.md)
 - [ReportRequest](doc/ReportRequest.md)
 - [ReportStatus](doc/ReportStatus.md)
 - [ReportedRole](doc/ReportedRole.md)
 - [ReportedSkill](doc/ReportedSkill.md)
 - [RequestDataVariable](doc/RequestDataVariable.md)
 - [ResourcePoint](doc/ResourcePoint.md)
 - [ResponseDataVariable](doc/ResponseDataVariable.md)
 - [RetreiverTrainViewRequest](doc/RetreiverTrainViewRequest.md)
 - [RetreiverTrainViewResponse](doc/RetreiverTrainViewResponse.md)
 - [RetrieveTask](doc/RetrieveTask.md)
 - [RetrieverDocumentEmbedding](doc/RetrieverDocumentEmbedding.md)
 - [RetrieverDocumentEmbeddingRequest](doc/RetrieverDocumentEmbeddingRequest.md)
 - [RetrieverRequestSearch](doc/RetrieverRequestSearch.md)
 - [RetrieverRequestSearchDocument](doc/RetrieverRequestSearchDocument.md)
 - [RetrieverResponseSearch](doc/RetrieverResponseSearch.md)
 - [ReuestDataVariableList](doc/ReuestDataVariableList.md)
 - [RevenueByProduct](doc/RevenueByProduct.md)
 - [Role](doc/Role.md)
 - [SampleQuestionsDocument](doc/SampleQuestionsDocument.md)
 - [SampleQuestionsDocumentStatusEnum](doc/SampleQuestionsDocumentStatusEnum.md)
 - [SessionDetail](doc/SessionDetail.md)
 - [Skill](doc/Skill.md)
 - [SkillDetail](doc/SkillDetail.md)
 - [SkillInfo](doc/SkillInfo.md)
 - [SkillThreshold](doc/SkillThreshold.md)
 - [SlackWebhook](doc/SlackWebhook.md)
 - [StateEnum](doc/StateEnum.md)
 - [StudentAnswer](doc/StudentAnswer.md)
 - [SubTimeChild](doc/SubTimeChild.md)
 - [SubTopic](doc/SubTopic.md)
 - [SuggestedPrompt](doc/SuggestedPrompt.md)
 - [SuggestedPromptIndex](doc/SuggestedPromptIndex.md)
 - [SuggestedPrompts](doc/SuggestedPrompts.md)
 - [Summary](doc/Summary.md)
 - [TaskView](doc/TaskView.md)
 - [ThemeEnum](doc/ThemeEnum.md)
 - [TimeChildData](doc/TimeChildData.md)
 - [TimeDetail](doc/TimeDetail.md)
 - [TimeDetailChild](doc/TimeDetailChild.md)
 - [TimeDetailData](doc/TimeDetailData.md)
 - [TimeSpentByUsersInCourse](doc/TimeSpentByUsersInCourse.md)
 - [TimeSpentByUsersInCourseData](doc/TimeSpentByUsersInCourseData.md)
 - [TimeSpentPerCourse](doc/TimeSpentPerCourse.md)
 - [TimeSpentPerCourseData](doc/TimeSpentPerCourseData.md)
 - [Topic](doc/Topic.md)
 - [TrainChatSessionDocumentView](doc/TrainChatSessionDocumentView.md)
 - [TrainDocumentViewRequest](doc/TrainDocumentViewRequest.md)
 - [TrainDocumentViewResponse](doc/TrainDocumentViewResponse.md)
 - [Usage](doc/Usage.md)
 - [UserChatFeedback](doc/UserChatFeedback.md)
 - [UserPlatformManagementListViewGetResponse](doc/UserPlatformManagementListViewGetResponse.md)
 - [UserPlatformViewPostRequest](doc/UserPlatformViewPostRequest.md)
 - [UserProxyBulkRequest](doc/UserProxyBulkRequest.md)
 - [UserProxyGetResponse](doc/UserProxyGetResponse.md)
 - [UserProxyPostRequest](doc/UserProxyPostRequest.md)
 - [UserProxyPostResponse](doc/UserProxyPostResponse.md)
 - [UserSearchViewGetResponse](doc/UserSearchViewGetResponse.md)
 - [UserSkill](doc/UserSkill.md)
 - [UserSkillPointsPercentile](doc/UserSkillPointsPercentile.md)
 - [Value](doc/Value.md)
 - [ValueData](doc/ValueData.md)
 - [VideoBlock](doc/VideoBlock.md)
 - [VideoEngagementPerCourse](doc/VideoEngagementPerCourse.md)
 - [VideoEngagementPerCourseData](doc/VideoEngagementPerCourseData.md)
 - [VideosCount](doc/VideosCount.md)
 - [VideosCountData](doc/VideosCountData.md)
 - [VideosInCourseSummary](doc/VideosInCourseSummary.md)
 - [VideosInCourseSummaryData](doc/VideosInCourseSummaryData.md)
 - [VideosSpecificCourse](doc/VideosSpecificCourse.md)
 - [VideosSpecificCourseData](doc/VideosSpecificCourseData.md)
 - [VideosWatchedSubSection](doc/VideosWatchedSubSection.md)
 - [WatchedVideosPerCourse](doc/WatchedVideosPerCourse.md)
 - [WatchedVideosPerCourseData](doc/WatchedVideosPerCourseData.md)
 - [WatchedVideosPerUser](doc/WatchedVideosPerUser.md)
 - [WatchedVideosPerUserData](doc/WatchedVideosPerUserData.md)
 - [WebSocketStopGenerationView](doc/WebSocketStopGenerationView.md)
 - [WebexWebhook](doc/WebexWebhook.md)
 - [WhatAppWebHook](doc/WhatAppWebHook.md)


## Documentation For Authorization

Endpoints do not require authorization.


## Author



