# ibl_ai_data_manager_sdk.api.AiAccountApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**aiAccountOrgsCredentialCreate**](AiAccountApi.md#aiaccountorgscredentialcreate) | **POST** /api/ai-account/orgs/{org}/credential/ | 
[**aiAccountOrgsCredentialPartialUpdate**](AiAccountApi.md#aiaccountorgscredentialpartialupdate) | **PATCH** /api/ai-account/orgs/{org}/credential/ | 
[**aiAccountOrgsCredentialRetrieve**](AiAccountApi.md#aiaccountorgscredentialretrieve) | **GET** /api/ai-account/orgs/{org}/credential/ | 
[**aiAccountOrgsIntegrationCredentialCreate**](AiAccountApi.md#aiaccountorgsintegrationcredentialcreate) | **POST** /api/ai-account/orgs/{org}/integration-credential/ | 
[**aiAccountOrgsIntegrationCredentialPartialUpdate**](AiAccountApi.md#aiaccountorgsintegrationcredentialpartialupdate) | **PATCH** /api/ai-account/orgs/{org}/integration-credential/ | 
[**aiAccountOrgsIntegrationCredentialRetrieve**](AiAccountApi.md#aiaccountorgsintegrationcredentialretrieve) | **GET** /api/ai-account/orgs/{org}/integration-credential/ | 
[**aiAccountOrgsPlatformMetadataCreate**](AiAccountApi.md#aiaccountorgsplatformmetadatacreate) | **POST** /api/ai-account/orgs/{org}/platform-metadata/ | 
[**aiAccountOrgsPlatformMetadataList**](AiAccountApi.md#aiaccountorgsplatformmetadatalist) | **GET** /api/ai-account/orgs/{org}/platform-metadata/ | 
[**aiAccountOrgsPlatformMetadataUpdate**](AiAccountApi.md#aiaccountorgsplatformmetadataupdate) | **PUT** /api/ai-account/orgs/{org}/platform-metadata/ | 
[**aiAccountOrgsTokensList**](AiAccountApi.md#aiaccountorgstokenslist) | **GET** /api/ai-account/orgs/{org}/tokens/ | 


# **aiAccountOrgsCredentialCreate**
> Credential aiAccountOrgsCredentialCreate(org, credentialRequest)



This is for creating llm credentials for a tenant.  Accessible to tenant admins only.  Raises:      NotFound: When tenant key is not found.  Returns:      400: When the data is not valid, when the name already exists for the same tenant.      400: When the name already exists for the same tenant.      400: When the name already exists for the same tenant.      201 : Llm credential details.  Example Response:      POST : /api/ai-account/orgs/main/credential/ .      Request:       {                         \"name\": \"openai\",                         \"value\": {                             \"key\": \"sk-xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\"                         },                         \"platform\": \"main\"                     }       Response:       {                         \"name\": \"openai\",                         \"value\": {                             \"key\": \"sk-xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\"                         },                         \"platform\": \"main\"                     }

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiAccountApi();
final String org = org_example; // String | 
final CredentialRequest credentialRequest = ; // CredentialRequest | 

try {
    final response = api.aiAccountOrgsCredentialCreate(org, credentialRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiAccountApi->aiAccountOrgsCredentialCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **credentialRequest** | [**CredentialRequest**](CredentialRequest.md)|  | 

### Return type

[**Credential**](Credential.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsCredentialPartialUpdate**
> Credential aiAccountOrgsCredentialPartialUpdate(org, patchedCredentialRequest)



This is for updating llm credentials for a tenant.  Accessible to tenant admins only.  Raises:      NotFound: When tenant key is not found.      NotFound: When the name passed is not found.  Returns:      400: When the data is not valid, when the name already exists for the same tenant.      400: When the name already exists for the same tenant.      400: When the name already exists for the same tenant.      200 : Llm credential details.  Example Response:      POST : /api/ai-account/orgs/main/credential/ .      Request:       {                         \"name\": \"openai\",                         \"value\": {                             \"key\": \"sk-xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\"                         },                         \"platform\": \"main\"                     }       Response:       {                         \"name\": \"openai\",                         \"value\": {                             \"key\": \"sk-xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\"                         },                         \"platform\": \"main\"                     }

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiAccountApi();
final String org = org_example; // String | 
final PatchedCredentialRequest patchedCredentialRequest = ; // PatchedCredentialRequest | 

try {
    final response = api.aiAccountOrgsCredentialPartialUpdate(org, patchedCredentialRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiAccountApi->aiAccountOrgsCredentialPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **patchedCredentialRequest** | [**PatchedCredentialRequest**](PatchedCredentialRequest.md)|  | [optional] 

### Return type

[**Credential**](Credential.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsCredentialRetrieve**
> Credential aiAccountOrgsCredentialRetrieve(org, name)



This is for getting list of llm credentials for a tenant.  You can also filter the llm credentials by passing a query parameter name=<llm_name>.  Accessible to tenant admins only.  Raises:      NotFound: When tenant key is not found.      NotFound: When the llm name passed in the paramter is not found.   Returns:      400: When the data is not valid.      200 : List of llm credentials.  Example Response:      GET : /api/ai-account/orgs/main/credential/ .      Response:       [                         {                             \"name\": \"openai\",                             \"value\": {                                 \"key\": \"sk-xxxxxxxxxxxxxxxxxxxxx\"                             },                             \"platform\": \"main\"                         },                         {                             \"name\": \"google\",                             \"value\": {                                 \"type\": \"service_account\",                                 \"auth_uri\": \"https://accounts.google.com/o/oauth2/auth\",                                 \"client_id\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxx\",                                 \"token_uri\": \"https://oauth2.googleapis.com/token\",                                 \"project_id\": \"xxxxxxxxxxxxxx\",                                 \"private_key\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\",                                 \"client_email\": \"xxx-xxx-sa@xx-xxxx.iam.gserviceaccount.com\",                                 \"private_key_id\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\",                                 \"universe_domain\": \"googleapis.com\",                                 \"client_x509_cert_url\": \"https://www.googleapis.com/robot/v1/metadata/x509/xxxxxxxx.com\",                                 \"auth_provider_x509_cert_url\": \"https://www.googleapis.com/oauth2/v1/certs\"                             },                             \"platform\": \"main\"                         }                     ]

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiAccountApi();
final String org = org_example; // String | 
final String name = name_example; // String | Name of the credential provider

try {
    final response = api.aiAccountOrgsCredentialRetrieve(org, name);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiAccountApi->aiAccountOrgsCredentialRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **name** | **String**| Name of the credential provider | [optional] 

### Return type

[**Credential**](Credential.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsIntegrationCredentialCreate**
> IntegrationCredential aiAccountOrgsIntegrationCredentialCreate(org, credentialRequest)



This is for creating integration credentials for a tenant.  Accessible to tenant admins only.  Raises:      NotFound: When tenant key is not found.  Returns:      400: When the data is not valid, when the name already exists for the same tenant.      400: When the name already exists for the same tenant.      201 : Tntegration credential details.  Example Response:      POST : /api/ai-account/orgs/main/integration-credential/ .      Request:       {                         \"name\": \"google-drive\",                         \"value\": {                             \"type\": \"service_account\",                             \"auth_uri\": \"https://accounts.google.com/o/oauth2/auth\",                             \"client_id\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxx\",                             \"token_uri\": \"https://oauth2.googleapis.com/token\",                             \"project_id\": \"xxxxxxxxxxxxxx\",                             \"private_key\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\",                             \"client_email\": \"xxx-xxx-sa@xx-xxxx.iam.gserviceaccount.com\",                             \"private_key_id\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\",                             \"universe_domain\": \"googleapis.com\",                             \"client_x509_cert_url\": \"https://www.googleapis.com/robot/v1/metadata/x509/xxxxxxxx.com\",                             \"auth_provider_x509_cert_url\": \"https://www.googleapis.com/oauth2/v1/certs\"                         },                         \"platform\": \"main\"                     }       Response:       {                         \"name\": \"google-drive\",                         \"value\": {                             \"type\": \"service_account\",                             \"auth_uri\": \"https://accounts.google.com/o/oauth2/auth\",                             \"client_id\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxx\",                             \"token_uri\": \"https://oauth2.googleapis.com/token\",                             \"project_id\": \"xxxxxxxxxxxxxx\",                             \"private_key\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\",                             \"client_email\": \"xxx-xxx-sa@xx-xxxx.iam.gserviceaccount.com\",                             \"private_key_id\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\",                             \"universe_domain\": \"googleapis.com\",                             \"client_x509_cert_url\": \"https://www.googleapis.com/robot/v1/metadata/x509/xxxxxxxx.com\",                             \"auth_provider_x509_cert_url\": \"https://www.googleapis.com/oauth2/v1/certs\"                         },                         \"platform\": \"main\"                     }

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiAccountApi();
final String org = org_example; // String | 
final CredentialRequest credentialRequest = ; // CredentialRequest | 

try {
    final response = api.aiAccountOrgsIntegrationCredentialCreate(org, credentialRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiAccountApi->aiAccountOrgsIntegrationCredentialCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **credentialRequest** | [**CredentialRequest**](CredentialRequest.md)|  | 

### Return type

[**IntegrationCredential**](IntegrationCredential.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsIntegrationCredentialPartialUpdate**
> IntegrationCredential aiAccountOrgsIntegrationCredentialPartialUpdate(org, patchedCredentialRequest)



This is for updating Integration credentials for a tenant.  Accessible to tenant admins only.  Raises:      NotFound: When tenant key is not found.      NotFound: When the name passed is not found.  Returns:      400: When the data is not valid, when the name already exists for the same tenant.      400: When the name already exists for the same tenant.      200 : Llm redential details.  Example Response:      POST : /api/ai-account/orgs/main/integration-credential/ .      Request:       {                         \"name\": \"google-drive\",                         \"value\": {                             \"type\": \"service_account\",                             \"auth_uri\": \"https://accounts.google.com/o/oauth2/auth\",                             \"client_id\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxx\",                             \"token_uri\": \"https://oauth2.googleapis.com/token\",                             \"project_id\": \"xxxxxxxxxxxxxx\",                             \"private_key\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\",                             \"client_email\": \"xxx-xxx-sa@xx-xxxx.iam.gserviceaccount.com\",                             \"private_key_id\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\",                             \"universe_domain\": \"googleapis.com\",                             \"client_x509_cert_url\": \"https://www.googleapis.com/robot/v1/metadata/x509/xxxxxxxx.com\",                             \"auth_provider_x509_cert_url\": \"https://www.googleapis.com/oauth2/v1/certs\"                         },                         \"platform\": \"main\"                     }       Response:       {                         \"name\": \"google-drive\",                         \"value\": {                             \"type\": \"service_account\",                             \"auth_uri\": \"https://accounts.google.com/o/oauth2/auth\",                             \"client_id\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxx\",                             \"token_uri\": \"https://oauth2.googleapis.com/token\",                             \"project_id\": \"xxxxxxxxxxxxxx\",                             \"private_key\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\",                             \"client_email\": \"xxx-xxx-sa@xx-xxxx.iam.gserviceaccount.com\",                             \"private_key_id\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\",                             \"universe_domain\": \"googleapis.com\",                             \"client_x509_cert_url\": \"https://www.googleapis.com/robot/v1/metadata/x509/xxxxxxxx.com\",                             \"auth_provider_x509_cert_url\": \"https://www.googleapis.com/oauth2/v1/certs\"                         }                         \"platform\": \"main\"                     }

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiAccountApi();
final String org = org_example; // String | 
final PatchedCredentialRequest patchedCredentialRequest = ; // PatchedCredentialRequest | 

try {
    final response = api.aiAccountOrgsIntegrationCredentialPartialUpdate(org, patchedCredentialRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiAccountApi->aiAccountOrgsIntegrationCredentialPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **patchedCredentialRequest** | [**PatchedCredentialRequest**](PatchedCredentialRequest.md)|  | [optional] 

### Return type

[**IntegrationCredential**](IntegrationCredential.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsIntegrationCredentialRetrieve**
> IntegrationCredential aiAccountOrgsIntegrationCredentialRetrieve(org, name)



This is for getting  a list of integration credentials for a tenant.  You can also filter the integration credentials by passing a query parameter name=<llm_name>.  Accessible to tenant admins only.  Raises:      NotFound: When tenant key is not found.      NotFound: When the  name passed in the paramter is not found.   Returns:      400: When the data is not valid.      200 : List of integration credentials.  Example Response:      GET : /api/ai-account/orgs/main/integration-credential/ .      Response:       [                         {                             \"name\": \"google-drive\",                             \"value\": {                                 \"type\": \"service_account\",                                 \"auth_uri\": \"https://accounts.google.com/o/oauth2/auth\",                                 \"client_id\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxx\",                                 \"token_uri\": \"https://oauth2.googleapis.com/token\",                                 \"project_id\": \"xxxxxxxxxxxxxx\",                                 \"private_key\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\",                                 \"client_email\": \"xxx-xxx-sa@xx-xxxx.iam.gserviceaccount.com\",                                 \"private_key_id\": \"xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\",                                 \"universe_domain\": \"googleapis.com\",                                 \"client_x509_cert_url\": \"https://www.googleapis.com/robot/v1/metadata/x509/xxxxxxxx.com\",                                 \"auth_provider_x509_cert_url\": \"https://www.googleapis.com/oauth2/v1/certs\"                             },                             \"platform\": \"main\"                         }                     ]

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiAccountApi();
final String org = org_example; // String | 
final String name = name_example; // String | Name of the credential provider

try {
    final response = api.aiAccountOrgsIntegrationCredentialRetrieve(org, name);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiAccountApi->aiAccountOrgsIntegrationCredentialRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **name** | **String**| Name of the credential provider | [optional] 

### Return type

[**IntegrationCredential**](IntegrationCredential.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsPlatformMetadataCreate**
> IBLAIPlatformMeta aiAccountOrgsPlatformMetadataCreate(org, iBLAIPlatformMetaRequest)



This is for  adding platform metadata. In order to use google as your LLM provider, you need to specify `google_project` (your google cloud project id) and `google_location`, which defaults to `us-central1`  Accessible to tenant admins only.  Raises:      NotFound: When platfom metadata is not found.  Returns:      201 : Platform metadata details.  Example Response:      GET : /api/ai-account/orgs/main/platform-metadata/ .      Request:        {                         \"data\": {                             \"services\": {                                 \"google\": {                                     \"credential\": {                                         \"type\": \"service_account\",                                         \"auth_uri\": \"https://accounts.google.com/o/oauth2/auth\",                                         \"client_id\": \"\",                                         \"token_uri\": \"https://oauth2.googleapis.com/token\",                                         \"project_id\": \"NO PROJECT ID IS PROVIDED\",                                         \"private_key\": \"\",                                         \"client_email\": \"\",                                         \"private_key_id\": \"\",                                         \"universe_domain\": \"googleapis.com\",                                         \"client_x509_cert_url\": \"\",                                         \"auth_provider_x509_cert_url\": \"https://www.googleapis.com/oauth2/v1/certs\"                                     },                                     \"llm_options\": {                                         \"temperature\": 0.7                                     }                                 },                                 \"openai\": {                                     \"credential\": {                                         \"key\": \"NO KEY IS PROVIDED\"                                     },                                     \"llm_options\": {                                         \"temperature\": 0.7                                     }                                 }                             },                             \"active_llm\": \"openai\",                             \"active_stt\": \"google\",                             \"active_tts\": \"google\"                         }                     }      Response:       {                         \"metadata\": {                             \"services\": {                                 \"google\": {                                     \"credential\": {                                         \"type\": \"service_account\",                                         \"auth_uri\": \"https://accounts.google.com/o/oauth2/auth\",                                         \"client_id\": \"\",                                         \"token_uri\": \"https://oauth2.googleapis.com/token\",                                         \"project_id\": \"NO PROJECT ID IS PROVIDED\",                                         \"private_key\": \"\",                                         \"client_email\": \"\",                                         \"private_key_id\": \"\",                                         \"universe_domain\": \"googleapis.com\",                                         \"client_x509_cert_url\": \"\",                                         \"auth_provider_x509_cert_url\": \"https://www.googleapis.com/oauth2/v1/certs\"                                     },                                     \"llm_options\": {                                         \"temperature\": 0.7                                     }                                 },                                 \"openai\": {                                     \"credential\": {                                         \"key\": \"NO KEY IS PROVIDED\"                                     },                                     \"llm_options\": {                                         \"temperature\": 0.7                                     }                                 }                             },                             \"active_llm\": \"openai\",                             \"active_stt\": \"google\",                             \"active_tts\": \"google\"                         }                     }

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiAccountApi();
final String org = org_example; // String | 
final IBLAIPlatformMetaRequest iBLAIPlatformMetaRequest = ; // IBLAIPlatformMetaRequest | 

try {
    final response = api.aiAccountOrgsPlatformMetadataCreate(org, iBLAIPlatformMetaRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiAccountApi->aiAccountOrgsPlatformMetadataCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **iBLAIPlatformMetaRequest** | [**IBLAIPlatformMetaRequest**](IBLAIPlatformMetaRequest.md)|  | 

### Return type

[**IBLAIPlatformMeta**](IBLAIPlatformMeta.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsPlatformMetadataList**
> BuiltList<IBLAIPlatformMeta> aiAccountOrgsPlatformMetadataList(org)



This is for getting platform metadata.  Accessible to tenant admins only.  Raises:      NotFound: When platfom metadata is not found.  Returns:      200 : Platform metadata details.  Example Response:      GET : /api/ai-account/orgs/main/platform-metadata/ .      Response:       {                         \"metadata\": {                             \"services\": {                                 \"google\": {                                     \"credential\": {                                         \"type\": \"service_account\",                                         \"auth_uri\": \"https://accounts.google.com/o/oauth2/auth\",                                         \"client_id\": \"\",                                         \"token_uri\": \"https://oauth2.googleapis.com/token\",                                         \"project_id\": \"NO PROJECT ID IS PROVIDED\",                                         \"private_key\": \"\",                                         \"client_email\": \"\",                                         \"private_key_id\": \"\",                                         \"universe_domain\": \"googleapis.com\",                                         \"client_x509_cert_url\": \"\",                                         \"auth_provider_x509_cert_url\": \"https://www.googleapis.com/oauth2/v1/certs\"                                     },                                     \"llm_options\": {                                         \"temperature\": 0.7                                     }                                 },                                 \"openai\": {                                     \"credential\": {                                         \"key\": \"NO KEY IS PROVIDED\"                                     },                                     \"llm_options\": {                                         \"temperature\": 0.7                                     }                                 }                             },                             \"active_llm\": \"openai\",                             \"active_stt\": \"google\",                             \"active_tts\": \"google\"                         }                     }

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiAccountApi();
final String org = org_example; // String | 

try {
    final response = api.aiAccountOrgsPlatformMetadataList(org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiAccountApi->aiAccountOrgsPlatformMetadataList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**BuiltList&lt;IBLAIPlatformMeta&gt;**](IBLAIPlatformMeta.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsPlatformMetadataUpdate**
> BuiltList<IBLAIPlatformMeta> aiAccountOrgsPlatformMetadataUpdate(org, iBLAIPlatformMetaUpdateRequest)



This is for  updating platform metadata.  Accessible to tenant admins only.  Raises:      NotFound: When platfom metadata is not found.  Returns:      200 : Platform metadata details.  Example Response:      GET : /api/ai-account/orgs/main/platform-metadata/ .      Request:        {                         \"active_llm\": \"openai\",                         \"llms\": [\"google\", \"openai\"]                     }      Response:       {                         \"metadata\": {                             \"services\": {                                 \"google\": {                                     \"credential\": {                                         \"type\": \"service_account\",                                         \"auth_uri\": \"https://accounts.google.com/o/oauth2/auth\",                                         \"client_id\": \"\",                                         \"token_uri\": \"https://oauth2.googleapis.com/token\",                                         \"project_id\": \"NO PROJECT ID IS PROVIDED\",                                         \"private_key\": \"\",                                         \"client_email\": \"\",                                         \"private_key_id\": \"\",                                         \"universe_domain\": \"googleapis.com\",                                         \"client_x509_cert_url\": \"\",                                         \"auth_provider_x509_cert_url\": \"https://www.googleapis.com/oauth2/v1/certs\"                                     },                                     \"llm_options\": {                                         \"temperature\": 0.7                                     }                                 },                                 \"openai\": {                                     \"credential\": {                                         \"key\": \"NO KEY IS PROVIDED\"                                     },                                     \"llm_options\": {                                         \"temperature\": 0.7                                     }                                 }                             },                             \"active_llm\": \"openai\",                             \"active_stt\": \"google\",                             \"active_tts\": \"google\"                         }                     }

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiAccountApi();
final String org = org_example; // String | 
final IBLAIPlatformMetaUpdateRequest iBLAIPlatformMetaUpdateRequest = ; // IBLAIPlatformMetaUpdateRequest | 

try {
    final response = api.aiAccountOrgsPlatformMetadataUpdate(org, iBLAIPlatformMetaUpdateRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiAccountApi->aiAccountOrgsPlatformMetadataUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **iBLAIPlatformMetaUpdateRequest** | [**IBLAIPlatformMetaUpdateRequest**](IBLAIPlatformMetaUpdateRequest.md)|  | [optional] 

### Return type

[**BuiltList&lt;IBLAIPlatformMeta&gt;**](IBLAIPlatformMeta.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsTokensList**
> BuiltList<APITokenCost> aiAccountOrgsTokensList(org, sessionId, username)



This is for getting weekly tokens.  You can also filter the list  by passing a query parameter username=<username> and session_id=<session_id>.  Accessible to tenant admins only.  Raises:      NotFound: When organization is not found.      NotFound: When session id is not found.   Returns:      400: When the data is not valid.      200 : List of tokens.  Example Response:      GET : /api/ai-account/orgs/main/tokens/ .      Response:       [                         {                             \"date\": \"2024-02-05\",                             \"completion_tokens\": 2147483647,                             \"prompt_tokens\": 123456785                         }                     ]

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiAccountApi();
final String org = org_example; // String | 
final String sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | session id of the user's chat
final String username = username_example; // String | Username of the user

try {
    final response = api.aiAccountOrgsTokensList(org, sessionId, username);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiAccountApi->aiAccountOrgsTokensList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**| session id of the user's chat | [optional] 
 **username** | **String**| Username of the user | [optional] 

### Return type

[**BuiltList&lt;APITokenCost&gt;**](APITokenCost.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

