# ibl_ai_data_manager_sdk.api.AiBotApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**aiBotV1BotsBotCommandsCreate**](AiBotApi.md#aibotv1botsbotcommandscreate) | **POST** /api/ai-bot/v1/bots/{org}/bot-commands/ | 
[**aiBotV1BotsBotCommandsDestroy**](AiBotApi.md#aibotv1botsbotcommandsdestroy) | **DELETE** /api/ai-bot/v1/bots/{org}/bot-commands/{id}/ | 
[**aiBotV1BotsBotCommandsList**](AiBotApi.md#aibotv1botsbotcommandslist) | **GET** /api/ai-bot/v1/bots/{org}/bot-commands/ | 
[**aiBotV1BotsBotCommandsPartialUpdate**](AiBotApi.md#aibotv1botsbotcommandspartialupdate) | **PATCH** /api/ai-bot/v1/bots/{org}/bot-commands/{id}/ | 
[**aiBotV1BotsBotCommandsRetrieve**](AiBotApi.md#aibotv1botsbotcommandsretrieve) | **GET** /api/ai-bot/v1/bots/{org}/bot-commands/{id}/ | 
[**aiBotV1BotsBotCommandsUpdate**](AiBotApi.md#aibotv1botsbotcommandsupdate) | **PUT** /api/ai-bot/v1/bots/{org}/bot-commands/{id}/ | 
[**aiBotV1BotsBotCreate**](AiBotApi.md#aibotv1botsbotcreate) | **POST** /api/ai-bot/v1/bots/{org}/bot/ | 
[**aiBotV1BotsBotDestroy**](AiBotApi.md#aibotv1botsbotdestroy) | **DELETE** /api/ai-bot/v1/bots/{org}/bot/{id}/ | 
[**aiBotV1BotsBotList**](AiBotApi.md#aibotv1botsbotlist) | **GET** /api/ai-bot/v1/bots/{org}/bot/ | 
[**aiBotV1BotsBotPartialUpdate**](AiBotApi.md#aibotv1botsbotpartialupdate) | **PATCH** /api/ai-bot/v1/bots/{org}/bot/{id}/ | 
[**aiBotV1BotsBotRetrieve**](AiBotApi.md#aibotv1botsbotretrieve) | **GET** /api/ai-bot/v1/bots/{org}/bot/{id}/ | 
[**aiBotV1BotsBotUpdate**](AiBotApi.md#aibotv1botsbotupdate) | **PUT** /api/ai-bot/v1/bots/{org}/bot/{id}/ | 
[**aiBotV1BotsWebhooksDiscordCreate**](AiBotApi.md#aibotv1botswebhooksdiscordcreate) | **POST** /api/ai-bot/v1/bots/webhooks/{org}/discord/ | 
[**aiBotV1BotsWebhooksSlackCreate**](AiBotApi.md#aibotv1botswebhooksslackcreate) | **POST** /api/ai-bot/v1/bots/webhooks/{org}/slack/ | 
[**aiBotV1BotsWebhooksWebexCreate**](AiBotApi.md#aibotv1botswebhookswebexcreate) | **POST** /api/ai-bot/v1/bots/webhooks/{org}/webex/ | 
[**aiBotV1BotsWebhooksWhatsappCreate**](AiBotApi.md#aibotv1botswebhookswhatsappcreate) | **POST** /api/ai-bot/v1/bots/webhooks/{org}/whatsapp/ | 
[**aiBotV1BotsWebhooksWhatsappRetrieve**](AiBotApi.md#aibotv1botswebhookswhatsappretrieve) | **GET** /api/ai-bot/v1/bots/webhooks/{org}/whatsapp/ | 


# **aiBotV1BotsBotCommandsCreate**
> BotCommand aiBotV1BotsBotCommandsCreate(org, botCommand)



Create slash commands for a specific bot eg. /iblai-baseline

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final String org = org_example; // String | 
final BotCommand botCommand = ; // BotCommand | 

try {
    final response = api.aiBotV1BotsBotCommandsCreate(org, botCommand);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsBotCommandsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **botCommand** | [**BotCommand**](BotCommand.md)|  | 

### Return type

[**BotCommand**](BotCommand.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotCommandsDestroy**
> aiBotV1BotsBotCommandsDestroy(id, org)



Create slash commands for a specific bot eg. /iblai-baseline

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final int id = 56; // int | A unique integer value identifying this bot command.
final String org = org_example; // String | 

try {
    api.aiBotV1BotsBotCommandsDestroy(id, org);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsBotCommandsDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this bot command. | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotCommandsList**
> BuiltList<BotCommand> aiBotV1BotsBotCommandsList(org)



Create slash commands for a specific bot eg. /iblai-baseline

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final String org = org_example; // String | 

try {
    final response = api.aiBotV1BotsBotCommandsList(org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsBotCommandsList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**BuiltList&lt;BotCommand&gt;**](BotCommand.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotCommandsPartialUpdate**
> BotCommand aiBotV1BotsBotCommandsPartialUpdate(id, org, patchedBotCommand)



Create slash commands for a specific bot eg. /iblai-baseline

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final int id = 56; // int | A unique integer value identifying this bot command.
final String org = org_example; // String | 
final PatchedBotCommand patchedBotCommand = ; // PatchedBotCommand | 

try {
    final response = api.aiBotV1BotsBotCommandsPartialUpdate(id, org, patchedBotCommand);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsBotCommandsPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this bot command. | 
 **org** | **String**|  | 
 **patchedBotCommand** | [**PatchedBotCommand**](PatchedBotCommand.md)|  | [optional] 

### Return type

[**BotCommand**](BotCommand.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotCommandsRetrieve**
> BotCommand aiBotV1BotsBotCommandsRetrieve(id, org)



Create slash commands for a specific bot eg. /iblai-baseline

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final int id = 56; // int | A unique integer value identifying this bot command.
final String org = org_example; // String | 

try {
    final response = api.aiBotV1BotsBotCommandsRetrieve(id, org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsBotCommandsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this bot command. | 
 **org** | **String**|  | 

### Return type

[**BotCommand**](BotCommand.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotCommandsUpdate**
> BotCommand aiBotV1BotsBotCommandsUpdate(id, org, botCommand)



Create slash commands for a specific bot eg. /iblai-baseline

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final int id = 56; // int | A unique integer value identifying this bot command.
final String org = org_example; // String | 
final BotCommand botCommand = ; // BotCommand | 

try {
    final response = api.aiBotV1BotsBotCommandsUpdate(id, org, botCommand);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsBotCommandsUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this bot command. | 
 **org** | **String**|  | 
 **botCommand** | [**BotCommand**](BotCommand.md)|  | 

### Return type

[**BotCommand**](BotCommand.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotCreate**
> BotCreate aiBotV1BotsBotCreate(org, botCreate)



Create modify and update bot information for a specific tenant.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final String org = org_example; // String | 
final BotCreate botCreate = ; // BotCreate | 

try {
    final response = api.aiBotV1BotsBotCreate(org, botCreate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsBotCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **botCreate** | [**BotCreate**](BotCreate.md)|  | 

### Return type

[**BotCreate**](BotCreate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotDestroy**
> aiBotV1BotsBotDestroy(id, org)



Create modify and update bot information for a specific tenant.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final int id = 56; // int | A unique integer value identifying this bot.
final String org = org_example; // String | 

try {
    api.aiBotV1BotsBotDestroy(id, org);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsBotDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this bot. | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotList**
> BuiltList<Bot> aiBotV1BotsBotList(org)



Create modify and update bot information for a specific tenant.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final String org = org_example; // String | 

try {
    final response = api.aiBotV1BotsBotList(org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsBotList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**BuiltList&lt;Bot&gt;**](Bot.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotPartialUpdate**
> BotCreate aiBotV1BotsBotPartialUpdate(id, org, patchedBotCreate)



Create modify and update bot information for a specific tenant.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final int id = 56; // int | A unique integer value identifying this bot.
final String org = org_example; // String | 
final PatchedBotCreate patchedBotCreate = ; // PatchedBotCreate | 

try {
    final response = api.aiBotV1BotsBotPartialUpdate(id, org, patchedBotCreate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsBotPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this bot. | 
 **org** | **String**|  | 
 **patchedBotCreate** | [**PatchedBotCreate**](PatchedBotCreate.md)|  | [optional] 

### Return type

[**BotCreate**](BotCreate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotRetrieve**
> Bot aiBotV1BotsBotRetrieve(id, org)



Create modify and update bot information for a specific tenant.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final int id = 56; // int | A unique integer value identifying this bot.
final String org = org_example; // String | 

try {
    final response = api.aiBotV1BotsBotRetrieve(id, org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsBotRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this bot. | 
 **org** | **String**|  | 

### Return type

[**Bot**](Bot.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotUpdate**
> BotCreate aiBotV1BotsBotUpdate(id, org, botCreate)



Create modify and update bot information for a specific tenant.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final int id = 56; // int | A unique integer value identifying this bot.
final String org = org_example; // String | 
final BotCreate botCreate = ; // BotCreate | 

try {
    final response = api.aiBotV1BotsBotUpdate(id, org, botCreate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsBotUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this bot. | 
 **org** | **String**|  | 
 **botCreate** | [**BotCreate**](BotCreate.md)|  | 

### Return type

[**BotCreate**](BotCreate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsWebhooksDiscordCreate**
> DiscordWebhook aiBotV1BotsWebhooksDiscordCreate(org, discordWebhook)



Webhook endpoint to receive and process discord messages.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final String org = org_example; // String | 
final DiscordWebhook discordWebhook = ; // DiscordWebhook | 

try {
    final response = api.aiBotV1BotsWebhooksDiscordCreate(org, discordWebhook);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsWebhooksDiscordCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **discordWebhook** | [**DiscordWebhook**](DiscordWebhook.md)|  | 

### Return type

[**DiscordWebhook**](DiscordWebhook.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, multipart/form-data, application/x-www-form-urlencoded
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsWebhooksSlackCreate**
> SlackWebhook aiBotV1BotsWebhooksSlackCreate(org, slackWebhook)



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final String org = org_example; // String | 
final SlackWebhook slackWebhook = ; // SlackWebhook | 

try {
    final response = api.aiBotV1BotsWebhooksSlackCreate(org, slackWebhook);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsWebhooksSlackCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **slackWebhook** | [**SlackWebhook**](SlackWebhook.md)|  | 

### Return type

[**SlackWebhook**](SlackWebhook.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, multipart/form-data, application/x-www-form-urlencoded
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsWebhooksWebexCreate**
> WebexWebhook aiBotV1BotsWebhooksWebexCreate(org, webexWebhook)



Webhook endpoint to receive and process discord messages.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final String org = org_example; // String | 
final WebexWebhook webexWebhook = ; // WebexWebhook | 

try {
    final response = api.aiBotV1BotsWebhooksWebexCreate(org, webexWebhook);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsWebhooksWebexCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **webexWebhook** | [**WebexWebhook**](WebexWebhook.md)|  | 

### Return type

[**WebexWebhook**](WebexWebhook.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, multipart/form-data, application/x-www-form-urlencoded
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsWebhooksWhatsappCreate**
> WhatAppWebHook aiBotV1BotsWebhooksWhatsappCreate(org, whatAppWebHook)



Webhook endpoint to receive and process whatsapp messages.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final String org = org_example; // String | 
final WhatAppWebHook whatAppWebHook = ; // WhatAppWebHook | 

try {
    final response = api.aiBotV1BotsWebhooksWhatsappCreate(org, whatAppWebHook);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsWebhooksWhatsappCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **whatAppWebHook** | [**WhatAppWebHook**](WhatAppWebHook.md)|  | 

### Return type

[**WhatAppWebHook**](WhatAppWebHook.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, multipart/form-data, application/x-www-form-urlencoded
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsWebhooksWhatsappRetrieve**
> WhatAppWebHook aiBotV1BotsWebhooksWhatsappRetrieve(org)



Respond to whatsapp's webhook challenge.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiBotApi();
final String org = org_example; // String | 

try {
    final response = api.aiBotV1BotsWebhooksWhatsappRetrieve(org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiBotApi->aiBotV1BotsWebhooksWhatsappRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**WhatAppWebHook**](WhatAppWebHook.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

