# ibl_ai_data_manager_sdk.api.AiIndexApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**aiIndexOrgsUsersDocumentsPathwaysRetrieve**](AiIndexApi.md#aiindexorgsusersdocumentspathwaysretrieve) | **GET** /api/ai-index/orgs/{org}/users/{user_id}/documents/pathways/{pathway}/ | 
[**aiIndexOrgsUsersDocumentsRetrieve**](AiIndexApi.md#aiindexorgsusersdocumentsretrieve) | **GET** /api/ai-index/orgs/{org}/users/{user_id}/documents/{document_id}/ | 
[**aiIndexOrgsUsersDocumentsSearchCreate**](AiIndexApi.md#aiindexorgsusersdocumentssearchcreate) | **POST** /api/ai-index/orgs/{org}/users/{user_id}/documents/search/ | 
[**aiIndexOrgsUsersDocumentsSourcesCreate**](AiIndexApi.md#aiindexorgsusersdocumentssourcescreate) | **POST** /api/ai-index/orgs/{org}/users/{user_id}/documents/sources/ | 
[**aiIndexOrgsUsersDocumentsTasksRetrieve**](AiIndexApi.md#aiindexorgsusersdocumentstasksretrieve) | **GET** /api/ai-index/orgs/{org}/users/{user_id}/documents/tasks/{task_id}/ | 
[**aiIndexOrgsUsersDocumentsTrainCreate**](AiIndexApi.md#aiindexorgsusersdocumentstraincreate) | **POST** /api/ai-index/orgs/{org}/users/{user_id}/documents/train/ | 
[**aiIndexOrgsUsersDocumentsTrainMultilingualRetrieverCreate**](AiIndexApi.md#aiindexorgsusersdocumentstrainmultilingualretrievercreate) | **POST** /api/ai-index/orgs/{org}/users/{user_id}/documents/train/multilingual-retriever/ | 
[**aiIndexOrgsUsersDocumentsTrainRetrieverCreate**](AiIndexApi.md#aiindexorgsusersdocumentstrainretrievercreate) | **POST** /api/ai-index/orgs/{org}/users/{user_id}/documents/train/retriever/ | 
[**aiIndexOrgsUsersDocumentsTrainSessionsCreate**](AiIndexApi.md#aiindexorgsusersdocumentstrainsessionscreate) | **POST** /api/ai-index/orgs/{org}/users/{user_id}/documents/train/sessions/{session_id}/ | 
[**aiIndexOrgsUsersDocumentsUpdate**](AiIndexApi.md#aiindexorgsusersdocumentsupdate) | **PUT** /api/ai-index/orgs/{org}/users/{user_id}/documents/{document_id}/ | 


# **aiIndexOrgsUsersDocumentsPathwaysRetrieve**
> RetrieverDocumentEmbedding aiIndexOrgsUsersDocumentsPathwaysRetrieve(org, pathway, userId)



     Get document resources for a tenant     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiIndexApi();
final String org = org_example; // String | 
final String pathway = pathway_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiIndexOrgsUsersDocumentsPathwaysRetrieve(org, pathway, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiIndexApi->aiIndexOrgsUsersDocumentsPathwaysRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **pathway** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**RetrieverDocumentEmbedding**](RetrieverDocumentEmbedding.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersDocumentsRetrieve**
> RetrieverDocumentEmbedding aiIndexOrgsUsersDocumentsRetrieve(documentId, org, userId)



     Get document resource details for a tenant     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiIndexApi();
final String documentId = documentId_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiIndexOrgsUsersDocumentsRetrieve(documentId, org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiIndexApi->aiIndexOrgsUsersDocumentsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **documentId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**RetrieverDocumentEmbedding**](RetrieverDocumentEmbedding.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersDocumentsSearchCreate**
> RetrieverResponseSearch aiIndexOrgsUsersDocumentsSearchCreate(org, userId, retrieverRequestSearch)



     Retrieve similar documents to the query     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiIndexApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final RetrieverRequestSearch retrieverRequestSearch = ; // RetrieverRequestSearch | 

try {
    final response = api.aiIndexOrgsUsersDocumentsSearchCreate(org, userId, retrieverRequestSearch);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiIndexApi->aiIndexOrgsUsersDocumentsSearchCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **retrieverRequestSearch** | [**RetrieverRequestSearch**](RetrieverRequestSearch.md)|  | 

### Return type

[**RetrieverResponseSearch**](RetrieverResponseSearch.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersDocumentsSourcesCreate**
> RetrieverRequestSearchDocument aiIndexOrgsUsersDocumentsSourcesCreate(org, userId, retrieverRequestSearch)



     Retrieve similar documents sources to the query     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiIndexApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final RetrieverRequestSearch retrieverRequestSearch = ; // RetrieverRequestSearch | 

try {
    final response = api.aiIndexOrgsUsersDocumentsSourcesCreate(org, userId, retrieverRequestSearch);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiIndexApi->aiIndexOrgsUsersDocumentsSourcesCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **retrieverRequestSearch** | [**RetrieverRequestSearch**](RetrieverRequestSearch.md)|  | 

### Return type

[**RetrieverRequestSearchDocument**](RetrieverRequestSearchDocument.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersDocumentsTasksRetrieve**
> CheckDocumentTrainingStatus aiIndexOrgsUsersDocumentsTasksRetrieve(org, taskId, userId)



     Check document status of training     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiIndexApi();
final String org = org_example; // String | 
final String taskId = taskId_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiIndexOrgsUsersDocumentsTasksRetrieve(org, taskId, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiIndexApi->aiIndexOrgsUsersDocumentsTasksRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **taskId** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**CheckDocumentTrainingStatus**](CheckDocumentTrainingStatus.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersDocumentsTrainCreate**
> TrainDocumentViewResponse aiIndexOrgsUsersDocumentsTrainCreate(org, userId, trainDocumentViewRequest)



     Train documents     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiIndexApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final TrainDocumentViewRequest trainDocumentViewRequest = ; // TrainDocumentViewRequest | 

try {
    final response = api.aiIndexOrgsUsersDocumentsTrainCreate(org, userId, trainDocumentViewRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiIndexApi->aiIndexOrgsUsersDocumentsTrainCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **trainDocumentViewRequest** | [**TrainDocumentViewRequest**](TrainDocumentViewRequest.md)|  | 

### Return type

[**TrainDocumentViewResponse**](TrainDocumentViewResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersDocumentsTrainMultilingualRetrieverCreate**
> RetreiverTrainViewResponse aiIndexOrgsUsersDocumentsTrainMultilingualRetrieverCreate(org, userId, retreiverTrainViewRequest)



     Train document from other languages to english     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiIndexApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final RetreiverTrainViewRequest retreiverTrainViewRequest = ; // RetreiverTrainViewRequest | 

try {
    final response = api.aiIndexOrgsUsersDocumentsTrainMultilingualRetrieverCreate(org, userId, retreiverTrainViewRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiIndexApi->aiIndexOrgsUsersDocumentsTrainMultilingualRetrieverCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **retreiverTrainViewRequest** | [**RetreiverTrainViewRequest**](RetreiverTrainViewRequest.md)|  | 

### Return type

[**RetreiverTrainViewResponse**](RetreiverTrainViewResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersDocumentsTrainRetrieverCreate**
> RetreiverTrainViewResponse aiIndexOrgsUsersDocumentsTrainRetrieverCreate(org, userId, retreiverTrainViewRequest)



     Train documents     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiIndexApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final RetreiverTrainViewRequest retreiverTrainViewRequest = ; // RetreiverTrainViewRequest | 

try {
    final response = api.aiIndexOrgsUsersDocumentsTrainRetrieverCreate(org, userId, retreiverTrainViewRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiIndexApi->aiIndexOrgsUsersDocumentsTrainRetrieverCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **retreiverTrainViewRequest** | [**RetreiverTrainViewRequest**](RetreiverTrainViewRequest.md)|  | 

### Return type

[**RetreiverTrainViewResponse**](RetreiverTrainViewResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersDocumentsTrainSessionsCreate**
> TrainChatSessionDocumentView aiIndexOrgsUsersDocumentsTrainSessionsCreate(org, sessionId, userId)



     Train in chat session documents     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiIndexApi();
final String org = org_example; // String | 
final String sessionId = sessionId_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiIndexOrgsUsersDocumentsTrainSessionsCreate(org, sessionId, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiIndexApi->aiIndexOrgsUsersDocumentsTrainSessionsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**TrainChatSessionDocumentView**](TrainChatSessionDocumentView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersDocumentsUpdate**
> RetrieverDocumentEmbedding aiIndexOrgsUsersDocumentsUpdate(documentId, org, userId, retrieverDocumentEmbeddingRequest)



     Update document resource details for a tenant     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiIndexApi();
final String documentId = documentId_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final RetrieverDocumentEmbeddingRequest retrieverDocumentEmbeddingRequest = ; // RetrieverDocumentEmbeddingRequest | 

try {
    final response = api.aiIndexOrgsUsersDocumentsUpdate(documentId, org, userId, retrieverDocumentEmbeddingRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiIndexApi->aiIndexOrgsUsersDocumentsUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **documentId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **retrieverDocumentEmbeddingRequest** | [**RetrieverDocumentEmbeddingRequest**](RetrieverDocumentEmbeddingRequest.md)|  | 

### Return type

[**RetrieverDocumentEmbedding**](RetrieverDocumentEmbedding.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

