# ibl_ai_data_manager_sdk.api.AiMathApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**aiMathMathMathStudentsCreate**](AiMathApi.md#aimathmathmathstudentscreate) | **POST** /api/ai-math/math/{org}/math-students/ | 
[**aiMathMathMathStudentsDestroy**](AiMathApi.md#aimathmathmathstudentsdestroy) | **DELETE** /api/ai-math/math/{org}/math-students/{id}/ | 
[**aiMathMathMathStudentsList**](AiMathApi.md#aimathmathmathstudentslist) | **GET** /api/ai-math/math/{org}/math-students/ | 
[**aiMathMathMathStudentsPartialUpdate**](AiMathApi.md#aimathmathmathstudentspartialupdate) | **PATCH** /api/ai-math/math/{org}/math-students/{id}/ | 
[**aiMathMathMathStudentsRetrieve**](AiMathApi.md#aimathmathmathstudentsretrieve) | **GET** /api/ai-math/math/{org}/math-students/{id}/ | 
[**aiMathMathMathStudentsUpdate**](AiMathApi.md#aimathmathmathstudentsupdate) | **PUT** /api/ai-math/math/{org}/math-students/{id}/ | 
[**aiMathMathQuestionsDestroy**](AiMathApi.md#aimathmathquestionsdestroy) | **DELETE** /api/ai-math/math/{org}/questions/{id}/ | 
[**aiMathMathQuestionsList**](AiMathApi.md#aimathmathquestionslist) | **GET** /api/ai-math/math/{org}/questions/ | 
[**aiMathMathQuestionsPartialUpdate**](AiMathApi.md#aimathmathquestionspartialupdate) | **PATCH** /api/ai-math/math/{org}/questions/{id}/ | 
[**aiMathMathQuestionsRetrieve**](AiMathApi.md#aimathmathquestionsretrieve) | **GET** /api/ai-math/math/{org}/questions/{id}/ | 
[**aiMathMathSampleQuestionsCreate**](AiMathApi.md#aimathmathsamplequestionscreate) | **POST** /api/ai-math/math/{org}/sample-questions/ | 
[**aiMathMathSampleQuestionsDestroy**](AiMathApi.md#aimathmathsamplequestionsdestroy) | **DELETE** /api/ai-math/math/{org}/sample-questions/{id}/ | 
[**aiMathMathSampleQuestionsList**](AiMathApi.md#aimathmathsamplequestionslist) | **GET** /api/ai-math/math/{org}/sample-questions/ | 
[**aiMathMathSampleQuestionsRetrieve**](AiMathApi.md#aimathmathsamplequestionsretrieve) | **GET** /api/ai-math/math/{org}/sample-questions/{id}/ | 
[**aiMathMathSkillsCreate**](AiMathApi.md#aimathmathskillscreate) | **POST** /api/ai-math/math/{org}/skills/ | 
[**aiMathMathSkillsDestroy**](AiMathApi.md#aimathmathskillsdestroy) | **DELETE** /api/ai-math/math/{org}/skills/{id}/ | 
[**aiMathMathSkillsList**](AiMathApi.md#aimathmathskillslist) | **GET** /api/ai-math/math/{org}/skills/ | 
[**aiMathMathSkillsPartialUpdate**](AiMathApi.md#aimathmathskillspartialupdate) | **PATCH** /api/ai-math/math/{org}/skills/{id}/ | 
[**aiMathMathSkillsRetrieve**](AiMathApi.md#aimathmathskillsretrieve) | **GET** /api/ai-math/math/{org}/skills/{id}/ | 
[**aiMathMathSkillsUpdate**](AiMathApi.md#aimathmathskillsupdate) | **PUT** /api/ai-math/math/{org}/skills/{id}/ | 
[**aiMathMathStudentAnswersCreate**](AiMathApi.md#aimathmathstudentanswerscreate) | **POST** /api/ai-math/math/{org}/student-answers/ | 
[**aiMathMathStudentAnswersDestroy**](AiMathApi.md#aimathmathstudentanswersdestroy) | **DELETE** /api/ai-math/math/{org}/student-answers/{id}/ | 
[**aiMathMathStudentAnswersList**](AiMathApi.md#aimathmathstudentanswerslist) | **GET** /api/ai-math/math/{org}/student-answers/ | 
[**aiMathMathStudentAnswersPartialUpdate**](AiMathApi.md#aimathmathstudentanswerspartialupdate) | **PATCH** /api/ai-math/math/{org}/student-answers/{id}/ | 
[**aiMathMathStudentAnswersRetrieve**](AiMathApi.md#aimathmathstudentanswersretrieve) | **GET** /api/ai-math/math/{org}/student-answers/{id}/ | 
[**aiMathMathStudentAnswersUpdate**](AiMathApi.md#aimathmathstudentanswersupdate) | **PUT** /api/ai-math/math/{org}/student-answers/{id}/ | 


# **aiMathMathMathStudentsCreate**
> MathStudent aiMathMathMathStudentsCreate(org, mathStudent)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final String org = org_example; // String | 
final MathStudent mathStudent = ; // MathStudent | 

try {
    final response = api.aiMathMathMathStudentsCreate(org, mathStudent);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathMathStudentsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **mathStudent** | [**MathStudent**](MathStudent.md)|  | [optional] 

### Return type

[**MathStudent**](MathStudent.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathMathStudentsDestroy**
> aiMathMathMathStudentsDestroy(id, org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this math student.
final String org = org_example; // String | 

try {
    api.aiMathMathMathStudentsDestroy(id, org);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathMathStudentsDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this math student. | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathMathStudentsList**
> BuiltList<MathStudent> aiMathMathMathStudentsList(org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final String org = org_example; // String | 

try {
    final response = api.aiMathMathMathStudentsList(org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathMathStudentsList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**BuiltList&lt;MathStudent&gt;**](MathStudent.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathMathStudentsPartialUpdate**
> MathStudent aiMathMathMathStudentsPartialUpdate(id, org, patchedMathStudent)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this math student.
final String org = org_example; // String | 
final PatchedMathStudent patchedMathStudent = ; // PatchedMathStudent | 

try {
    final response = api.aiMathMathMathStudentsPartialUpdate(id, org, patchedMathStudent);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathMathStudentsPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this math student. | 
 **org** | **String**|  | 
 **patchedMathStudent** | [**PatchedMathStudent**](PatchedMathStudent.md)|  | [optional] 

### Return type

[**MathStudent**](MathStudent.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathMathStudentsRetrieve**
> MathStudent aiMathMathMathStudentsRetrieve(id, org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this math student.
final String org = org_example; // String | 

try {
    final response = api.aiMathMathMathStudentsRetrieve(id, org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathMathStudentsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this math student. | 
 **org** | **String**|  | 

### Return type

[**MathStudent**](MathStudent.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathMathStudentsUpdate**
> MathStudent aiMathMathMathStudentsUpdate(id, org, mathStudent)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this math student.
final String org = org_example; // String | 
final MathStudent mathStudent = ; // MathStudent | 

try {
    final response = api.aiMathMathMathStudentsUpdate(id, org, mathStudent);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathMathStudentsUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this math student. | 
 **org** | **String**|  | 
 **mathStudent** | [**MathStudent**](MathStudent.md)|  | [optional] 

### Return type

[**MathStudent**](MathStudent.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathQuestionsDestroy**
> aiMathMathQuestionsDestroy(id, org)



Retrieve, update and delete math questions.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this math question.
final String org = org_example; // String | 

try {
    api.aiMathMathQuestionsDestroy(id, org);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathQuestionsDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this math question. | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathQuestionsList**
> BuiltList<MathQuestion> aiMathMathQuestionsList(org)



Retrieve, update and delete math questions.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final String org = org_example; // String | 

try {
    final response = api.aiMathMathQuestionsList(org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathQuestionsList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**BuiltList&lt;MathQuestion&gt;**](MathQuestion.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathQuestionsPartialUpdate**
> MathQuestion aiMathMathQuestionsPartialUpdate(id, org, patchedMathQuestion)



Retrieve, update and delete math questions.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this math question.
final String org = org_example; // String | 
final PatchedMathQuestion patchedMathQuestion = ; // PatchedMathQuestion | 

try {
    final response = api.aiMathMathQuestionsPartialUpdate(id, org, patchedMathQuestion);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathQuestionsPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this math question. | 
 **org** | **String**|  | 
 **patchedMathQuestion** | [**PatchedMathQuestion**](PatchedMathQuestion.md)|  | [optional] 

### Return type

[**MathQuestion**](MathQuestion.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathQuestionsRetrieve**
> MathQuestion aiMathMathQuestionsRetrieve(id, org)



Retrieve, update and delete math questions.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this math question.
final String org = org_example; // String | 

try {
    final response = api.aiMathMathQuestionsRetrieve(id, org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathQuestionsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this math question. | 
 **org** | **String**|  | 

### Return type

[**MathQuestion**](MathQuestion.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSampleQuestionsCreate**
> SampleQuestionsDocument aiMathMathSampleQuestionsCreate(org, sampleQuestionsDocument)



Upload documents to provide sample questions of reference to generate more math questions from.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final String org = org_example; // String | 
final SampleQuestionsDocument sampleQuestionsDocument = ; // SampleQuestionsDocument | 

try {
    final response = api.aiMathMathSampleQuestionsCreate(org, sampleQuestionsDocument);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathSampleQuestionsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sampleQuestionsDocument** | [**SampleQuestionsDocument**](SampleQuestionsDocument.md)|  | 

### Return type

[**SampleQuestionsDocument**](SampleQuestionsDocument.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSampleQuestionsDestroy**
> aiMathMathSampleQuestionsDestroy(id, org)



Upload documents to provide sample questions of reference to generate more math questions from.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this sample questions document.
final String org = org_example; // String | 

try {
    api.aiMathMathSampleQuestionsDestroy(id, org);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathSampleQuestionsDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this sample questions document. | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSampleQuestionsList**
> BuiltList<SampleQuestionsDocument> aiMathMathSampleQuestionsList(org)



Upload documents to provide sample questions of reference to generate more math questions from.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final String org = org_example; // String | 

try {
    final response = api.aiMathMathSampleQuestionsList(org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathSampleQuestionsList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**BuiltList&lt;SampleQuestionsDocument&gt;**](SampleQuestionsDocument.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSampleQuestionsRetrieve**
> SampleQuestionsDocument aiMathMathSampleQuestionsRetrieve(id, org)



Upload documents to provide sample questions of reference to generate more math questions from.

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this sample questions document.
final String org = org_example; // String | 

try {
    final response = api.aiMathMathSampleQuestionsRetrieve(id, org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathSampleQuestionsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this sample questions document. | 
 **org** | **String**|  | 

### Return type

[**SampleQuestionsDocument**](SampleQuestionsDocument.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSkillsCreate**
> Skill aiMathMathSkillsCreate(org, skill)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final String org = org_example; // String | 
final Skill skill = ; // Skill | 

try {
    final response = api.aiMathMathSkillsCreate(org, skill);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathSkillsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **skill** | [**Skill**](Skill.md)|  | 

### Return type

[**Skill**](Skill.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSkillsDestroy**
> aiMathMathSkillsDestroy(id, org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this skill.
final String org = org_example; // String | 

try {
    api.aiMathMathSkillsDestroy(id, org);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathSkillsDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this skill. | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSkillsList**
> BuiltList<Skill> aiMathMathSkillsList(org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final String org = org_example; // String | 

try {
    final response = api.aiMathMathSkillsList(org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathSkillsList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**BuiltList&lt;Skill&gt;**](Skill.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSkillsPartialUpdate**
> Skill aiMathMathSkillsPartialUpdate(id, org, patchedSkill)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this skill.
final String org = org_example; // String | 
final PatchedSkill patchedSkill = ; // PatchedSkill | 

try {
    final response = api.aiMathMathSkillsPartialUpdate(id, org, patchedSkill);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathSkillsPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this skill. | 
 **org** | **String**|  | 
 **patchedSkill** | [**PatchedSkill**](PatchedSkill.md)|  | [optional] 

### Return type

[**Skill**](Skill.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSkillsRetrieve**
> Skill aiMathMathSkillsRetrieve(id, org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this skill.
final String org = org_example; // String | 

try {
    final response = api.aiMathMathSkillsRetrieve(id, org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathSkillsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this skill. | 
 **org** | **String**|  | 

### Return type

[**Skill**](Skill.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSkillsUpdate**
> Skill aiMathMathSkillsUpdate(id, org, skill)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this skill.
final String org = org_example; // String | 
final Skill skill = ; // Skill | 

try {
    final response = api.aiMathMathSkillsUpdate(id, org, skill);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathSkillsUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this skill. | 
 **org** | **String**|  | 
 **skill** | [**Skill**](Skill.md)|  | 

### Return type

[**Skill**](Skill.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathStudentAnswersCreate**
> StudentAnswer aiMathMathStudentAnswersCreate(org, studentAnswer)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final String org = org_example; // String | 
final StudentAnswer studentAnswer = ; // StudentAnswer | 

try {
    final response = api.aiMathMathStudentAnswersCreate(org, studentAnswer);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathStudentAnswersCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **studentAnswer** | [**StudentAnswer**](StudentAnswer.md)|  | 

### Return type

[**StudentAnswer**](StudentAnswer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathStudentAnswersDestroy**
> aiMathMathStudentAnswersDestroy(id, org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this student answer.
final String org = org_example; // String | 

try {
    api.aiMathMathStudentAnswersDestroy(id, org);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathStudentAnswersDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this student answer. | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathStudentAnswersList**
> BuiltList<StudentAnswer> aiMathMathStudentAnswersList(org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final String org = org_example; // String | 

try {
    final response = api.aiMathMathStudentAnswersList(org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathStudentAnswersList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**BuiltList&lt;StudentAnswer&gt;**](StudentAnswer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathStudentAnswersPartialUpdate**
> StudentAnswer aiMathMathStudentAnswersPartialUpdate(id, org, patchedStudentAnswer)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this student answer.
final String org = org_example; // String | 
final PatchedStudentAnswer patchedStudentAnswer = ; // PatchedStudentAnswer | 

try {
    final response = api.aiMathMathStudentAnswersPartialUpdate(id, org, patchedStudentAnswer);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathStudentAnswersPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this student answer. | 
 **org** | **String**|  | 
 **patchedStudentAnswer** | [**PatchedStudentAnswer**](PatchedStudentAnswer.md)|  | [optional] 

### Return type

[**StudentAnswer**](StudentAnswer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathStudentAnswersRetrieve**
> StudentAnswer aiMathMathStudentAnswersRetrieve(id, org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this student answer.
final String org = org_example; // String | 

try {
    final response = api.aiMathMathStudentAnswersRetrieve(id, org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathStudentAnswersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this student answer. | 
 **org** | **String**|  | 

### Return type

[**StudentAnswer**](StudentAnswer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathStudentAnswersUpdate**
> StudentAnswer aiMathMathStudentAnswersUpdate(id, org, studentAnswer)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMathApi();
final int id = 56; // int | A unique integer value identifying this student answer.
final String org = org_example; // String | 
final StudentAnswer studentAnswer = ; // StudentAnswer | 

try {
    final response = api.aiMathMathStudentAnswersUpdate(id, org, studentAnswer);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMathApi->aiMathMathStudentAnswersUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this student answer. | 
 **org** | **String**|  | 
 **studentAnswer** | [**StudentAnswer**](StudentAnswer.md)|  | 

### Return type

[**StudentAnswer**](StudentAnswer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

