# ibl_ai_data_manager_sdk.api.AiMentorApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**aiMentorGenerationsStopGenerationCreate**](AiMentorApi.md#aimentorgenerationsstopgenerationcreate) | **POST** /api/ai-mentor/generations/{generation_id}/stop-generation/ | 
[**aiMentorOrgsSessionsCreate**](AiMentorApi.md#aimentororgssessionscreate) | **POST** /api/ai-mentor/orgs/{org}/sessions/ | 
[**aiMentorOrgsUsersAudioToTextCreate**](AiMentorApi.md#aimentororgsusersaudiototextcreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/audio-to-text/ | 
[**aiMentorOrgsUsersCategoryCreate**](AiMentorApi.md#aimentororgsuserscategorycreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/category | 
[**aiMentorOrgsUsersCategoryDestroy**](AiMentorApi.md#aimentororgsuserscategorydestroy) | **DELETE** /api/ai-mentor/orgs/{org}/users/{user_id}/category | 
[**aiMentorOrgsUsersCategoryRetrieve**](AiMentorApi.md#aimentororgsuserscategoryretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/category | 
[**aiMentorOrgsUsersCreate**](AiMentorApi.md#aimentororgsuserscreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/ | 
[**aiMentorOrgsUsersDestroy**](AiMentorApi.md#aimentororgsusersdestroy) | **DELETE** /api/ai-mentor/orgs/{org}/users/{user_id}/{name}/ | 
[**aiMentorOrgsUsersFreeUsageCountRetrieve**](AiMentorApi.md#aimentororgsusersfreeusagecountretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/free-usage-count/ | 
[**aiMentorOrgsUsersList**](AiMentorApi.md#aimentororgsuserslist) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/ | 
[**aiMentorOrgsUsersMentorFeedbackCreateCreate**](AiMentorApi.md#aimentororgsusersmentorfeedbackcreatecreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/mentor-feedback/create/ | 
[**aiMentorOrgsUsersMentorFeedbackRetrieve**](AiMentorApi.md#aimentororgsusersmentorfeedbackretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/mentor-feedback/{feedback_id}/ | 
[**aiMentorOrgsUsersMentorFeedbackUpdate**](AiMentorApi.md#aimentororgsusersmentorfeedbackupdate) | **PUT** /api/ai-mentor/orgs/{org}/users/{user_id}/mentor-feedback/{feedback_id}/ | 
[**aiMentorOrgsUsersMentorFromTemplateCreate**](AiMentorApi.md#aimentororgsusersmentorfromtemplatecreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/mentor-from-template/ | 
[**aiMentorOrgsUsersMentorLlmsRetrieve**](AiMentorApi.md#aimentororgsusersmentorllmsretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/mentor-llms/ | 
[**aiMentorOrgsUsersMentorWithSettingsCreate**](AiMentorApi.md#aimentororgsusersmentorwithsettingscreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/mentor-with-settings/ | 
[**aiMentorOrgsUsersMentorsPublicSettingsRetrieve**](AiMentorApi.md#aimentororgsusersmentorspublicsettingsretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/public-settings/ | 
[**aiMentorOrgsUsersMentorsRetrieve**](AiMentorApi.md#aimentororgsusersmentorsretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/ | 
[**aiMentorOrgsUsersMentorsSettingsRetrieve**](AiMentorApi.md#aimentororgsusersmentorssettingsretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/settings/ | 
[**aiMentorOrgsUsersMentorsSettingsUpdate**](AiMentorApi.md#aimentororgsusersmentorssettingsupdate) | **PUT** /api/ai-mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/settings/ | 
[**aiMentorOrgsUsersPartialUpdate**](AiMentorApi.md#aimentororgsuserspartialupdate) | **PATCH** /api/ai-mentor/orgs/{org}/users/{user_id}/{name}/ | 
[**aiMentorOrgsUsersPinMessageCreate**](AiMentorApi.md#aimentororgsuserspinmessagecreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/pin-message/ | 
[**aiMentorOrgsUsersPinMessageDestroy**](AiMentorApi.md#aimentororgsuserspinmessagedestroy) | **DELETE** /api/ai-mentor/orgs/{org}/users/{user_id}/pin-message/ | 
[**aiMentorOrgsUsersPinMessageRetrieve**](AiMentorApi.md#aimentororgsuserspinmessageretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/pin-message/ | 
[**aiMentorOrgsUsersPredictiveAnalyticsCreate**](AiMentorApi.md#aimentororgsuserspredictiveanalyticscreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/predictive-analytics/ | 
[**aiMentorOrgsUsersRecentMessagesRetrieve**](AiMentorApi.md#aimentororgsusersrecentmessagesretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/recent-messages/ | 
[**aiMentorOrgsUsersRecommendCoursesRetrieve**](AiMentorApi.md#aimentororgsusersrecommendcoursesretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/recommend-courses/ | 
[**aiMentorOrgsUsersRetrieve**](AiMentorApi.md#aimentororgsusersretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/{name}/ | 
[**aiMentorOrgsUsersSessionidList**](AiMentorApi.md#aimentororgsuserssessionidlist) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/sessionid/ | 
[**aiMentorOrgsUsersSessionsCreate**](AiMentorApi.md#aimentororgsuserssessionscreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/sessions/ | 
[**aiMentorOrgsUsersSessionsDestroy**](AiMentorApi.md#aimentororgsuserssessionsdestroy) | **DELETE** /api/ai-mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/ | 
[**aiMentorOrgsUsersSessionsDownloadSessionRetrieve**](AiMentorApi.md#aimentororgsuserssessionsdownloadsessionretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/download-session | 
[**aiMentorOrgsUsersSessionsRetrieve**](AiMentorApi.md#aimentororgsuserssessionsretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/ | 
[**aiMentorOrgsUsersSessionsSuggestionRetrieve**](AiMentorApi.md#aimentororgsuserssessionssuggestionretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/suggestion | 
[**aiMentorOrgsUsersSessionsTasksRetrieve**](AiMentorApi.md#aimentororgsuserssessionstasksretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/tasks/{task_id}/ | 
[**aiMentorOrgsUsersSessionsUpdate**](AiMentorApi.md#aimentororgsuserssessionsupdate) | **PUT** /api/ai-mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/ | 
[**aiMentorOrgsUsersTasksRetrieve**](AiMentorApi.md#aimentororgsuserstasksretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/tasks/{task_id} | 
[**aiMentorOrgsUsersTasksSessionsCreate**](AiMentorApi.md#aimentororgsuserstaskssessionscreate) | **POST** /api/ai-mentor/orgs/{org}/users/{user_id}/tasks/sessions/{session_id}/ | 
[**aiMentorOrgsUsersUpdate**](AiMentorApi.md#aimentororgsusersupdate) | **PUT** /api/ai-mentor/orgs/{org}/users/{user_id}/{name}/ | 
[**aiMentorOrgsUsersUsageRetrieve**](AiMentorApi.md#aimentororgsusersusageretrieve) | **GET** /api/ai-mentor/orgs/{org}/users/{user_id}/usage/ | 


# **aiMentorGenerationsStopGenerationCreate**
> WebSocketStopGenerationView aiMentorGenerationsStopGenerationCreate(generationId)



     Stop websocket generation     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String generationId = generationId_example; // String | 

try {
    final response = api.aiMentorGenerationsStopGenerationCreate(generationId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorGenerationsStopGenerationCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **generationId** | **String**|  | 

### Return type

[**WebSocketStopGenerationView**](WebSocketStopGenerationView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsSessionsCreate**
> ChatSessionResponse aiMentorOrgsSessionsCreate(org, chatSessionRequest)



Create a new chat session

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final ChatSessionRequest chatSessionRequest = ; // ChatSessionRequest | 

try {
    final response = api.aiMentorOrgsSessionsCreate(org, chatSessionRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsSessionsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **chatSessionRequest** | [**ChatSessionRequest**](ChatSessionRequest.md)|  | 

### Return type

[**ChatSessionResponse**](ChatSessionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersAudioToTextCreate**
> AudioToTextResponse aiMentorOrgsUsersAudioToTextCreate(org, userId, audioToTextRequest)



     Convert audio to text     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final AudioToTextRequest audioToTextRequest = ; // AudioToTextRequest | 

try {
    final response = api.aiMentorOrgsUsersAudioToTextCreate(org, userId, audioToTextRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersAudioToTextCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **audioToTextRequest** | [**AudioToTextRequest**](AudioToTextRequest.md)|  | 

### Return type

[**AudioToTextResponse**](AudioToTextResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersCategoryCreate**
> PromptCategory aiMentorOrgsUsersCategoryCreate(org, userId, promptCategory)



View to create/retrieve a prompt category  Only users with the IsAdminUserOrStudentDRFMixin permission can view the categories Only users with the IsPlatformAdminDRFMixin permission can create categories

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final PromptCategory promptCategory = ; // PromptCategory | 

try {
    final response = api.aiMentorOrgsUsersCategoryCreate(org, userId, promptCategory);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersCategoryCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **promptCategory** | [**PromptCategory**](PromptCategory.md)|  | 

### Return type

[**PromptCategory**](PromptCategory.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersCategoryDestroy**
> aiMentorOrgsUsersCategoryDestroy(org, userId)



View to create/retrieve a prompt category  Only users with the IsAdminUserOrStudentDRFMixin permission can view the categories Only users with the IsPlatformAdminDRFMixin permission can create categories

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    api.aiMentorOrgsUsersCategoryDestroy(org, userId);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersCategoryDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersCategoryRetrieve**
> PromptCategory aiMentorOrgsUsersCategoryRetrieve(org, userId)



View to create/retrieve a prompt category  Only users with the IsAdminUserOrStudentDRFMixin permission can view the categories Only users with the IsPlatformAdminDRFMixin permission can create categories

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiMentorOrgsUsersCategoryRetrieve(org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersCategoryRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**PromptCategory**](PromptCategory.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersCreate**
> Mentor aiMentorOrgsUsersCreate(org, userId, mentor)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final Mentor mentor = ; // Mentor | 

try {
    final response = api.aiMentorOrgsUsersCreate(org, userId, mentor);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **mentor** | [**Mentor**](Mentor.md)|  | 

### Return type

[**Mentor**](Mentor.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersDestroy**
> aiMentorOrgsUsersDestroy(name, org, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String name = name_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    api.aiMentorOrgsUsersDestroy(name, org, userId);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersFreeUsageCountRetrieve**
> FreeUsageCount aiMentorOrgsUsersFreeUsageCountRetrieve(org, userId)



Retrieve the number of questions left for a tenant

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiMentorOrgsUsersFreeUsageCountRetrieve(org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersFreeUsageCountRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**FreeUsageCount**](FreeUsageCount.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersList**
> PaginatedMentorList aiMentorOrgsUsersList(org, userId, page, pageSize)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final int page = 56; // int | A page number within the paginated result set.
final int pageSize = 56; // int | Number of results to return per page.

try {
    final response = api.aiMentorOrgsUsersList(org, userId, page, pageSize);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **page** | **int**| A page number within the paginated result set. | [optional] 
 **pageSize** | **int**| Number of results to return per page. | [optional] 

### Return type

[**PaginatedMentorList**](PaginatedMentorList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersMentorFeedbackCreateCreate**
> UserChatFeedback aiMentorOrgsUsersMentorFeedbackCreateCreate(org, userId, userChatFeedback)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final UserChatFeedback userChatFeedback = ; // UserChatFeedback | 

try {
    final response = api.aiMentorOrgsUsersMentorFeedbackCreateCreate(org, userId, userChatFeedback);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersMentorFeedbackCreateCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **userChatFeedback** | [**UserChatFeedback**](UserChatFeedback.md)|  | 

### Return type

[**UserChatFeedback**](UserChatFeedback.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersMentorFeedbackRetrieve**
> UserChatFeedback aiMentorOrgsUsersMentorFeedbackRetrieve(feedbackId, org, userId)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final int feedbackId = 56; // int | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiMentorOrgsUsersMentorFeedbackRetrieve(feedbackId, org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersMentorFeedbackRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **feedbackId** | **int**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**UserChatFeedback**](UserChatFeedback.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersMentorFeedbackUpdate**
> UserChatFeedback aiMentorOrgsUsersMentorFeedbackUpdate(feedbackId, org, userId, userChatFeedback)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final int feedbackId = 56; // int | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final UserChatFeedback userChatFeedback = ; // UserChatFeedback | 

try {
    final response = api.aiMentorOrgsUsersMentorFeedbackUpdate(feedbackId, org, userId, userChatFeedback);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersMentorFeedbackUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **feedbackId** | **int**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **userChatFeedback** | [**UserChatFeedback**](UserChatFeedback.md)|  | 

### Return type

[**UserChatFeedback**](UserChatFeedback.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersMentorFromTemplateCreate**
> Mentor aiMentorOrgsUsersMentorFromTemplateCreate(org, userId, mentorFromTemplateRequest)



View to create a mentor from a template

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final MentorFromTemplateRequest mentorFromTemplateRequest = ; // MentorFromTemplateRequest | 

try {
    final response = api.aiMentorOrgsUsersMentorFromTemplateCreate(org, userId, mentorFromTemplateRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersMentorFromTemplateCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **mentorFromTemplateRequest** | [**MentorFromTemplateRequest**](MentorFromTemplateRequest.md)|  | 

### Return type

[**Mentor**](Mentor.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersMentorLlmsRetrieve**
> MentorLLMFlowResponse aiMentorOrgsUsersMentorLlmsRetrieve(org, userId)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiMentorOrgsUsersMentorLlmsRetrieve(org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersMentorLlmsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**MentorLLMFlowResponse**](MentorLLMFlowResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersMentorWithSettingsCreate**
> Mentor aiMentorOrgsUsersMentorWithSettingsCreate(org, userId, mentorFromTemplateWithSettingRequest)



View to create a mentor from a template with settings

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final MentorFromTemplateWithSettingRequest mentorFromTemplateWithSettingRequest = ; // MentorFromTemplateWithSettingRequest | 

try {
    final response = api.aiMentorOrgsUsersMentorWithSettingsCreate(org, userId, mentorFromTemplateWithSettingRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersMentorWithSettingsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **mentorFromTemplateWithSettingRequest** | [**MentorFromTemplateWithSettingRequest**](MentorFromTemplateWithSettingRequest.md)|  | 

### Return type

[**Mentor**](Mentor.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersMentorsPublicSettingsRetrieve**
> MentorSettings aiMentorOrgsUsersMentorsPublicSettingsRetrieve(mentor, org, userId)



Get mentor settings

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String mentor = mentor_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiMentorOrgsUsersMentorsPublicSettingsRetrieve(mentor, org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersMentorsPublicSettingsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**MentorSettings**](MentorSettings.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersMentorsRetrieve**
> SessionDetail aiMentorOrgsUsersMentorsRetrieve(mentor, org, userId)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String mentor = mentor_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiMentorOrgsUsersMentorsRetrieve(mentor, org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersMentorsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**SessionDetail**](SessionDetail.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersMentorsSettingsRetrieve**
> MentorSettings aiMentorOrgsUsersMentorsSettingsRetrieve(mentor, org, userId)



Get mentor settings

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String mentor = mentor_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiMentorOrgsUsersMentorsSettingsRetrieve(mentor, org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersMentorsSettingsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**MentorSettings**](MentorSettings.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersMentorsSettingsUpdate**
> MentorSettings aiMentorOrgsUsersMentorsSettingsUpdate(mentor, org, userId, mentorSettingsRequest)



Update mentor settings

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String mentor = mentor_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final MentorSettingsRequest mentorSettingsRequest = ; // MentorSettingsRequest | 

try {
    final response = api.aiMentorOrgsUsersMentorsSettingsUpdate(mentor, org, userId, mentorSettingsRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersMentorsSettingsUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **mentorSettingsRequest** | [**MentorSettingsRequest**](MentorSettingsRequest.md)|  | [optional] 

### Return type

[**MentorSettings**](MentorSettings.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersPartialUpdate**
> Mentor aiMentorOrgsUsersPartialUpdate(name, org, userId, patchedMentor)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String name = name_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final PatchedMentor patchedMentor = ; // PatchedMentor | 

try {
    final response = api.aiMentorOrgsUsersPartialUpdate(name, org, userId, patchedMentor);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **patchedMentor** | [**PatchedMentor**](PatchedMentor.md)|  | [optional] 

### Return type

[**Mentor**](Mentor.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersPinMessageCreate**
> PinnedMessageCreate aiMentorOrgsUsersPinMessageCreate(org, userId, pinnedMessageCreate)



View to create/retrieve a pinned message

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final PinnedMessageCreate pinnedMessageCreate = ; // PinnedMessageCreate | 

try {
    final response = api.aiMentorOrgsUsersPinMessageCreate(org, userId, pinnedMessageCreate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersPinMessageCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **pinnedMessageCreate** | [**PinnedMessageCreate**](PinnedMessageCreate.md)|  | 

### Return type

[**PinnedMessageCreate**](PinnedMessageCreate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersPinMessageDestroy**
> aiMentorOrgsUsersPinMessageDestroy(org, userId)



View to create/retrieve a pinned message

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    api.aiMentorOrgsUsersPinMessageDestroy(org, userId);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersPinMessageDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersPinMessageRetrieve**
> PinnedMessageCreate aiMentorOrgsUsersPinMessageRetrieve(org, userId)



View to create/retrieve a pinned message

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiMentorOrgsUsersPinMessageRetrieve(org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersPinMessageRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**PinnedMessageCreate**](PinnedMessageCreate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersPredictiveAnalyticsCreate**
> PredictiveAnalyticsResponse aiMentorOrgsUsersPredictiveAnalyticsCreate(org, userId, predictiveAnalyticsRequest)



     Send data  for  predictions     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final PredictiveAnalyticsRequest predictiveAnalyticsRequest = ; // PredictiveAnalyticsRequest | 

try {
    final response = api.aiMentorOrgsUsersPredictiveAnalyticsCreate(org, userId, predictiveAnalyticsRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersPredictiveAnalyticsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **predictiveAnalyticsRequest** | [**PredictiveAnalyticsRequest**](PredictiveAnalyticsRequest.md)|  | 

### Return type

[**PredictiveAnalyticsResponse**](PredictiveAnalyticsResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersRecentMessagesRetrieve**
> ChatSessionWithMessage aiMentorOrgsUsersRecentMessagesRetrieve(org, userId)



Paginated view to return recent messages

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiMentorOrgsUsersRecentMessagesRetrieve(org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersRecentMessagesRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**ChatSessionWithMessage**](ChatSessionWithMessage.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersRecommendCoursesRetrieve**
> RecommendCourseResponse aiMentorOrgsUsersRecommendCoursesRetrieve(org, userId, includeLearnerSkills, rankByDifficulty, returnCourseData, returnNumber, searchTerms)



     Recommend courses for a user     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final bool includeLearnerSkills = true; // bool | Include available learner skills for search
final bool rankByDifficulty = true; // bool | Rank by course difficulty
final bool returnCourseData = true; // bool | Return course data
final int returnNumber = 56; // int | Number of courses to return
final String searchTerms = searchTerms_example; // String | Terms to be searched

try {
    final response = api.aiMentorOrgsUsersRecommendCoursesRetrieve(org, userId, includeLearnerSkills, rankByDifficulty, returnCourseData, returnNumber, searchTerms);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersRecommendCoursesRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **includeLearnerSkills** | **bool**| Include available learner skills for search | [optional] [default to true]
 **rankByDifficulty** | **bool**| Rank by course difficulty | [optional] [default to false]
 **returnCourseData** | **bool**| Return course data | [optional] [default to false]
 **returnNumber** | **int**| Number of courses to return | [optional] 
 **searchTerms** | **String**| Terms to be searched | [optional] 

### Return type

[**RecommendCourseResponse**](RecommendCourseResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersRetrieve**
> Mentor aiMentorOrgsUsersRetrieve(name, org, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String name = name_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiMentorOrgsUsersRetrieve(name, org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**Mentor**](Mentor.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersSessionidList**
> BuiltList<ChatHistorySessionId> aiMentorOrgsUsersSessionidList(endDate, org, startDate, userId)



View to get the sessions of a particular user filterable by start date and end date without pagination

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String endDate = endDate_example; // String | 
final String org = org_example; // String | 
final String startDate = startDate_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiMentorOrgsUsersSessionidList(endDate, org, startDate, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersSessionidList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **endDate** | **String**|  | 
 **org** | **String**|  | 
 **startDate** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**BuiltList&lt;ChatHistorySessionId&gt;**](ChatHistorySessionId.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersSessionsCreate**
> ChatSessionResponse aiMentorOrgsUsersSessionsCreate(org, userId, chatSessionRequest)



Create a new chat session

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final ChatSessionRequest chatSessionRequest = ; // ChatSessionRequest | 

try {
    final response = api.aiMentorOrgsUsersSessionsCreate(org, userId, chatSessionRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersSessionsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **chatSessionRequest** | [**ChatSessionRequest**](ChatSessionRequest.md)|  | 

### Return type

[**ChatSessionResponse**](ChatSessionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersSessionsDestroy**
> aiMentorOrgsUsersSessionsDestroy(org, sessionId, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final String userId = userId_example; // String | 

try {
    api.aiMentorOrgsUsersSessionsDestroy(org, sessionId, userId);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersSessionsDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersSessionsDownloadSessionRetrieve**
> ChatHistoryItem aiMentorOrgsUsersSessionsDownloadSessionRetrieve(org, sessionId, userId)



View to add the downloadable message for a session

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiMentorOrgsUsersSessionsDownloadSessionRetrieve(org, sessionId, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersSessionsDownloadSessionRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**ChatHistoryItem**](ChatHistoryItem.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersSessionsRetrieve**
> MessageView aiMentorOrgsUsersSessionsRetrieve(org, sessionId, userId, share)



     Get chat messages     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final String userId = userId_example; // String | 
final bool share = true; // bool | 

try {
    final response = api.aiMentorOrgsUsersSessionsRetrieve(org, sessionId, userId, share);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersSessionsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 
 **share** | **bool**|  | [optional] [default to false]

### Return type

[**MessageView**](MessageView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersSessionsSuggestionRetrieve**
> RelatedText aiMentorOrgsUsersSessionsSuggestionRetrieve(org, sessionId, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiMentorOrgsUsersSessionsSuggestionRetrieve(org, sessionId, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersSessionsSuggestionRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**RelatedText**](RelatedText.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersSessionsTasksRetrieve**
> ChatHistoryItem aiMentorOrgsUsersSessionsTasksRetrieve(org, sessionId, taskId, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final String taskId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiMentorOrgsUsersSessionsTasksRetrieve(org, sessionId, taskId, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersSessionsTasksRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **taskId** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**ChatHistoryItem**](ChatHistoryItem.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersSessionsUpdate**
> MessageViewUpdatResponse aiMentorOrgsUsersSessionsUpdate(org, sessionId, userId, messageViewRequest)



     Update Chat session details     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final String userId = userId_example; // String | 
final MessageViewRequest messageViewRequest = ; // MessageViewRequest | 

try {
    final response = api.aiMentorOrgsUsersSessionsUpdate(org, sessionId, userId, messageViewRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersSessionsUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 
 **messageViewRequest** | [**MessageViewRequest**](MessageViewRequest.md)|  | [optional] 

### Return type

[**MessageViewUpdatResponse**](MessageViewUpdatResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersTasksRetrieve**
> RetrieveTask aiMentorOrgsUsersTasksRetrieve(org, taskId, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String taskId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiMentorOrgsUsersTasksRetrieve(org, taskId, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersTasksRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **taskId** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**RetrieveTask**](RetrieveTask.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersTasksSessionsCreate**
> TaskView aiMentorOrgsUsersTasksSessionsCreate(org, sessionId, userId, taskView)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final String userId = userId_example; // String | 
final TaskView taskView = ; // TaskView | 

try {
    final response = api.aiMentorOrgsUsersTasksSessionsCreate(org, sessionId, userId, taskView);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersTasksSessionsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 
 **taskView** | [**TaskView**](TaskView.md)|  | 

### Return type

[**TaskView**](TaskView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersUpdate**
> Mentor aiMentorOrgsUsersUpdate(name, org, userId, mentor)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String name = name_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final Mentor mentor = ; // Mentor | 

try {
    final response = api.aiMentorOrgsUsersUpdate(name, org, userId, mentor);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **mentor** | [**Mentor**](Mentor.md)|  | 

### Return type

[**Mentor**](Mentor.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersUsageRetrieve**
> Usage aiMentorOrgsUsersUsageRetrieve(org, userId)



View to return the usage summary of a tenant

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiMentorApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiMentorOrgsUsersUsageRetrieve(org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiMentorApi->aiMentorOrgsUsersUsageRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**Usage**](Usage.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

