# ibl_ai_data_manager_sdk.api.AiPromptApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**aiPromptOrgsUsersMentorsSuggestedPromptsCreate**](AiPromptApi.md#aipromptorgsusersmentorssuggestedpromptscreate) | **POST** /api/ai-prompt/orgs/{org}/users/{user_id}/mentors/{mentor}/suggested-prompts/ | 
[**aiPromptOrgsUsersMentorsSuggestedPromptsDestroy**](AiPromptApi.md#aipromptorgsusersmentorssuggestedpromptsdestroy) | **DELETE** /api/ai-prompt/orgs/{org}/users/{user_id}/mentors/{mentor}/suggested-prompts/ | 
[**aiPromptOrgsUsersMentorsSuggestedPromptsRetrieve**](AiPromptApi.md#aipromptorgsusersmentorssuggestedpromptsretrieve) | **GET** /api/ai-prompt/orgs/{org}/users/{user_id}/mentors/{mentor}/suggested-prompts/ | 
[**aiPromptOrgsUsersMentorsSuggestedPromptsUpdate**](AiPromptApi.md#aipromptorgsusersmentorssuggestedpromptsupdate) | **PUT** /api/ai-prompt/orgs/{org}/users/{user_id}/mentors/{mentor}/suggested-prompts/ | 
[**aiPromptOrgsUsersPromptCreate**](AiPromptApi.md#aipromptorgsuserspromptcreate) | **POST** /api/ai-prompt/orgs/{org}/users/{user_id}/prompt/ | 
[**aiPromptOrgsUsersPromptDestroy**](AiPromptApi.md#aipromptorgsuserspromptdestroy) | **DELETE** /api/ai-prompt/orgs/{org}/users/{user_id}/prompt/{id}/ | 
[**aiPromptOrgsUsersPromptList**](AiPromptApi.md#aipromptorgsuserspromptlist) | **GET** /api/ai-prompt/orgs/{org}/users/{user_id}/prompt/ | 
[**aiPromptOrgsUsersPromptPartialUpdate**](AiPromptApi.md#aipromptorgsuserspromptpartialupdate) | **PATCH** /api/ai-prompt/orgs/{org}/users/{user_id}/prompt/{id}/ | 
[**aiPromptOrgsUsersPromptRetrieve**](AiPromptApi.md#aipromptorgsuserspromptretrieve) | **GET** /api/ai-prompt/orgs/{org}/users/{user_id}/prompt/{id}/ | 
[**aiPromptOrgsUsersPromptUpdate**](AiPromptApi.md#aipromptorgsuserspromptupdate) | **PUT** /api/ai-prompt/orgs/{org}/users/{user_id}/prompt/{id}/ | 
[**aiPromptOrgsUsersPromptsCategoryCreate**](AiPromptApi.md#aipromptorgsuserspromptscategorycreate) | **POST** /api/ai-prompt/orgs/{org}/users/{user_id}/prompts/category/ | 
[**aiPromptOrgsUsersPromptsCategoryDestroy**](AiPromptApi.md#aipromptorgsuserspromptscategorydestroy) | **DELETE** /api/ai-prompt/orgs/{org}/users/{user_id}/prompts/category/ | 
[**aiPromptOrgsUsersPromptsCategoryRetrieve**](AiPromptApi.md#aipromptorgsuserspromptscategoryretrieve) | **GET** /api/ai-prompt/orgs/{org}/users/{user_id}/prompts/category/ | 
[**aiPromptOrgsUsersSessionsGuidedPromptsRetrieve**](AiPromptApi.md#aipromptorgsuserssessionsguidedpromptsretrieve) | **GET** /api/ai-prompt/orgs/{org}/users/{user_id}/sessions/{session_id}/guided-prompts/ | 


# **aiPromptOrgsUsersMentorsSuggestedPromptsCreate**
> DefaultResponse aiPromptOrgsUsersMentorsSuggestedPromptsCreate(mentor, org, userId, suggestedPrompt)



Suggested Prompts Endpoint

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiPromptApi();
final String mentor = mentor_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final SuggestedPrompt suggestedPrompt = ; // SuggestedPrompt | 

try {
    final response = api.aiPromptOrgsUsersMentorsSuggestedPromptsCreate(mentor, org, userId, suggestedPrompt);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiPromptApi->aiPromptOrgsUsersMentorsSuggestedPromptsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **suggestedPrompt** | [**SuggestedPrompt**](SuggestedPrompt.md)|  | 

### Return type

[**DefaultResponse**](DefaultResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiPromptOrgsUsersMentorsSuggestedPromptsDestroy**
> aiPromptOrgsUsersMentorsSuggestedPromptsDestroy(mentor, org, userId)



Request body  {\"index\": 0}

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiPromptApi();
final String mentor = mentor_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    api.aiPromptOrgsUsersMentorsSuggestedPromptsDestroy(mentor, org, userId);
} catch on DioException (e) {
    print('Exception when calling AiPromptApi->aiPromptOrgsUsersMentorsSuggestedPromptsDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiPromptOrgsUsersMentorsSuggestedPromptsRetrieve**
> SuggestedPrompts aiPromptOrgsUsersMentorsSuggestedPromptsRetrieve(mentor, org, userId)



Suggested Prompts Endpoint

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiPromptApi();
final String mentor = mentor_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiPromptOrgsUsersMentorsSuggestedPromptsRetrieve(mentor, org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiPromptApi->aiPromptOrgsUsersMentorsSuggestedPromptsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**SuggestedPrompts**](SuggestedPrompts.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiPromptOrgsUsersMentorsSuggestedPromptsUpdate**
> DefaultResponse aiPromptOrgsUsersMentorsSuggestedPromptsUpdate(mentor, org, userId, suggestedPromptIndex)



Suggested Prompts Endpoint

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiPromptApi();
final String mentor = mentor_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final SuggestedPromptIndex suggestedPromptIndex = ; // SuggestedPromptIndex | 

try {
    final response = api.aiPromptOrgsUsersMentorsSuggestedPromptsUpdate(mentor, org, userId, suggestedPromptIndex);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiPromptApi->aiPromptOrgsUsersMentorsSuggestedPromptsUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **suggestedPromptIndex** | [**SuggestedPromptIndex**](SuggestedPromptIndex.md)|  | 

### Return type

[**DefaultResponse**](DefaultResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiPromptOrgsUsersPromptCreate**
> Prompt aiPromptOrgsUsersPromptCreate(org, userId, prompt)



View to create/retrieve a prompt

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiPromptApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final Prompt prompt = ; // Prompt | 

try {
    final response = api.aiPromptOrgsUsersPromptCreate(org, userId, prompt);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiPromptApi->aiPromptOrgsUsersPromptCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **prompt** | [**Prompt**](Prompt.md)|  | 

### Return type

[**Prompt**](Prompt.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiPromptOrgsUsersPromptDestroy**
> aiPromptOrgsUsersPromptDestroy(id, org, userId)



View to create/retrieve a prompt

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiPromptApi();
final int id = 56; // int | A unique integer value identifying this prompt.
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    api.aiPromptOrgsUsersPromptDestroy(id, org, userId);
} catch on DioException (e) {
    print('Exception when calling AiPromptApi->aiPromptOrgsUsersPromptDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this prompt. | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiPromptOrgsUsersPromptList**
> BuiltList<Prompt> aiPromptOrgsUsersPromptList(org, userId)



View to create/retrieve a prompt

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiPromptApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiPromptOrgsUsersPromptList(org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiPromptApi->aiPromptOrgsUsersPromptList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**BuiltList&lt;Prompt&gt;**](Prompt.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiPromptOrgsUsersPromptPartialUpdate**
> Prompt aiPromptOrgsUsersPromptPartialUpdate(id, org, userId, patchedPrompt)



View to create/retrieve a prompt

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiPromptApi();
final int id = 56; // int | A unique integer value identifying this prompt.
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final PatchedPrompt patchedPrompt = ; // PatchedPrompt | 

try {
    final response = api.aiPromptOrgsUsersPromptPartialUpdate(id, org, userId, patchedPrompt);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiPromptApi->aiPromptOrgsUsersPromptPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this prompt. | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **patchedPrompt** | [**PatchedPrompt**](PatchedPrompt.md)|  | [optional] 

### Return type

[**Prompt**](Prompt.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiPromptOrgsUsersPromptRetrieve**
> Prompt aiPromptOrgsUsersPromptRetrieve(id, org, userId)



View to create/retrieve a prompt

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiPromptApi();
final int id = 56; // int | A unique integer value identifying this prompt.
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiPromptOrgsUsersPromptRetrieve(id, org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiPromptApi->aiPromptOrgsUsersPromptRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this prompt. | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**Prompt**](Prompt.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiPromptOrgsUsersPromptUpdate**
> Prompt aiPromptOrgsUsersPromptUpdate(id, org, userId, prompt)



View to create/retrieve a prompt

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiPromptApi();
final int id = 56; // int | A unique integer value identifying this prompt.
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final Prompt prompt = ; // Prompt | 

try {
    final response = api.aiPromptOrgsUsersPromptUpdate(id, org, userId, prompt);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiPromptApi->aiPromptOrgsUsersPromptUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this prompt. | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **prompt** | [**Prompt**](Prompt.md)|  | 

### Return type

[**Prompt**](Prompt.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiPromptOrgsUsersPromptsCategoryCreate**
> PromptCategory aiPromptOrgsUsersPromptsCategoryCreate(org, userId, promptCategory)



View to create/retrieve a prompt category  Only users with the IsAdminUserOrStudentDRFMixin permission can view the categories Only users with the IsPlatformAdminDRFMixin permission can create categories

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiPromptApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final PromptCategory promptCategory = ; // PromptCategory | 

try {
    final response = api.aiPromptOrgsUsersPromptsCategoryCreate(org, userId, promptCategory);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiPromptApi->aiPromptOrgsUsersPromptsCategoryCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **promptCategory** | [**PromptCategory**](PromptCategory.md)|  | 

### Return type

[**PromptCategory**](PromptCategory.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiPromptOrgsUsersPromptsCategoryDestroy**
> aiPromptOrgsUsersPromptsCategoryDestroy(org, userId)



View to create/retrieve a prompt category  Only users with the IsAdminUserOrStudentDRFMixin permission can view the categories Only users with the IsPlatformAdminDRFMixin permission can create categories

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiPromptApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    api.aiPromptOrgsUsersPromptsCategoryDestroy(org, userId);
} catch on DioException (e) {
    print('Exception when calling AiPromptApi->aiPromptOrgsUsersPromptsCategoryDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiPromptOrgsUsersPromptsCategoryRetrieve**
> PromptCategory aiPromptOrgsUsersPromptsCategoryRetrieve(org, userId)



View to create/retrieve a prompt category  Only users with the IsAdminUserOrStudentDRFMixin permission can view the categories Only users with the IsPlatformAdminDRFMixin permission can create categories

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiPromptApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiPromptOrgsUsersPromptsCategoryRetrieve(org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiPromptApi->aiPromptOrgsUsersPromptsCategoryRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**PromptCategory**](PromptCategory.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiPromptOrgsUsersSessionsGuidedPromptsRetrieve**
> GuidedPromptsResponse aiPromptOrgsUsersSessionsGuidedPromptsRetrieve(org, sessionId, userId)



     Get suggested AI prompts based on chat history     

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAiPromptApi();
final String org = org_example; // String | 
final String sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.aiPromptOrgsUsersSessionsGuidedPromptsRetrieve(org, sessionId, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AiPromptApi->aiPromptOrgsUsersSessionsGuidedPromptsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**GuidedPromptsResponse**](GuidedPromptsResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

