# ibl_ai_data_manager_sdk.api.AudienceApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**audienceOrgsActiveUsersOverTimeRetrieve**](AudienceApi.md#audienceorgsactiveusersovertimeretrieve) | **GET** /api/audience/orgs/{org}/active-users/over-time | 
[**audienceOrgsActiveUsersPerCourseRetrieve**](AudienceApi.md#audienceorgsactiveuserspercourseretrieve) | **GET** /api/audience/orgs/{org}/active-users/per-course | 
[**audienceOrgsActiveUsersUsersRetrieve**](AudienceApi.md#audienceorgsactiveusersusersretrieve) | **GET** /api/audience/orgs/{org}/active-users/users | 
[**audienceOrgsEnrollmentsCoursesOverTimeRetrieve**](AudienceApi.md#audienceorgsenrollmentscoursesovertimeretrieve) | **GET** /api/audience/orgs/{org}/enrollments/courses/{course_id}/over-time | 
[**audienceOrgsEnrollmentsCoursesUsersRetrieve**](AudienceApi.md#audienceorgsenrollmentscoursesusersretrieve) | **GET** /api/audience/orgs/{org}/enrollments/courses/{course_id}/users | 
[**audienceOrgsEnrollmentsOverTimeRetrieve**](AudienceApi.md#audienceorgsenrollmentsovertimeretrieve) | **GET** /api/audience/orgs/{org}/enrollments/over-time | 
[**audienceOrgsEnrollmentsPerCourseRetrieve**](AudienceApi.md#audienceorgsenrollmentspercourseretrieve) | **GET** /api/audience/orgs/{org}/enrollments/per-course | 
[**audienceOrgsRegisteredUsersOverTimeRetrieve**](AudienceApi.md#audienceorgsregisteredusersovertimeretrieve) | **GET** /api/audience/orgs/{org}/registered-users/over-time | 
[**audienceOrgsRegisteredUsersPerCourseRetrieve**](AudienceApi.md#audienceorgsregistereduserspercourseretrieve) | **GET** /api/audience/orgs/{org}/registered-users/per-course | 
[**audienceOrgsRegisteredUsersRetrieve**](AudienceApi.md#audienceorgsregisteredusersretrieve) | **GET** /api/audience/orgs/{org}/registered-users/ | 


# **audienceOrgsActiveUsersOverTimeRetrieve**
> OvertimeWithChangeInfo audienceOrgsActiveUsersOverTimeRetrieve(org, endDate, format, groupId, startDate)



Count of users with known activity within the past 30 days on a per day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive) Returns ``` {     \"data\": {         \"2022-04-26\": 0,         \"2022-04-27\": 0,         \"2022-04-28\": 0,         \"2022-04-29\": 60,         ...         \"2022-05-05\": 0     },     \"total\": 60,     \"meta\": {         \"change_last_seven_days\": 0,         \"change_last_seven_days_percent\": 0.0,         \"change_last_thirty_days\": 0,         \"change_last_thirty_days_percent\": 0.0,         \"change_range\": 0,         \"change_range_percent\": 0.0,         \"total\": 0,     } }

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAudienceApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.audienceOrgsActiveUsersOverTimeRetrieve(org, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AudienceApi->audienceOrgsActiveUsersOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**OvertimeWithChangeInfo**](OvertimeWithChangeInfo.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **audienceOrgsActiveUsersPerCourseRetrieve**
> ActiveUsersPerCourse audienceOrgsActiveUsersPerCourseRetrieve(org, endDate, format, groupId, startDate)



Count of users with known activity within specified date_range on a per-course basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAudienceApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.audienceOrgsActiveUsersPerCourseRetrieve(org, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AudienceApi->audienceOrgsActiveUsersPerCourseRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**ActiveUsersPerCourse**](ActiveUsersPerCourse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **audienceOrgsActiveUsersUsersRetrieve**
> ActiveUsersList audienceOrgsActiveUsersUsersRetrieve(org, format, groupId, length, page)



List of users with known activity within the specified date range  default is all time  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10 3. course_id <optional> e.g course-v1:Org+Course4+Run  Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAudienceApi();
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final int length = 56; // int | Size of data to return
final int page = 56; // int | Page offset

try {
    final response = api.audienceOrgsActiveUsersUsersRetrieve(org, format, groupId, length, page);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AudienceApi->audienceOrgsActiveUsersUsersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **length** | **int**| Size of data to return | [optional] 
 **page** | **int**| Page offset | [optional] 

### Return type

[**ActiveUsersList**](ActiveUsersList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **audienceOrgsEnrollmentsCoursesOverTimeRetrieve**
> OvertimeWithChangeInfo audienceOrgsEnrollmentsCoursesOverTimeRetrieve(courseId, org, active, endDate, format, groupId, startDate)



Aggregated count of  new enrollments/ unenrollments on a per day basis   Params 1. course_id <optional> e.g course-v1:Org+Course4+Run 2. start_date e.g 2020-10-01 3. end_date e.g 2020-10-10 4. active e.g true/false would mean not active enrollments  Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAudienceApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String active = active_example; // String | Any of `y`, `yes`, `true`. set to false or no for unenrollments   * `y` - y * `yes` - yes * `true` - true * `True` - True * `n` - n * `no` - no * `false` - false * `False` - False
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.audienceOrgsEnrollmentsCoursesOverTimeRetrieve(courseId, org, active, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AudienceApi->audienceOrgsEnrollmentsCoursesOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **active** | **String**| Any of `y`, `yes`, `true`. set to false or no for unenrollments   * `y` - y * `yes` - yes * `true` - true * `True` - True * `n` - n * `no` - no * `false` - false * `False` - False | [optional] [default to 'y']
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**OvertimeWithChangeInfo**](OvertimeWithChangeInfo.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **audienceOrgsEnrollmentsCoursesUsersRetrieve**
> EnrollmentsPerUser audienceOrgsEnrollmentsCoursesUsersRetrieve(courseId, org, active, endDate, format, groupId, length, page, startDate)



List of users who are enrolled/not enrolled in specified course  Query Params 1. course_id 2. active e.g true/false would mean not active enrollments

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAudienceApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String active = active_example; // String | Any of `y`, `yes`, `true`. set to false or no for unenrollments   * `y` - y * `yes` - yes * `true` - true * `True` - True * `n` - n * `no` - no * `false` - false * `False` - False
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final int length = 56; // int | Size of data to return
final int page = 56; // int | Page offset
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.audienceOrgsEnrollmentsCoursesUsersRetrieve(courseId, org, active, endDate, format, groupId, length, page, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AudienceApi->audienceOrgsEnrollmentsCoursesUsersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **active** | **String**| Any of `y`, `yes`, `true`. set to false or no for unenrollments   * `y` - y * `yes` - yes * `true` - true * `True` - True * `n` - n * `no` - no * `false` - false * `False` - False | [optional] [default to 'y']
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **length** | **int**| Size of data to return | [optional] 
 **page** | **int**| Page offset | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**EnrollmentsPerUser**](EnrollmentsPerUser.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **audienceOrgsEnrollmentsOverTimeRetrieve**
> OvertimeWithChangeInfo audienceOrgsEnrollmentsOverTimeRetrieve(org, active, endDate, format, groupId, startDate)



Aggregated count of  new enrollments/ unenrollments on a per day basis   Params 1. course_id <optional> e.g course-v1:Org+Course4+Run 2. start_date e.g 2020-10-01 3. end_date e.g 2020-10-10 4. active e.g true/false would mean not active enrollments  Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAudienceApi();
final String org = org_example; // String | 
final String active = active_example; // String | Any of `y`, `yes`, `true`. set to false or no for unenrollments   * `y` - y * `yes` - yes * `true` - true * `True` - True * `n` - n * `no` - no * `false` - false * `False` - False
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.audienceOrgsEnrollmentsOverTimeRetrieve(org, active, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AudienceApi->audienceOrgsEnrollmentsOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **active** | **String**| Any of `y`, `yes`, `true`. set to false or no for unenrollments   * `y` - y * `yes` - yes * `true` - true * `True` - True * `n` - n * `no` - no * `false` - false * `False` - False | [optional] [default to 'y']
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**OvertimeWithChangeInfo**](OvertimeWithChangeInfo.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **audienceOrgsEnrollmentsPerCourseRetrieve**
> Enrollments audienceOrgsEnrollmentsPerCourseRetrieve(org, active, endDate, format, groupId, length, page, startDate)



Aggregated count of active/inactive enrollments on a per course basis Query Params     active e.g true/false would mean not active enrollments

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAudienceApi();
final String org = org_example; // String | 
final String active = active_example; // String | Any of `y`, `yes`, `true`. set to false or no for unenrollments   * `y` - y * `yes` - yes * `true` - true * `True` - True * `n` - n * `no` - no * `false` - false * `False` - False
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final int length = 56; // int | Size of data to return
final int page = 56; // int | Page offset
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.audienceOrgsEnrollmentsPerCourseRetrieve(org, active, endDate, format, groupId, length, page, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AudienceApi->audienceOrgsEnrollmentsPerCourseRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **active** | **String**| Any of `y`, `yes`, `true`. set to false or no for unenrollments   * `y` - y * `yes` - yes * `true` - true * `True` - True * `n` - n * `no` - no * `false` - false * `False` - False | [optional] [default to 'y']
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **length** | **int**| Size of data to return | [optional] 
 **page** | **int**| Page offset | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Enrollments**](Enrollments.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **audienceOrgsRegisteredUsersOverTimeRetrieve**
> OvertimeWithChangeInfo audienceOrgsRegisteredUsersOverTimeRetrieve(org, endDate, format, groupId, startDate)



Registered users count on a per day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAudienceApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.audienceOrgsRegisteredUsersOverTimeRetrieve(org, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AudienceApi->audienceOrgsRegisteredUsersOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**OvertimeWithChangeInfo**](OvertimeWithChangeInfo.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **audienceOrgsRegisteredUsersPerCourseRetrieve**
> Enrollments audienceOrgsRegisteredUsersPerCourseRetrieve(org, active, endDate, format, groupId, length, page, startDate)



Aggregated count of active/inactive enrollments on a per course basis Query Params     active e.g true/false would mean not active enrollments

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAudienceApi();
final String org = org_example; // String | 
final String active = active_example; // String | Any of `y`, `yes`, `true`. set to false or no for unenrollments   * `y` - y * `yes` - yes * `true` - true * `True` - True * `n` - n * `no` - no * `false` - false * `False` - False
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final int length = 56; // int | Size of data to return
final int page = 56; // int | Page offset
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.audienceOrgsRegisteredUsersPerCourseRetrieve(org, active, endDate, format, groupId, length, page, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AudienceApi->audienceOrgsRegisteredUsersPerCourseRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **active** | **String**| Any of `y`, `yes`, `true`. set to false or no for unenrollments   * `y` - y * `yes` - yes * `true` - true * `True` - True * `n` - n * `no` - no * `false` - false * `False` - False | [optional] [default to 'y']
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **length** | **int**| Size of data to return | [optional] 
 **page** | **int**| Page offset | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Enrollments**](Enrollments.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **audienceOrgsRegisteredUsersRetrieve**
> PerlearnerUserList audienceOrgsRegisteredUsersRetrieve(org, format, groupId, length, page, search)



List of entire learners on the platform with aggregated enrollments, completions and time spent

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getAudienceApi();
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final int length = 56; // int | Size of data to return
final int page = 56; // int | Page offset
final String search = search_example; // String | Search string for learner

try {
    final response = api.audienceOrgsRegisteredUsersRetrieve(org, format, groupId, length, page, search);
    print(response);
} catch on DioException (e) {
    print('Exception when calling AudienceApi->audienceOrgsRegisteredUsersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **length** | **int**| Size of data to return | [optional] 
 **page** | **int**| Page offset | [optional] 
 **search** | **String**| Search string for learner | [optional] 

### Return type

[**PerlearnerUserList**](PerlearnerUserList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

