# ibl_ai_data_manager_sdk.api.CoreApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**coreLauncherCreate**](CoreApi.md#corelaunchercreate) | **POST** /api/core/launcher/ | 
[**coreLauncherRetrieve**](CoreApi.md#corelauncherretrieve) | **GET** /api/core/launcher/ | 
[**corePlatformConfigSiteCreate**](CoreApi.md#coreplatformconfigsitecreate) | **POST** /api/core/platform/config/site/ | 
[**corePlatformConfigSiteRetrieve**](CoreApi.md#coreplatformconfigsiteretrieve) | **GET** /api/core/platform/config/site/ | 
[**corePlatformCreate**](CoreApi.md#coreplatformcreate) | **POST** /api/core/platform/ | 
[**corePlatformRetrieve**](CoreApi.md#coreplatformretrieve) | **GET** /api/core/platform/ | 
[**corePlatformUsersRetrieve**](CoreApi.md#coreplatformusersretrieve) | **GET** /api/core/platform/users/ | 
[**coreSignalsEdxCreate**](CoreApi.md#coresignalsedxcreate) | **POST** /api/core/signals/edx/ | 
[**coreUsersPlatformsCreate**](CoreApi.md#coreusersplatformscreate) | **POST** /api/core/users/platforms/ | 
[**coreUsersPlatformsList**](CoreApi.md#coreusersplatformslist) | **GET** /api/core/users/platforms/ | 
[**coreUsersProxyBulkCreate**](CoreApi.md#coreusersproxybulkcreate) | **POST** /api/core/users/proxy/bulk/ | 
[**coreUsersProxyCreate**](CoreApi.md#coreusersproxycreate) | **POST** /api/core/users/proxy/ | 
[**coreUsersProxyRetrieve**](CoreApi.md#coreusersproxyretrieve) | **GET** /api/core/users/proxy/ | 
[**coreUsersSearchRetrieve**](CoreApi.md#coreuserssearchretrieve) | **GET** /api/core/users/search | 


# **coreLauncherCreate**
> PlatformList coreLauncherCreate(launcherViewPostRequest)



POST: Launch a new edX platform  Params: user_id: The ID of the requesting user (required) key: The Deep LMS subdomain (required) name: The edX platform name (\"optional\") org: The edX organization (\"optional\") lms_url: LMS URL (\"optional\") cms_url: CMS URL (\"optional\") portal_url: Portal URL (\"optional\")

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCoreApi();
final LauncherViewPostRequest launcherViewPostRequest = ; // LauncherViewPostRequest | 

try {
    final response = api.coreLauncherCreate(launcherViewPostRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CoreApi->coreLauncherCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **launcherViewPostRequest** | [**LauncherViewPostRequest**](LauncherViewPostRequest.md)|  | 

### Return type

[**PlatformList**](PlatformList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **coreLauncherRetrieve**
> PlatformList coreLauncherRetrieve(key, userId)



GET Launch status  Params: key user_id: Optional

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCoreApi();
final String key = key_example; // String | 
final int userId = 56; // int | 

try {
    final response = api.coreLauncherRetrieve(key, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CoreApi->coreLauncherRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key** | **String**|  | 
 **userId** | **int**|  | [optional] 

### Return type

[**PlatformList**](PlatformList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **corePlatformConfigSiteCreate**
> BuiltMap<String, JsonObject> corePlatformConfigSiteCreate(requestBody)



GET /site Get site settings.  POST /site Save site settings.  Params: user_id key field_key (POST) value (POST)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCoreApi();
final BuiltMap<String, JsonObject> requestBody = Object; // BuiltMap<String, JsonObject> | 

try {
    final response = api.corePlatformConfigSiteCreate(requestBody);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CoreApi->corePlatformConfigSiteCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **requestBody** | [**BuiltMap&lt;String, JsonObject&gt;**](JsonObject.md)|  | [optional] 

### Return type

[**BuiltMap&lt;String, JsonObject&gt;**](JsonObject.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **corePlatformConfigSiteRetrieve**
> BuiltMap<String, JsonObject> corePlatformConfigSiteRetrieve(key, userId)



GET /site Get site settings.  POST /site Save site settings.  Params: user_id key field_key (POST) value (POST)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCoreApi();
final String key = key_example; // String | 
final int userId = 56; // int | 

try {
    final response = api.corePlatformConfigSiteRetrieve(key, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CoreApi->corePlatformConfigSiteRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key** | **String**|  | 
 **userId** | **int**|  | [optional] 

### Return type

[**BuiltMap&lt;String, JsonObject&gt;**](JsonObject.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **corePlatformCreate**
> PlatformList corePlatformCreate(platformUpdatePostRequest)



Update platform object  Params: user_id  key new_key (If changing platform key) name  Advanced Params (Don't expose these to users) lms_url cms_url portal_url

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCoreApi();
final PlatformUpdatePostRequest platformUpdatePostRequest = ; // PlatformUpdatePostRequest | 

try {
    final response = api.corePlatformCreate(platformUpdatePostRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CoreApi->corePlatformCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **platformUpdatePostRequest** | [**PlatformUpdatePostRequest**](PlatformUpdatePostRequest.md)|  | 

### Return type

[**PlatformList**](PlatformList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **corePlatformRetrieve**
> PlatformList corePlatformRetrieve(key, userId)



GET /api/core/platform/ Get main platform info.  POST /api/core/platform/ Save main platform settings.  Params: user_id (optional) key field_key (POST) value (POST)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCoreApi();
final String key = key_example; // String | 
final int userId = 56; // int | 

try {
    final response = api.corePlatformRetrieve(key, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CoreApi->corePlatformRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key** | **String**|  | 
 **userId** | **int**|  | [optional] 

### Return type

[**PlatformList**](PlatformList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **corePlatformUsersRetrieve**
> UserPlatformManagementListViewGetResponse corePlatformUsersRetrieve(key, org, page, pageSize, query, sort)



Retrieve users associated with platform  Params: key org  query sort  is_admin: To return all the tenant admin user

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCoreApi();
final String key = key_example; // String | 
final String org = org_example; // String | 
final int page = 56; // int | 
final int pageSize = 56; // int | 
final String query = query_example; // String | 
final String sort = sort_example; // String | 

try {
    final response = api.corePlatformUsersRetrieve(key, org, page, pageSize, query, sort);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CoreApi->corePlatformUsersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key** | **String**|  | [optional] 
 **org** | **String**|  | [optional] 
 **page** | **int**|  | [optional] 
 **pageSize** | **int**|  | [optional] 
 **query** | **String**|  | [optional] 
 **sort** | **String**|  | [optional] 

### Return type

[**UserPlatformManagementListViewGetResponse**](UserPlatformManagementListViewGetResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **coreSignalsEdxCreate**
> coreSignalsEdxCreate(edxSignalReceiverRequest)



POST signals/edx/

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCoreApi();
final EdxSignalReceiverRequest edxSignalReceiverRequest = ; // EdxSignalReceiverRequest | 

try {
    api.coreSignalsEdxCreate(edxSignalReceiverRequest);
} catch on DioException (e) {
    print('Exception when calling CoreApi->coreSignalsEdxCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **edxSignalReceiverRequest** | [**EdxSignalReceiverRequest**](EdxSignalReceiverRequest.md)|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **coreUsersPlatformsCreate**
> coreUsersPlatformsCreate(userPlatformViewPostRequest)



Explicitly link platform to user_id  Params: user_id key added_on (optional) expired_on (optional) is_admin (optional) active (optional)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCoreApi();
final UserPlatformViewPostRequest userPlatformViewPostRequest = ; // UserPlatformViewPostRequest | 

try {
    api.coreUsersPlatformsCreate(userPlatformViewPostRequest);
} catch on DioException (e) {
    print('Exception when calling CoreApi->coreUsersPlatformsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **userPlatformViewPostRequest** | [**UserPlatformViewPostRequest**](UserPlatformViewPostRequest.md)|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **coreUsersPlatformsList**
> BuiltList<PlatformList> coreUsersPlatformsList(userId)



Retrieve platforms associated with user_id  Params: user_id

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCoreApi();
final int userId = 56; // int | 

try {
    final response = api.coreUsersPlatformsList(userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CoreApi->coreUsersPlatformsList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **userId** | **int**|  | 

### Return type

[**BuiltList&lt;PlatformList&gt;**](PlatformList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **coreUsersProxyBulkCreate**
> BuiltList<BuiltMap<String, String>> coreUsersProxyBulkCreate(userProxyBulkRequest)



Add proxy users by bulk  Params: users: list of user objects ``` [     {\"user_id\": 1, ...},     {\"user_id\": 2, ...} ] ```

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCoreApi();
final UserProxyBulkRequest userProxyBulkRequest = {"users":[{"user_id":1,"username":"test_user1","email":"test_user1@example.com"},{"user_id":2,"username":"test_user2","email":"test_user2@example.com"}]}; // UserProxyBulkRequest | 

try {
    final response = api.coreUsersProxyBulkCreate(userProxyBulkRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CoreApi->coreUsersProxyBulkCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **userProxyBulkRequest** | [**UserProxyBulkRequest**](UserProxyBulkRequest.md)|  | 

### Return type

[**BuiltList&lt;BuiltMap&lt;String, String&gt;&gt;**](BuiltMap.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **coreUsersProxyCreate**
> UserProxyPostResponse coreUsersProxyCreate(userProxyPostRequest)



Add proxy user  Params: user_id username email edx_data data

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCoreApi();
final UserProxyPostRequest userProxyPostRequest = ; // UserProxyPostRequest | 

try {
    final response = api.coreUsersProxyCreate(userProxyPostRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CoreApi->coreUsersProxyCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **userProxyPostRequest** | [**UserProxyPostRequest**](UserProxyPostRequest.md)|  | 

### Return type

[**UserProxyPostResponse**](UserProxyPostResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **coreUsersProxyRetrieve**
> UserProxyGetResponse coreUsersProxyRetrieve(email, userId, username)



Retrieve proxy user information by user_id

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCoreApi();
final String email = email_example; // String | 
final int userId = 56; // int | 
final String username = username_example; // String | 

try {
    final response = api.coreUsersProxyRetrieve(email, userId, username);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CoreApi->coreUsersProxyRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **String**|  | [optional] 
 **userId** | **int**|  | [optional] 
 **username** | **String**|  | [optional] 

### Return type

[**UserProxyGetResponse**](UserProxyGetResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **coreUsersSearchRetrieve**
> UserSearchViewGetResponse coreUsersSearchRetrieve(page, pageSize, query, sort)



Retrieve users based on query Not intended for public use with multitenant platforms  Params: query sort

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCoreApi();
final int page = 56; // int | 
final int pageSize = 56; // int | 
final String query = query_example; // String | 
final String sort = sort_example; // String | 

try {
    final response = api.coreUsersSearchRetrieve(page, pageSize, query, sort);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CoreApi->coreUsersSearchRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **page** | **int**|  | [optional] 
 **pageSize** | **int**|  | [optional] 
 **query** | **String**|  | [optional] 
 **sort** | **String**|  | [optional] 

### Return type

[**UserSearchViewGetResponse**](UserSearchViewGetResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

