# ibl_ai_data_manager_sdk.api.CredApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**credV2AssertionsRetrieve**](CredApi.md#credv2assertionsretrieve) | **GET** /api/cred/v2/assertions/ | 
[**credV2AssertionsRetrieve2**](CredApi.md#credv2assertionsretrieve2) | **GET** /api/cred/v2/assertions/{entity_id} | 
[**credV2AssertionsUpdate**](CredApi.md#credv2assertionsupdate) | **PUT** /api/cred/v2/assertions/{entity_id} | 
[**credV2CredentialsAssertionsBulkCreate**](CredApi.md#credv2credentialsassertionsbulkcreate) | **POST** /api/cred/v2/credentials/{entity_id}/assertions/bulk/ | 
[**credV2CredentialsAssertionsCreate**](CredApi.md#credv2credentialsassertionscreate) | **POST** /api/cred/v2/credentials/{entity_id}/assertions/ | 
[**credV2CredentialsAssertionsRetrieve**](CredApi.md#credv2credentialsassertionsretrieve) | **GET** /api/cred/v2/credentials/{entity_id}/assertions/ | 
[**credV2CredentialsCreate**](CredApi.md#credv2credentialscreate) | **POST** /api/cred/v2/credentials/ | 
[**credV2CredentialsDestroy**](CredApi.md#credv2credentialsdestroy) | **DELETE** /api/cred/v2/credentials/{entity_id} | 
[**credV2CredentialsRetrieve**](CredApi.md#credv2credentialsretrieve) | **GET** /api/cred/v2/credentials/ | 
[**credV2CredentialsRetrieve2**](CredApi.md#credv2credentialsretrieve2) | **GET** /api/cred/v2/credentials/{entity_id} | 
[**credV2CredentialsUpdate**](CredApi.md#credv2credentialsupdate) | **PUT** /api/cred/v2/credentials/{entity_id} | 
[**credV2IssuersAuthorityCreate**](CredApi.md#credv2issuersauthoritycreate) | **POST** /api/cred/v2/issuers/authority/ | 
[**credV2IssuersCreate**](CredApi.md#credv2issuerscreate) | **POST** /api/cred/v2/issuers/ | 
[**credV2IssuersDestroy**](CredApi.md#credv2issuersdestroy) | **DELETE** /api/cred/v2/issuers/{entity_id} | 
[**credV2IssuersRetrieve**](CredApi.md#credv2issuersretrieve) | **GET** /api/cred/v2/issuers/ | 
[**credV2IssuersRetrieve2**](CredApi.md#credv2issuersretrieve2) | **GET** /api/cred/v2/issuers/{entity_id} | 
[**credV2IssuersUpdate**](CredApi.md#credv2issuersupdate) | **PUT** /api/cred/v2/issuers/{entity_id} | 


# **credV2AssertionsRetrieve**
> credV2AssertionsRetrieve()



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();

try {
    api.credV2AssertionsRetrieve();
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2AssertionsRetrieve: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credV2AssertionsRetrieve2**
> credV2AssertionsRetrieve2(entityId)



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();
final String entityId = entityId_example; // String | 

try {
    api.credV2AssertionsRetrieve2(entityId);
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2AssertionsRetrieve2: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **entityId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credV2AssertionsUpdate**
> credV2AssertionsUpdate(entityId)



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();
final String entityId = entityId_example; // String | 

try {
    api.credV2AssertionsUpdate(entityId);
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2AssertionsUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **entityId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credV2CredentialsAssertionsBulkCreate**
> credV2CredentialsAssertionsBulkCreate(entityId)



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();
final String entityId = entityId_example; // String | 

try {
    api.credV2CredentialsAssertionsBulkCreate(entityId);
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2CredentialsAssertionsBulkCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **entityId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credV2CredentialsAssertionsCreate**
> credV2CredentialsAssertionsCreate(entityId)



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();
final String entityId = entityId_example; // String | 

try {
    api.credV2CredentialsAssertionsCreate(entityId);
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2CredentialsAssertionsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **entityId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credV2CredentialsAssertionsRetrieve**
> credV2CredentialsAssertionsRetrieve(entityId)



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();
final String entityId = entityId_example; // String | 

try {
    api.credV2CredentialsAssertionsRetrieve(entityId);
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2CredentialsAssertionsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **entityId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credV2CredentialsCreate**
> credV2CredentialsCreate()



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();

try {
    api.credV2CredentialsCreate();
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2CredentialsCreate: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credV2CredentialsDestroy**
> credV2CredentialsDestroy(entityId)



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();
final String entityId = entityId_example; // String | 

try {
    api.credV2CredentialsDestroy(entityId);
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2CredentialsDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **entityId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credV2CredentialsRetrieve**
> credV2CredentialsRetrieve()



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();

try {
    api.credV2CredentialsRetrieve();
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2CredentialsRetrieve: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credV2CredentialsRetrieve2**
> credV2CredentialsRetrieve2(entityId)



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();
final String entityId = entityId_example; // String | 

try {
    api.credV2CredentialsRetrieve2(entityId);
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2CredentialsRetrieve2: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **entityId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credV2CredentialsUpdate**
> credV2CredentialsUpdate(entityId)



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();
final String entityId = entityId_example; // String | 

try {
    api.credV2CredentialsUpdate(entityId);
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2CredentialsUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **entityId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credV2IssuersAuthorityCreate**
> credV2IssuersAuthorityCreate()



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();

try {
    api.credV2IssuersAuthorityCreate();
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2IssuersAuthorityCreate: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credV2IssuersCreate**
> credV2IssuersCreate()



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();

try {
    api.credV2IssuersCreate();
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2IssuersCreate: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credV2IssuersDestroy**
> credV2IssuersDestroy(entityId)



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();
final String entityId = entityId_example; // String | 

try {
    api.credV2IssuersDestroy(entityId);
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2IssuersDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **entityId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credV2IssuersRetrieve**
> credV2IssuersRetrieve()



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();

try {
    api.credV2IssuersRetrieve();
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2IssuersRetrieve: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credV2IssuersRetrieve2**
> credV2IssuersRetrieve2(entityId)



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();
final String entityId = entityId_example; // String | 

try {
    api.credV2IssuersRetrieve2(entityId);
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2IssuersRetrieve2: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **entityId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credV2IssuersUpdate**
> credV2IssuersUpdate(entityId)



### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredApi();
final String entityId = entityId_example; // String | 

try {
    api.credV2IssuersUpdate(entityId);
} catch on DioException (e) {
    print('Exception when calling CredApi->credV2IssuersUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **entityId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

