# ibl_ai_data_manager_sdk.api.CredentialsApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**credentialsOrgsAssertionsList**](CredentialsApi.md#credentialsorgsassertionslist) | **GET** /api/credentials/orgs/{org}/assertions/ | 
[**credentialsOrgsAssertionsOverTimeRetrieve**](CredentialsApi.md#credentialsorgsassertionsovertimeretrieve) | **GET** /api/credentials/orgs/{org}/assertions-over-time/ | 
[**credentialsOrgsCourseAssertionsOverTimeRetrieve**](CredentialsApi.md#credentialsorgscourseassertionsovertimeretrieve) | **GET** /api/credentials/orgs/{org}/course-assertions-over-time/ | 
[**credentialsOrgsCourseCredentialsList**](CredentialsApi.md#credentialsorgscoursecredentialslist) | **GET** /api/credentials/orgs/{org}/course-credentials/ | 
[**credentialsOrgsCredentialsOverTimeRetrieve**](CredentialsApi.md#credentialsorgscredentialsovertimeretrieve) | **GET** /api/credentials/orgs/{org}/credentials-over-time/ | 
[**credentialsOrgsCredentialsRetrieve**](CredentialsApi.md#credentialsorgscredentialsretrieve) | **GET** /api/credentials/orgs/{org}/credentials/{id}/ | 
[**credentialsOrgsList**](CredentialsApi.md#credentialsorgslist) | **GET** /api/credentials/orgs/{org}/ | 


# **credentialsOrgsAssertionsList**
> PaginatedAssertionsList credentialsOrgsAssertionsList(org, format, groupId, limit, offset)



Endpoint to retrieve the issued credentials for a given tenant

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredentialsApi();
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final int limit = 56; // int | Number of results to return per page.
final int offset = 56; // int | The initial index from which to return the results.

try {
    final response = api.credentialsOrgsAssertionsList(org, format, groupId, limit, offset);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CredentialsApi->credentialsOrgsAssertionsList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **limit** | **int**| Number of results to return per page. | [optional] 
 **offset** | **int**| The initial index from which to return the results. | [optional] 

### Return type

[**PaginatedAssertionsList**](PaginatedAssertionsList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credentialsOrgsAssertionsOverTimeRetrieve**
> OverTime credentialsOrgsAssertionsOverTimeRetrieve(org, endDate, format, groupId, startDate)



Get all credentials of a given tenant

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredentialsApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.credentialsOrgsAssertionsOverTimeRetrieve(org, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CredentialsApi->credentialsOrgsAssertionsOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**OverTime**](OverTime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credentialsOrgsCourseAssertionsOverTimeRetrieve**
> OverTime credentialsOrgsCourseAssertionsOverTimeRetrieve(org, endDate, format, groupId, startDate)



Get all credentials of a given tenant

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredentialsApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.credentialsOrgsCourseAssertionsOverTimeRetrieve(org, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CredentialsApi->credentialsOrgsCourseAssertionsOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**OverTime**](OverTime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credentialsOrgsCourseCredentialsList**
> credentialsOrgsCourseCredentialsList(org, limit, offset)



Endpoint to retrieve the credentials of a given tenant

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredentialsApi();
final String org = org_example; // String | 
final int limit = 56; // int | Number of results to return per page.
final int offset = 56; // int | The initial index from which to return the results.

try {
    api.credentialsOrgsCourseCredentialsList(org, limit, offset);
} catch on DioException (e) {
    print('Exception when calling CredentialsApi->credentialsOrgsCourseCredentialsList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **limit** | **int**| Number of results to return per page. | [optional] 
 **offset** | **int**| The initial index from which to return the results. | [optional] 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credentialsOrgsCredentialsOverTimeRetrieve**
> OverTime credentialsOrgsCredentialsOverTimeRetrieve(org, endDate, format, groupId, startDate)



Get all credentials of a given tenant

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredentialsApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.credentialsOrgsCredentialsOverTimeRetrieve(org, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CredentialsApi->credentialsOrgsCredentialsOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**OverTime**](OverTime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credentialsOrgsCredentialsRetrieve**
> Credential credentialsOrgsCredentialsRetrieve(id, org)



Endpoint to retrieve the credentials of a given tenant

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredentialsApi();
final int id = 56; // int | 
final String org = org_example; // String | 

try {
    final response = api.credentialsOrgsCredentialsRetrieve(id, org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CredentialsApi->credentialsOrgsCredentialsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**|  | 
 **org** | **String**|  | 

### Return type

[**Credential**](Credential.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **credentialsOrgsList**
> PaginatedCredentialList credentialsOrgsList(org, limit, offset)



Endpoint to retrieve the credentials of a given tenant

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getCredentialsApi();
final String org = org_example; // String | 
final int limit = 56; // int | Number of results to return per page.
final int offset = 56; // int | The initial index from which to return the results.

try {
    final response = api.credentialsOrgsList(org, limit, offset);
    print(response);
} catch on DioException (e) {
    print('Exception when calling CredentialsApi->credentialsOrgsList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **limit** | **int**| Number of results to return per page. | [optional] 
 **offset** | **int**| The initial index from which to return the results. | [optional] 

### Return type

[**PaginatedCredentialList**](PaginatedCredentialList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

