# ibl_ai_data_manager_sdk.api.EngagementApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**engagementOrgsActivityRetrieve**](EngagementApi.md#engagementorgsactivityretrieve) | **GET** /api/engagement/orgs/{org}/activity | 
[**engagementOrgsCourseCompletionPerCourseRetrieve**](EngagementApi.md#engagementorgscoursecompletionpercourseretrieve) | **GET** /api/engagement/orgs/{org}/course_completion/per-course | 
[**engagementOrgsCoursesTimeAverageRetrieve**](EngagementApi.md#engagementorgscoursestimeaverageretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/time/average | 
[**engagementOrgsCoursesTimeDetailRetrieve**](EngagementApi.md#engagementorgscoursestimedetailretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/time/detail | 
[**engagementOrgsCoursesTimeOverTimeRetrieve**](EngagementApi.md#engagementorgscoursestimeovertimeretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/time/over-time | 
[**engagementOrgsCoursesTimeUsersDetailRetrieve**](EngagementApi.md#engagementorgscoursestimeusersdetailretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/time/users/{user_id}/detail | 
[**engagementOrgsCoursesTimeUsersOverTimeRetrieve**](EngagementApi.md#engagementorgscoursestimeusersovertimeretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/time/users/{user_id}/over-time | 
[**engagementOrgsCoursesTimeUsersRetrieve**](EngagementApi.md#engagementorgscoursestimeusersretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/time/users | 
[**engagementOrgsCoursesVideosOverTimeRetrieve**](EngagementApi.md#engagementorgscoursesvideosovertimeretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/videos/over-time | 
[**engagementOrgsCoursesVideosRetrieve**](EngagementApi.md#engagementorgscoursesvideosretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/videos/ | 
[**engagementOrgsCoursesVideosSummaryRetrieve**](EngagementApi.md#engagementorgscoursesvideossummaryretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/videos/summary | 
[**engagementOrgsCoursesVideosUsersRetrieve**](EngagementApi.md#engagementorgscoursesvideosusersretrieve) | **GET** /api/engagement/orgs/{org}/courses/{course_id}/videos/users | 
[**engagementOrgsTimeAveragePerlearnerPercourseRetrieve**](EngagementApi.md#engagementorgstimeaverageperlearnerpercourseretrieve) | **GET** /api/engagement/orgs/{org}/time/average-perlearner-percourse | 
[**engagementOrgsTimeAverageWithOverTimeRetrieve**](EngagementApi.md#engagementorgstimeaveragewithovertimeretrieve) | **GET** /api/engagement/orgs/{org}/time/average-with-over-time | 
[**engagementOrgsTimeOverTimeRetrieve**](EngagementApi.md#engagementorgstimeovertimeretrieve) | **GET** /api/engagement/orgs/{org}/time/over-time | 
[**engagementOrgsTimePerCourseRetrieve**](EngagementApi.md#engagementorgstimepercourseretrieve) | **GET** /api/engagement/orgs/{org}/time/per-course | 
[**engagementOrgsVideosOverTimeRetrieve**](EngagementApi.md#engagementorgsvideosovertimeretrieve) | **GET** /api/engagement/orgs/{org}/videos/over-time | 
[**engagementOrgsVideosRetrieve**](EngagementApi.md#engagementorgsvideosretrieve) | **GET** /api/engagement/orgs/{org}/videos/ | 


# **engagementOrgsActivityRetrieve**
> EngagementPerCourse engagementOrgsActivityRetrieve(org, format, groupId, length, page)



Engagement information on a per-course basis

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final int length = 56; // int | Size of data to return
final int page = 56; // int | Page offset

try {
    final response = api.engagementOrgsActivityRetrieve(org, format, groupId, length, page);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsActivityRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **length** | **int**| Size of data to return | [optional] 
 **page** | **int**| Page offset | [optional] 

### Return type

[**EngagementPerCourse**](EngagementPerCourse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsCourseCompletionPerCourseRetrieve**
> CourseCompletionPerCourse engagementOrgsCourseCompletionPerCourseRetrieve(org, format, groupId, length, page)



Aggregated table of enrollments,and completed count on a per-course basis

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final int length = 56; // int | Size of data to return
final int page = 56; // int | Page offset

try {
    final response = api.engagementOrgsCourseCompletionPerCourseRetrieve(org, format, groupId, length, page);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsCourseCompletionPerCourseRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **length** | **int**| Size of data to return | [optional] 
 **page** | **int**| Page offset | [optional] 

### Return type

[**CourseCompletionPerCourse**](CourseCompletionPerCourse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsCoursesTimeAverageRetrieve**
> AverageOvertime engagementOrgsCoursesTimeAverageRetrieve(courseId, org, endDate, format, groupId, startDate)



Average time spent in secs on a per-day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10 3. course_id <optional>  Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.engagementOrgsCoursesTimeAverageRetrieve(courseId, org, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsCoursesTimeAverageRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**AverageOvertime**](AverageOvertime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsCoursesTimeDetailRetrieve**
> TimeDetail engagementOrgsCoursesTimeDetailRetrieve(courseId, org, format, groupId)



Time spent per course in secs in a tree like form  Kwargs course_id e.g course-v1:Org+Course4+Run  Query Params 1. start_date <optional> e.g 2020-10-01 2. end_date <optional> e.g 2020-10-10

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID

try {
    final response = api.engagementOrgsCoursesTimeDetailRetrieve(courseId, org, format, groupId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsCoursesTimeDetailRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**TimeDetail**](TimeDetail.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsCoursesTimeOverTimeRetrieve**
> Overtime engagementOrgsCoursesTimeOverTimeRetrieve(courseId, org, endDate, format, groupId, startDate)



Time spent per course in secs on a per-day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10 Kwargs 3. course_id  Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.engagementOrgsCoursesTimeOverTimeRetrieve(courseId, org, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsCoursesTimeOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Overtime**](Overtime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsCoursesTimeUsersDetailRetrieve**
> PerLearnerTimeSpentInCourseTree engagementOrgsCoursesTimeUsersDetailRetrieve(courseId, org, userId, endDate, format, groupId, startDate)



Time spent within a course in ordered hierarchical format  Kwargs 1. course_id  e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email) Query Params 3. start_date <optional> e.g 2020-10-01 4. end_date <optional> e.g 2020-10-10

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.engagementOrgsCoursesTimeUsersDetailRetrieve(courseId, org, userId, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsCoursesTimeUsersDetailRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**PerLearnerTimeSpentInCourseTree**](PerLearnerTimeSpentInCourseTree.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsCoursesTimeUsersOverTimeRetrieve**
> Overtime engagementOrgsCoursesTimeUsersOverTimeRetrieve(courseId, org, userId, endDate, format, groupId, startDate)



Time spent in secs on a per-day basis  Query Params 1. course_id <optional> e.g course-v1:Org+Course4+Run 2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email) 3. start_date e.g 2020-10-01 4. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.engagementOrgsCoursesTimeUsersOverTimeRetrieve(courseId, org, userId, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsCoursesTimeUsersOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Overtime**](Overtime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsCoursesTimeUsersRetrieve**
> TimeSpentByUsersInCourse engagementOrgsCoursesTimeUsersRetrieve(courseId, org, endDate, format, groupId, length, page, startDate)



Time spent by users in a course  Query Params course_id  e.g course-v1:Org+Course4+Run

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final int length = 56; // int | Size of data to return
final int page = 56; // int | Page offset
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.engagementOrgsCoursesTimeUsersRetrieve(courseId, org, endDate, format, groupId, length, page, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsCoursesTimeUsersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **length** | **int**| Size of data to return | [optional] 
 **page** | **int**| Page offset | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**TimeSpentByUsersInCourse**](TimeSpentByUsersInCourse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsCoursesVideosOverTimeRetrieve**
> Overtime engagementOrgsCoursesVideosOverTimeRetrieve(courseId, org, endDate, format, groupId, startDate)



 Watched Videos count on a per-day basis  Kwargs  1. course_id <optional> e.g course-v1:Org+Course4+Run  2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)   Query Params  3. start_date e.g 2020-10-01  4. end_date e.g 2020-10-10   Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.engagementOrgsCoursesVideosOverTimeRetrieve(courseId, org, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsCoursesVideosOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Overtime**](Overtime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsCoursesVideosRetrieve**
> VideosSpecificCourse engagementOrgsCoursesVideosRetrieve(courseId, org, format, groupId)



Engagement information (video) for a specific course

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID

try {
    final response = api.engagementOrgsCoursesVideosRetrieve(courseId, org, format, groupId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsCoursesVideosRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**VideosSpecificCourse**](VideosSpecificCourse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsCoursesVideosSummaryRetrieve**
> VideosInCourseSummary engagementOrgsCoursesVideosSummaryRetrieve(courseId, org, format, groupId)



Returns a Simplified tree structure of videos watched in course Kwargs course_id  e.g course-v1:Org+Course4+Run

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID

try {
    final response = api.engagementOrgsCoursesVideosSummaryRetrieve(courseId, org, format, groupId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsCoursesVideosSummaryRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**VideosInCourseSummary**](VideosInCourseSummary.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsCoursesVideosUsersRetrieve**
> WatchedVideosPerUser engagementOrgsCoursesVideosUsersRetrieve(courseId, org, format, groupId)



List of users' videos completed records for a specific course  Kwargs course_id  e.g course-v1:Org+Course4+Run

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID

try {
    final response = api.engagementOrgsCoursesVideosUsersRetrieve(courseId, org, format, groupId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsCoursesVideosUsersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**WatchedVideosPerUser**](WatchedVideosPerUser.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsTimeAveragePerlearnerPercourseRetrieve**
> AverageOvertime engagementOrgsTimeAveragePerlearnerPercourseRetrieve(org, endDate, format, groupId, startDate)



Average time spent by a learner in enrolled courses. Gives a rough estimate of whats the average time that would be spent by a learner in a course  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.engagementOrgsTimeAveragePerlearnerPercourseRetrieve(org, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsTimeAveragePerlearnerPercourseRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**AverageOvertime**](AverageOvertime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsTimeAverageWithOverTimeRetrieve**
> AverageOvertime engagementOrgsTimeAverageWithOverTimeRetrieve(org, endDate, format, groupId, startDate)



Average time spent in secs on a per-day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10 3. course_id <optional>  Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.engagementOrgsTimeAverageWithOverTimeRetrieve(org, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsTimeAverageWithOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**AverageOvertime**](AverageOvertime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsTimeOverTimeRetrieve**
> OvertimeWithChangeInfo engagementOrgsTimeOverTimeRetrieve(org, endDate, format, groupId, startDate)



Time spent in secs on a per-day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.engagementOrgsTimeOverTimeRetrieve(org, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsTimeOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**OvertimeWithChangeInfo**](OvertimeWithChangeInfo.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsTimePerCourseRetrieve**
> TimeSpentPerCourse engagementOrgsTimePerCourseRetrieve(org, endDate, format, groupId, length, page, startDate)



Aggregated time spent value on a per course basis

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final int length = 56; // int | Size of data to return
final int page = 56; // int | Page offset
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.engagementOrgsTimePerCourseRetrieve(org, endDate, format, groupId, length, page, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsTimePerCourseRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **length** | **int**| Size of data to return | [optional] 
 **page** | **int**| Page offset | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**TimeSpentPerCourse**](TimeSpentPerCourse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsVideosOverTimeRetrieve**
> Overtime engagementOrgsVideosOverTimeRetrieve(org, endDate, format, groupId, startDate)



 Watched Videos count on a per-day basis  Kwargs  1. course_id <optional> e.g course-v1:Org+Course4+Run  2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)   Query Params  3. start_date e.g 2020-10-01  4. end_date e.g 2020-10-10   Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.engagementOrgsVideosOverTimeRetrieve(org, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsVideosOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Overtime**](Overtime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **engagementOrgsVideosRetrieve**
> VideoEngagementPerCourse engagementOrgsVideosRetrieve(org, format, groupId, length, page)



Video Engagement information on a per-course basis

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getEngagementApi();
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final int length = 56; // int | Size of data to return
final int page = 56; // int | Page offset

try {
    final response = api.engagementOrgsVideosRetrieve(org, format, groupId, length, page);
    print(response);
} catch on DioException (e) {
    print('Exception when calling EngagementApi->engagementOrgsVideosRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **length** | **int**| Size of data to return | [optional] 
 **page** | **int**| Page offset | [optional] 

### Return type

[**VideoEngagementPerCourse**](VideoEngagementPerCourse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

