# ibl_ai_data_manager_sdk.api.FinanceApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**financeOrgsProductsOrdersRetrieve**](FinanceApi.md#financeorgsproductsordersretrieve) | **GET** /api/finance/orgs/{org}/products/{item_id}/orders | 
[**financeOrgsProductsRetrieve**](FinanceApi.md#financeorgsproductsretrieve) | **GET** /api/finance/orgs/{org}/products | 
[**financeOrgsProductsSalesOverTimeRetrieve**](FinanceApi.md#financeorgsproductssalesovertimeretrieve) | **GET** /api/finance/orgs/{org}/products/{item_id}/sales-over-time | 
[**financeOrgsRevenueNetOverTimeRetrieve**](FinanceApi.md#financeorgsrevenuenetovertimeretrieve) | **GET** /api/finance/orgs/{org}/revenue/net-over-time | 
[**financeOrgsRevenueProductsRetrieve**](FinanceApi.md#financeorgsrevenueproductsretrieve) | **GET** /api/finance/orgs/{org}/revenue/products | 


# **financeOrgsProductsOrdersRetrieve**
> Order financeOrgsProductsOrdersRetrieve(itemId, org, endDate, startDate)



Return list of WooCommerce orders for product item_id over optional date range

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getFinanceApi();
final String itemId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final String org = org_example; // String | 
final String endDate = endDate_example; // String | End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
final String startDate = startDate_example; // String | Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.

try {
    final response = api.financeOrgsProductsOrdersRetrieve(itemId, org, endDate, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling FinanceApi->financeOrgsProductsOrdersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **itemId** | **String**|  | 
 **org** | **String**|  | 
 **endDate** | **String**| End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time. | [optional] 
 **startDate** | **String**| Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time. | [optional] 

### Return type

[**Order**](Order.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **financeOrgsProductsRetrieve**
> Product financeOrgsProductsRetrieve(org)



Returns table listing products and product info for all or specific org

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getFinanceApi();
final String org = org_example; // String | 

try {
    final response = api.financeOrgsProductsRetrieve(org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling FinanceApi->financeOrgsProductsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**Product**](Product.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **financeOrgsProductsSalesOverTimeRetrieve**
> NetRevenueOverTime financeOrgsProductsSalesOverTimeRetrieve(itemId, org, endDate, startDate)



Returns Net Revenue over time for org and slug

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getFinanceApi();
final String itemId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final String org = org_example; // String | 
final String endDate = endDate_example; // String | End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
final String startDate = startDate_example; // String | Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.

try {
    final response = api.financeOrgsProductsSalesOverTimeRetrieve(itemId, org, endDate, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling FinanceApi->financeOrgsProductsSalesOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **itemId** | **String**|  | 
 **org** | **String**|  | 
 **endDate** | **String**| End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time. | [optional] 
 **startDate** | **String**| Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time. | [optional] 

### Return type

[**NetRevenueOverTime**](NetRevenueOverTime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **financeOrgsRevenueNetOverTimeRetrieve**
> NetRevenueOverTime financeOrgsRevenueNetOverTimeRetrieve(org, endDate, startDate)



Returns Net Revenue over time for org and slug

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getFinanceApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
final String startDate = startDate_example; // String | Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.

try {
    final response = api.financeOrgsRevenueNetOverTimeRetrieve(org, endDate, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling FinanceApi->financeOrgsRevenueNetOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time. | [optional] 
 **startDate** | **String**| Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time. | [optional] 

### Return type

[**NetRevenueOverTime**](NetRevenueOverTime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **financeOrgsRevenueProductsRetrieve**
> RevenueByProduct financeOrgsRevenueProductsRetrieve(org, endDate, startDate)



Returns Revenue by Product + summary for specific org

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getFinanceApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
final String startDate = startDate_example; // String | Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.

try {
    final response = api.financeOrgsRevenueProductsRetrieve(org, endDate, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling FinanceApi->financeOrgsRevenueProductsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time. | [optional] 
 **startDate** | **String**| Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time. | [optional] 

### Return type

[**RevenueByProduct**](RevenueByProduct.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

