# ibl_ai_data_manager_sdk.api.OverviewApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**overviewOrgsActiveUsersRetrieve**](OverviewApi.md#overvieworgsactiveusersretrieve) | **GET** /api/overview/orgs/{org}/active-users | 
[**overviewOrgsAverageGradeRetrieve**](OverviewApi.md#overvieworgsaveragegraderetrieve) | **GET** /api/overview/orgs/{org}/average-grade | 
[**overviewOrgsCoursesCompletionsRetrieve**](OverviewApi.md#overvieworgscoursescompletionsretrieve) | **GET** /api/overview/orgs/{org}/courses/completions | 
[**overviewOrgsLearnersRetrieve**](OverviewApi.md#overvieworgslearnersretrieve) | **GET** /api/overview/orgs/{org}/learners | 
[**overviewOrgsMostActiveCoursesRetrieve**](OverviewApi.md#overvieworgsmostactivecoursesretrieve) | **GET** /api/overview/orgs/{org}/most-active-courses | 
[**overviewOrgsRegisteredUsersRetrieve**](OverviewApi.md#overvieworgsregisteredusersretrieve) | **GET** /api/overview/orgs/{org}/registered-users | 


# **overviewOrgsActiveUsersRetrieve**
> OvertimeWithChangeInfo overviewOrgsActiveUsersRetrieve(org, endDate, format, groupId, startDate)



Count of users with known activity within the past 30 days on a per day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive) Returns ``` {     \"data\": {         \"2022-04-26\": 0,         \"2022-04-27\": 0,         \"2022-04-28\": 0,         \"2022-04-29\": 60,         ...         \"2022-05-05\": 0     },     \"total\": 60,     \"meta\": {         \"change_last_seven_days\": 0,         \"change_last_seven_days_percent\": 0.0,         \"change_last_thirty_days\": 0,         \"change_last_thirty_days_percent\": 0.0,         \"change_range\": 0,         \"change_range_percent\": 0.0,         \"total\": 0,     } }

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getOverviewApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.overviewOrgsActiveUsersRetrieve(org, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling OverviewApi->overviewOrgsActiveUsersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**OvertimeWithChangeInfo**](OvertimeWithChangeInfo.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **overviewOrgsAverageGradeRetrieve**
> Average overviewOrgsAverageGradeRetrieve(org, format, groupId)



Average grade value for platform, course, or user.  Query Params course_id <optional>  e.g course-v1:Org+Course4+Run learner_id <optional> e.g std123 , student@email.com

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getOverviewApi();
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID

try {
    final response = api.overviewOrgsAverageGradeRetrieve(org, format, groupId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling OverviewApi->overviewOrgsAverageGradeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**Average**](Average.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **overviewOrgsCoursesCompletionsRetrieve**
> CourseCompletionSummaryOvertime overviewOrgsCoursesCompletionsRetrieve(org, endDate, format, groupId, startDate)



Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getOverviewApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.overviewOrgsCoursesCompletionsRetrieve(org, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling OverviewApi->overviewOrgsCoursesCompletionsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**CourseCompletionSummaryOvertime**](CourseCompletionSummaryOvertime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **overviewOrgsLearnersRetrieve**
> PerlearnerUserList overviewOrgsLearnersRetrieve(org, format, groupId, length, page, search)



List of entire learners on the platform with aggregated enrollments, completions and time spent

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getOverviewApi();
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final int length = 56; // int | Size of data to return
final int page = 56; // int | Page offset
final String search = search_example; // String | Search string for learner

try {
    final response = api.overviewOrgsLearnersRetrieve(org, format, groupId, length, page, search);
    print(response);
} catch on DioException (e) {
    print('Exception when calling OverviewApi->overviewOrgsLearnersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **length** | **int**| Size of data to return | [optional] 
 **page** | **int**| Page offset | [optional] 
 **search** | **String**| Search string for learner | [optional] 

### Return type

[**PerlearnerUserList**](PerlearnerUserList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **overviewOrgsMostActiveCoursesRetrieve**
> TimeSpentPerCourse overviewOrgsMostActiveCoursesRetrieve(org, endDate, format, groupId, length, page, startDate)



Aggregated time spent value on a per course basis

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getOverviewApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final int length = 56; // int | Size of data to return
final int page = 56; // int | Page offset
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.overviewOrgsMostActiveCoursesRetrieve(org, endDate, format, groupId, length, page, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling OverviewApi->overviewOrgsMostActiveCoursesRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **length** | **int**| Size of data to return | [optional] 
 **page** | **int**| Page offset | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**TimeSpentPerCourse**](TimeSpentPerCourse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **overviewOrgsRegisteredUsersRetrieve**
> OvertimeWithChangeInfo overviewOrgsRegisteredUsersRetrieve(org, endDate, format, groupId, startDate)



Registered users count on a per day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getOverviewApi();
final String org = org_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.overviewOrgsRegisteredUsersRetrieve(org, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling OverviewApi->overviewOrgsRegisteredUsersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**OvertimeWithChangeInfo**](OvertimeWithChangeInfo.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

