# ibl_ai_data_manager_sdk.api.PerformanceApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**performanceOrgsCoursesGradingAverageRetrieve**](PerformanceApi.md#performanceorgscoursesgradingaverageretrieve) | **GET** /api/performance/orgs/{org}/courses/{course_id}/grading/average | 
[**performanceOrgsCoursesGradingAverageWithCutoffRetrieve**](PerformanceApi.md#performanceorgscoursesgradingaveragewithcutoffretrieve) | **GET** /api/performance/orgs/{org}/courses/{course_id}/grading/average-with-cutoff | 
[**performanceOrgsCoursesGradingDetailRetrieve**](PerformanceApi.md#performanceorgscoursesgradingdetailretrieve) | **GET** /api/performance/orgs/{org}/courses/{course_id}/grading/detail | 
[**performanceOrgsCoursesGradingPerLearnerRetrieve**](PerformanceApi.md#performanceorgscoursesgradingperlearnerretrieve) | **GET** /api/performance/orgs/{org}/courses/{course_id}/grading/per-learner | 
[**performanceOrgsCoursesGradingSummaryRetrieve**](PerformanceApi.md#performanceorgscoursesgradingsummaryretrieve) | **GET** /api/performance/orgs/{org}/courses/{course_id}/grading/summary | 
[**performanceOrgsGradingAverageRetrieve**](PerformanceApi.md#performanceorgsgradingaverageretrieve) | **GET** /api/performance/orgs/{org}/grading/average | 
[**performanceOrgsGradingPerCourseRetrieve**](PerformanceApi.md#performanceorgsgradingpercourseretrieve) | **GET** /api/performance/orgs/{org}/grading/per-course | 


# **performanceOrgsCoursesGradingAverageRetrieve**
> Average performanceOrgsCoursesGradingAverageRetrieve(courseId, org, format, groupId)



Average grade value for platform, course, or user.  Query Params course_id <optional>  e.g course-v1:Org+Course4+Run learner_id <optional> e.g std123 , student@email.com

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerformanceApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID

try {
    final response = api.performanceOrgsCoursesGradingAverageRetrieve(courseId, org, format, groupId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerformanceApi->performanceOrgsCoursesGradingAverageRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**Average**](Average.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **performanceOrgsCoursesGradingAverageWithCutoffRetrieve**
> AvgCourseGradeWithCutoff performanceOrgsCoursesGradingAverageWithCutoffRetrieve(courseId, org, format, groupId)



Returns average course grade and grade cuttoff  e.g ``` {     \"data\": {         \"grade_cutoffs\": {             \"A\": 90,             \"B\": 80,             \"C\": 70,         },         \"average_grade\": 50.0,     } } ```  Kwargs course_id

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerformanceApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID

try {
    final response = api.performanceOrgsCoursesGradingAverageWithCutoffRetrieve(courseId, org, format, groupId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerformanceApi->performanceOrgsCoursesGradingAverageWithCutoffRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**AvgCourseGradeWithCutoff**](AvgCourseGradeWithCutoff.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **performanceOrgsCoursesGradingDetailRetrieve**
> CourseGradingDetail performanceOrgsCoursesGradingDetailRetrieve(courseId, org, format, groupId)



Grading summary for the entire course overview in a tree-like format  Kwargs course_id <required>

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerformanceApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID

try {
    final response = api.performanceOrgsCoursesGradingDetailRetrieve(courseId, org, format, groupId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerformanceApi->performanceOrgsCoursesGradingDetailRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**CourseGradingDetail**](CourseGradingDetail.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **performanceOrgsCoursesGradingPerLearnerRetrieve**
> GradingPerUser performanceOrgsCoursesGradingPerLearnerRetrieve(courseId, org, format, groupId)



Grading information per enrolled user in a course  Kwargs course_id <required>

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerformanceApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID

try {
    final response = api.performanceOrgsCoursesGradingPerLearnerRetrieve(courseId, org, format, groupId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerformanceApi->performanceOrgsCoursesGradingPerLearnerRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**GradingPerUser**](GradingPerUser.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **performanceOrgsCoursesGradingSummaryRetrieve**
> CourseGradeSummary performanceOrgsCoursesGradingSummaryRetrieve(courseId, org, format, groupId)



Returns average grades across various assignment types in a course  Query Params course_id  Returns:     dict     {         \"data\": [             {                 \"assignment_type': <str>,                 \"weight\": <float>,                 \"average_weighted_grade\": <float>,                 \"average_section_grade\": <float>             }, ...         ]     }

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerformanceApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID

try {
    final response = api.performanceOrgsCoursesGradingSummaryRetrieve(courseId, org, format, groupId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerformanceApi->performanceOrgsCoursesGradingSummaryRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**CourseGradeSummary**](CourseGradeSummary.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **performanceOrgsGradingAverageRetrieve**
> Average performanceOrgsGradingAverageRetrieve(org, format, groupId)



Average grade value for platform, course, or user.  Query Params course_id <optional>  e.g course-v1:Org+Course4+Run learner_id <optional> e.g std123 , student@email.com

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerformanceApi();
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID

try {
    final response = api.performanceOrgsGradingAverageRetrieve(org, format, groupId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerformanceApi->performanceOrgsGradingAverageRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**Average**](Average.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **performanceOrgsGradingPerCourseRetrieve**
> PerformanceGradesPerCourse performanceOrgsGradingPerCourseRetrieve(org, format, groupId, length, page)



Returns grade related performance data per course  Returns:     dict     {         \"data\": [             {                 \"course_id': <str>,                 \"name': <str>,                 \"num_enrollments\": <int>,                 \"num_passed\": <int>,                 \"avg_grade\": <int>             }, ...         ]     }

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerformanceApi();
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final int length = 56; // int | Size of data to return
final int page = 56; // int | Page offset

try {
    final response = api.performanceOrgsGradingPerCourseRetrieve(org, format, groupId, length, page);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerformanceApi->performanceOrgsGradingPerCourseRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **length** | **int**| Size of data to return | [optional] 
 **page** | **int**| Page offset | [optional] 

### Return type

[**PerformanceGradesPerCourse**](PerformanceGradesPerCourse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

