# ibl_ai_data_manager_sdk.api.PerlearnerApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**perlearnerOrgsUsersActivityRetrieve**](PerlearnerApi.md#perlearnerorgsusersactivityretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/activity/ | 
[**perlearnerOrgsUsersCoursesGradingCutoffsRetrieve**](PerlearnerApi.md#perlearnerorgsuserscoursesgradingcutoffsretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/grading/cutoffs | 
[**perlearnerOrgsUsersCoursesGradingDetailRetrieve**](PerlearnerApi.md#perlearnerorgsuserscoursesgradingdetailretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/grading/detail | 
[**perlearnerOrgsUsersCoursesGradingSummaryRetrieve**](PerlearnerApi.md#perlearnerorgsuserscoursesgradingsummaryretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/grading/summary | 
[**perlearnerOrgsUsersCoursesOverviewEngagementIndexRetrieve**](PerlearnerApi.md#perlearnerorgsuserscoursesoverviewengagementindexretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/overview/engagement-index | 
[**perlearnerOrgsUsersCoursesOverviewGradeRetrieve**](PerlearnerApi.md#perlearnerorgsuserscoursesoverviewgraderetrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/overview/grade | 
[**perlearnerOrgsUsersCoursesOverviewPerformanceIndexRetrieve**](PerlearnerApi.md#perlearnerorgsuserscoursesoverviewperformanceindexretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/overview/performance-index | 
[**perlearnerOrgsUsersCoursesOverviewTimeOverTimeRetrieve**](PerlearnerApi.md#perlearnerorgsuserscoursesoverviewtimeovertimeretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/overview/time/over-time | 
[**perlearnerOrgsUsersCoursesVideosOverTimeRetrieve**](PerlearnerApi.md#perlearnerorgsuserscoursesvideosovertimeretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/videos/over-time | 
[**perlearnerOrgsUsersCoursesVideosRetrieve**](PerlearnerApi.md#perlearnerorgsuserscoursesvideosretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/videos | 
[**perlearnerOrgsUsersGradesPerCourseRetrieve**](PerlearnerApi.md#perlearnerorgsusersgradespercourseretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/grades/per-course | 
[**perlearnerOrgsUsersInfoRetrieve**](PerlearnerApi.md#perlearnerorgsusersinforetrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/info | 
[**perlearnerOrgsUsersLastAccessRetrieve**](PerlearnerApi.md#perlearnerorgsuserslastaccessretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/last-access | 
[**perlearnerOrgsUsersOverviewEngagementIndexRetrieve**](PerlearnerApi.md#perlearnerorgsusersoverviewengagementindexretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/overview/engagement-index | 
[**perlearnerOrgsUsersOverviewGradesAverageRetrieve**](PerlearnerApi.md#perlearnerorgsusersoverviewgradesaverageretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/overview/grades/average | 
[**perlearnerOrgsUsersOverviewPerformanceIndexRetrieve**](PerlearnerApi.md#perlearnerorgsusersoverviewperformanceindexretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/overview/performance-index | 
[**perlearnerOrgsUsersOverviewTimeOverTimeRetrieve**](PerlearnerApi.md#perlearnerorgsusersoverviewtimeovertimeretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/overview/time/over-time | 
[**perlearnerOrgsUsersRetrieve**](PerlearnerApi.md#perlearnerorgsusersretrieve) | **GET** /api/perlearner/orgs/{org}/users | 
[**perlearnerOrgsUsersVideosOverTimeRetrieve**](PerlearnerApi.md#perlearnerorgsusersvideosovertimeretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/videos/over-time | 
[**perlearnerOrgsUsersVideosPerCourseRetrieve**](PerlearnerApi.md#perlearnerorgsusersvideospercourseretrieve) | **GET** /api/perlearner/orgs/{org}/users/{user_id}/videos/per-course | 


# **perlearnerOrgsUsersActivityRetrieve**
> ActivityAPI perlearnerOrgsUsersActivityRetrieve(org, userId, format, groupId)



Provides information on user enrollments  Params user_id e.g developer@ibleducation.com| developer

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID

try {
    final response = api.perlearnerOrgsUsersActivityRetrieve(org, userId, format, groupId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersActivityRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**ActivityAPI**](ActivityAPI.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersCoursesGradingCutoffsRetrieve**
> PerlearnerGradeWithCutOff perlearnerOrgsUsersCoursesGradingCutoffsRetrieve(courseId, org, userId, endDate, format, groupId, startDate)



Provides about a learner current grade in a course with the course cut Kwargs 1. course_id e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.perlearnerOrgsUsersCoursesGradingCutoffsRetrieve(courseId, org, userId, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersCoursesGradingCutoffsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**PerlearnerGradeWithCutOff**](PerlearnerGradeWithCutOff.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersCoursesGradingDetailRetrieve**
> DetailedGradeView perlearnerOrgsUsersCoursesGradingDetailRetrieve(courseId, org, userId, endDate, format, groupId, startDate)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.perlearnerOrgsUsersCoursesGradingDetailRetrieve(courseId, org, userId, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersCoursesGradingDetailRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**DetailedGradeView**](DetailedGradeView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersCoursesGradingSummaryRetrieve**
> PerlearnerGradeSummary perlearnerOrgsUsersCoursesGradingSummaryRetrieve(courseId, org, userId, endDate, format, groupId, startDate)



Query Params 1. course_id e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.perlearnerOrgsUsersCoursesGradingSummaryRetrieve(courseId, org, userId, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersCoursesGradingSummaryRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**PerlearnerGradeSummary**](PerlearnerGradeSummary.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersCoursesOverviewEngagementIndexRetrieve**
> Value perlearnerOrgsUsersCoursesOverviewEngagementIndexRetrieve(courseId, org, userId)



Average of days with atleast an activity within ENGAGEMENT_INDEX_PERIOD consecutive days for a learner in a course

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 

try {
    final response = api.perlearnerOrgsUsersCoursesOverviewEngagementIndexRetrieve(courseId, org, userId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersCoursesOverviewEngagementIndexRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**Value**](Value.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersCoursesOverviewGradeRetrieve**
> PerlearnerGradeWithCutOff perlearnerOrgsUsersCoursesOverviewGradeRetrieve(courseId, org, userId, endDate, format, groupId, startDate)



Provides about a learner current grade in a course with the course cut Kwargs 1. course_id e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.perlearnerOrgsUsersCoursesOverviewGradeRetrieve(courseId, org, userId, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersCoursesOverviewGradeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**PerlearnerGradeWithCutOff**](PerlearnerGradeWithCutOff.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersCoursesOverviewPerformanceIndexRetrieve**
> Value perlearnerOrgsUsersCoursesOverviewPerformanceIndexRetrieve(courseId, org, userId, endDate, format, groupId, startDate)



Evaluates performance index for platform, per course, per user and per user-per course  Query Params course_id <optional> learner_id <optional>

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.perlearnerOrgsUsersCoursesOverviewPerformanceIndexRetrieve(courseId, org, userId, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersCoursesOverviewPerformanceIndexRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Value**](Value.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersCoursesOverviewTimeOverTimeRetrieve**
> Overtime perlearnerOrgsUsersCoursesOverviewTimeOverTimeRetrieve(courseId, org, userId, endDate, format, groupId, startDate)



Time spent within a course in secs on a per-day basis  Kwargs 1. course_id  e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email) Query Params 3. start_date e.g 2020-10-01 4. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.perlearnerOrgsUsersCoursesOverviewTimeOverTimeRetrieve(courseId, org, userId, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersCoursesOverviewTimeOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Overtime**](Overtime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersCoursesVideosOverTimeRetrieve**
> Overtime perlearnerOrgsUsersCoursesVideosOverTimeRetrieve(courseId, org, userId, endDate, format, groupId, startDate)



 Watched Videos count on a per-day basis  Kwargs  1. course_id <optional> e.g course-v1:Org+Course4+Run  2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)   Query Params  3. start_date e.g 2020-10-01  4. end_date e.g 2020-10-10   Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.perlearnerOrgsUsersCoursesVideosOverTimeRetrieve(courseId, org, userId, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersCoursesVideosOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Overtime**](Overtime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersCoursesVideosRetrieve**
> PerLearnerCourseVideosWatched perlearnerOrgsUsersCoursesVideosRetrieve(courseId, org, userId, format, groupId)



List of videos within a course a learner has watched  Kwargs 1. course_id e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email)  Default result when no query param is added is [], 0

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String courseId = courseId_example; // String | 
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID

try {
    final response = api.perlearnerOrgsUsersCoursesVideosRetrieve(courseId, org, userId, format, groupId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersCoursesVideosRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**PerLearnerCourseVideosWatched**](PerLearnerCourseVideosWatched.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersGradesPerCourseRetrieve**
> PerlearnerGradingPerCourseAPI perlearnerOrgsUsersGradesPerCourseRetrieve(org, userId, format, groupId)



Summary Grading Information for a learner on a per-enrollment basis  Query Params 1. user_id e.g developer@ibleducation.com or dev123 (username|email)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID

try {
    final response = api.perlearnerOrgsUsersGradesPerCourseRetrieve(org, userId, format, groupId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersGradesPerCourseRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**PerlearnerGradingPerCourseAPI**](PerlearnerGradingPerCourseAPI.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersInfoRetrieve**
> LearnerInformationAPI perlearnerOrgsUsersInfoRetrieve(org, userId, format, groupId, meta, search)



Returns dictionary of user PII

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String meta = meta_example; // String | Include extra analytics information?  * `y` - y * `yes` - yes * `true` - true * `True` - True * `n` - n * `no` - no * `false` - false * `False` - False
final String search = search_example; // String | 

try {
    final response = api.perlearnerOrgsUsersInfoRetrieve(org, userId, format, groupId, meta, search);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersInfoRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **meta** | **String**| Include extra analytics information?  * `y` - y * `yes` - yes * `true` - true * `True` - True * `n` - n * `no` - no * `false` - false * `False` - False | [optional] [default to 'n']
 **search** | **String**|  | [optional] 

### Return type

[**LearnerInformationAPI**](LearnerInformationAPI.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersLastAccessRetrieve**
> PerLearnerLastAccess perlearnerOrgsUsersLastAccessRetrieve(org, userId, format, groupId)



Last course accessed by a learner, includes upto unit information as well

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID

try {
    final response = api.perlearnerOrgsUsersLastAccessRetrieve(org, userId, format, groupId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersLastAccessRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**PerLearnerLastAccess**](PerLearnerLastAccess.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersOverviewEngagementIndexRetrieve**
> Value perlearnerOrgsUsersOverviewEngagementIndexRetrieve(org, userId, endDate, format, groupId, startDate)



Average of days with atleast an activity within ENGAGEMENT_INDEX_PERIOD consecutive days

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.perlearnerOrgsUsersOverviewEngagementIndexRetrieve(org, userId, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersOverviewEngagementIndexRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Value**](Value.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersOverviewGradesAverageRetrieve**
> Average perlearnerOrgsUsersOverviewGradesAverageRetrieve(org, userId, format, groupId)



Average grade value for platform, course, or user.  Query Params course_id <optional>  e.g course-v1:Org+Course4+Run learner_id <optional> e.g std123 , student@email.com

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID

try {
    final response = api.perlearnerOrgsUsersOverviewGradesAverageRetrieve(org, userId, format, groupId);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersOverviewGradesAverageRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**Average**](Average.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersOverviewPerformanceIndexRetrieve**
> Value perlearnerOrgsUsersOverviewPerformanceIndexRetrieve(org, userId, endDate, format, groupId, startDate)



Evaluates performance index for platform, per course, per user and per user-per course  Query Params course_id <optional> learner_id <optional>

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.perlearnerOrgsUsersOverviewPerformanceIndexRetrieve(org, userId, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersOverviewPerformanceIndexRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Value**](Value.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersOverviewTimeOverTimeRetrieve**
> Overtime perlearnerOrgsUsersOverviewTimeOverTimeRetrieve(org, userId, endDate, format, groupId, startDate)



Time spent in secs on a per-day basis  Query Params 1. course_id <optional> e.g course-v1:Org+Course4+Run 2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email) 3. start_date e.g 2020-10-01 4. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.perlearnerOrgsUsersOverviewTimeOverTimeRetrieve(org, userId, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersOverviewTimeOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Overtime**](Overtime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersRetrieve**
> PerlearnerUserList perlearnerOrgsUsersRetrieve(org, format, groupId, length, page, search)



List of entire learners on the platform with aggregated enrollments, completions and time spent

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String org = org_example; // String | 
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final int length = 56; // int | Size of data to return
final int page = 56; // int | Page offset
final String search = search_example; // String | Search string for learner

try {
    final response = api.perlearnerOrgsUsersRetrieve(org, format, groupId, length, page, search);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **length** | **int**| Size of data to return | [optional] 
 **page** | **int**| Page offset | [optional] 
 **search** | **String**| Search string for learner | [optional] 

### Return type

[**PerlearnerUserList**](PerlearnerUserList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersVideosOverTimeRetrieve**
> Overtime perlearnerOrgsUsersVideosOverTimeRetrieve(org, userId, endDate, format, groupId, startDate)



 Watched Videos count on a per-day basis  Kwargs  1. course_id <optional> e.g course-v1:Org+Course4+Run  2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)   Query Params  3. start_date e.g 2020-10-01  4. end_date e.g 2020-10-10   Default result when no query param is added is last_7_days (today inclusive)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.perlearnerOrgsUsersVideosOverTimeRetrieve(org, userId, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersVideosOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Overtime**](Overtime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **perlearnerOrgsUsersVideosPerCourseRetrieve**
> PerlearnerEngagementVideosWatchedPerCourse perlearnerOrgsUsersVideosPerCourseRetrieve(org, userId, endDate, format, groupId, startDate)



Summary Videos watched data for a learner per enrollment  Query Params 1. user_id e.g developer@ibleducation.com or dev123 (username|email)

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getPerlearnerApi();
final String org = org_example; // String | 
final String userId = userId_example; // String | 
final String endDate = endDate_example; // String | end date. ISO 8601
final String format = format_example; // String | Format  * `json` - json
final int groupId = 56; // int | Cohort Group ID
final String startDate = startDate_example; // String | start date. ISO 8601

try {
    final response = api.perlearnerOrgsUsersVideosPerCourseRetrieve(org, userId, endDate, format, groupId, startDate);
    print(response);
} catch on DioException (e) {
    print('Exception when calling PerlearnerApi->perlearnerOrgsUsersVideosPerCourseRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**PerlearnerEngagementVideosWatchedPerCourse**](PerlearnerEngagementVideosWatchedPerCourse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

