# ibl_ai_data_manager_sdk.api.ReportsApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**reportsOrgsList**](ReportsApi.md#reportsorgslist) | **GET** /api/reports/orgs/{org}/ | 
[**reportsOrgsNewCreate**](ReportsApi.md#reportsorgsnewcreate) | **POST** /api/reports/orgs/{org}/new | 


# **reportsOrgsList**
> BuiltList<ReportList> reportsOrgsList(org)



Returns list of report available in the system to download.     `extra_query_params` defines additional query params that can be passed to the report create body If the report has been previously requested, it returns the status of the report

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getReportsApi();
final String org = org_example; // String | 

try {
    final response = api.reportsOrgsList(org);
    print(response);
} catch on DioException (e) {
    print('Exception when calling ReportsApi->reportsOrgsList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**BuiltList&lt;ReportList&gt;**](ReportList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **reportsOrgsNewCreate**
> ReportCreate reportsOrgsNewCreate(org, reportRequest)



Triggers a new report generation.  If the report has been previously requested, it returns the status of the report  The current duration for generated report `{settings.REPORT_EXPIRY_SECONDS/3600}` hours.  Given a sample result of the api call  ```json     [       {         \"data\": [           {             \"display_name\": \"User Report 1\",             \"description\": \"A short Description of Report 1\",             \"report_name\": \"report-1\",             \"icon\": \"http://some-icon.png\",             \"extra_query_params\": [               \"course_id\", \"learner_id\"             ],             \"status\": {}           }         ]       }     ] ```  The body of the request would be ```json     {         \"report_name\": \"report-1\",         \"owner\": \"owner-name\"         \"learner_id\": \"learner-id\",         \"course_id\": \"course-id\",     } ```

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getReportsApi();
final String org = org_example; // String | 
final ReportRequest reportRequest = ; // ReportRequest | 

try {
    final response = api.reportsOrgsNewCreate(org, reportRequest);
    print(response);
} catch on DioException (e) {
    print('Exception when calling ReportsApi->reportsOrgsNewCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **reportRequest** | [**ReportRequest**](ReportRequest.md)|  | 

### Return type

[**ReportCreate**](ReportCreate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

