# ibl_ai_data_manager_sdk.api.ServiceApi

## Load the API package
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**serviceLaunchTenantCreate**](ServiceApi.md#servicelaunchtenantcreate) | **POST** /api/service/launch/tenant/ | 
[**serviceManageUserCreate**](ServiceApi.md#servicemanageusercreate) | **POST** /api/service/manage/user/ | 
[**serviceManageUserRoleCreate**](ServiceApi.md#servicemanageuserrolecreate) | **POST** /api/service/manage/user/role/ | 
[**serviceTenantValidationCreate**](ServiceApi.md#servicetenantvalidationcreate) | **POST** /api/service/tenant/validation/ | 
[**serviceTokenRetrieve**](ServiceApi.md#servicetokenretrieve) | **GET** /api/service/token/ | 
[**serviceUserValidationCreate**](ServiceApi.md#serviceuservalidationcreate) | **POST** /api/service/user/validation/ | 


# **serviceLaunchTenantCreate**
> serviceLaunchTenantCreate()



User/tenant creation flow

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getServiceApi();

try {
    api.serviceLaunchTenantCreate();
} catch on DioException (e) {
    print('Exception when calling ServiceApi->serviceLaunchTenantCreate: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **serviceManageUserCreate**
> serviceManageUserCreate()



User creation flow

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getServiceApi();

try {
    api.serviceManageUserCreate();
} catch on DioException (e) {
    print('Exception when calling ServiceApi->serviceManageUserCreate: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **serviceManageUserRoleCreate**
> serviceManageUserRoleCreate()



Make user tenant admin

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getServiceApi();

try {
    api.serviceManageUserRoleCreate();
} catch on DioException (e) {
    print('Exception when calling ServiceApi->serviceManageUserRoleCreate: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **serviceTenantValidationCreate**
> serviceTenantValidationCreate()



Check if tenant exists or not

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getServiceApi();

try {
    api.serviceTenantValidationCreate();
} catch on DioException (e) {
    print('Exception when calling ServiceApi->serviceTenantValidationCreate: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **serviceTokenRetrieve**
> serviceTokenRetrieve()



GET Gets site hash_key from or Gets site_id form hash_key

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getServiceApi();

try {
    api.serviceTokenRetrieve();
} catch on DioException (e) {
    print('Exception when calling ServiceApi->serviceTokenRetrieve: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **serviceUserValidationCreate**
> serviceUserValidationCreate()



Check if tenant exists or not

### Example
```dart
import 'package:ibl_ai_data_manager_sdk/api.dart';

final api = IblAiDataManagerSdk().getServiceApi();

try {
    api.serviceUserValidationCreate();
} catch on DioException (e) {
    print('Exception when calling ServiceApi->serviceUserValidationCreate: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

