//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//

import 'package:dio/dio.dart';
import 'package:built_value/serializer.dart';
import 'package:ibl_ai_data_manager_sdk/src/serializers.dart';
import 'package:ibl_ai_data_manager_sdk/src/auth/api_key_auth.dart';
import 'package:ibl_ai_data_manager_sdk/src/auth/basic_auth.dart';
import 'package:ibl_ai_data_manager_sdk/src/auth/bearer_auth.dart';
import 'package:ibl_ai_data_manager_sdk/src/auth/oauth.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/ai_account_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/ai_bot_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/ai_index_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/ai_math_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/ai_mentor_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/ai_prompt_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/audience_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/catalog_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/core_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/cred_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/credentials_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/documentsearch_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/engagement_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/es_health_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/finance_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/monitoring_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/overview_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/performance_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/perlearner_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/platform_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/recommendations_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/reports_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/roles_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/saas_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/search_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/service_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/api/skills_api.dart';
import 'package:flutter_dotenv/flutter_dotenv.dart';

class IblAiDataManagerSdk {
   static final String basePath = dotenv.env['IBL_DM_BASE_URL'] ?? r'https://base.manager.mentor.iblai.tech';

  final Dio dio;
  final Serializers serializers;

  IblAiDataManagerSdk({
    Dio? dio,
    Serializers? serializers,
    String? basePathOverride,
    List<Interceptor>? interceptors,
  })  : this.serializers = serializers ?? standardSerializers,
        this.dio = dio ??
            Dio(BaseOptions(
              baseUrl: basePathOverride ?? basePath,
              connectTimeout: const Duration(milliseconds: 5000),
              receiveTimeout: const Duration(milliseconds: 3000),
            )) {
    if (interceptors == null) {
      this.dio.interceptors.addAll([
        OAuthInterceptor(),
        BasicAuthInterceptor(),
        BearerAuthInterceptor(),
        ApiKeyAuthInterceptor(),
      ]);
    } else {
      this.dio.interceptors.addAll(interceptors);
    }
  }

  void setOAuthToken(String name, String token) {
    if (this.dio.interceptors.any((i) => i is OAuthInterceptor)) {
      (this.dio.interceptors.firstWhere((i) => i is OAuthInterceptor) as OAuthInterceptor).tokens[name] = token;
    }
  }

  void setBearerAuth(String name, String token) {
    if (this.dio.interceptors.any((i) => i is BearerAuthInterceptor)) {
      (this.dio.interceptors.firstWhere((i) => i is BearerAuthInterceptor) as BearerAuthInterceptor).tokens[name] = token;
    }
  }

  void setBasicAuth(String name, String username, String password) {
    if (this.dio.interceptors.any((i) => i is BasicAuthInterceptor)) {
      (this.dio.interceptors.firstWhere((i) => i is BasicAuthInterceptor) as BasicAuthInterceptor).authInfo[name] = BasicAuthInfo(username, password);
    }
  }

  void setApiKey(String name, String apiKey) {
    if (this.dio.interceptors.any((i) => i is ApiKeyAuthInterceptor)) {
      (this.dio.interceptors.firstWhere((element) => element is ApiKeyAuthInterceptor) as ApiKeyAuthInterceptor).apiKeys[name] = apiKey;
    }
  }

  /// Get AiAccountApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  AiAccountApi getAiAccountApi() {
    return AiAccountApi(dio, serializers);
  }

  /// Get AiBotApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  AiBotApi getAiBotApi() {
    return AiBotApi(dio, serializers);
  }

  /// Get AiIndexApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  AiIndexApi getAiIndexApi() {
    return AiIndexApi(dio, serializers);
  }

  /// Get AiMathApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  AiMathApi getAiMathApi() {
    return AiMathApi(dio, serializers);
  }

  /// Get AiMentorApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  AiMentorApi getAiMentorApi() {
    return AiMentorApi(dio, serializers);
  }

  /// Get AiPromptApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  AiPromptApi getAiPromptApi() {
    return AiPromptApi(dio, serializers);
  }

  /// Get AudienceApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  AudienceApi getAudienceApi() {
    return AudienceApi(dio, serializers);
  }

  /// Get CatalogApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  CatalogApi getCatalogApi() {
    return CatalogApi(dio, serializers);
  }

  /// Get CoreApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  CoreApi getCoreApi() {
    return CoreApi(dio, serializers);
  }

  /// Get CredApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  CredApi getCredApi() {
    return CredApi(dio, serializers);
  }

  /// Get CredentialsApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  CredentialsApi getCredentialsApi() {
    return CredentialsApi(dio, serializers);
  }

  /// Get DocumentsearchApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  DocumentsearchApi getDocumentsearchApi() {
    return DocumentsearchApi(dio, serializers);
  }

  /// Get EngagementApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  EngagementApi getEngagementApi() {
    return EngagementApi(dio, serializers);
  }

  /// Get EsHealthApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  EsHealthApi getEsHealthApi() {
    return EsHealthApi(dio, serializers);
  }

  /// Get FinanceApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  FinanceApi getFinanceApi() {
    return FinanceApi(dio, serializers);
  }

  /// Get MonitoringApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  MonitoringApi getMonitoringApi() {
    return MonitoringApi(dio, serializers);
  }

  /// Get OverviewApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  OverviewApi getOverviewApi() {
    return OverviewApi(dio, serializers);
  }

  /// Get PerformanceApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  PerformanceApi getPerformanceApi() {
    return PerformanceApi(dio, serializers);
  }

  /// Get PerlearnerApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  PerlearnerApi getPerlearnerApi() {
    return PerlearnerApi(dio, serializers);
  }

  /// Get PlatformApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  PlatformApi getPlatformApi() {
    return PlatformApi(dio, serializers);
  }

  /// Get RecommendationsApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  RecommendationsApi getRecommendationsApi() {
    return RecommendationsApi(dio, serializers);
  }

  /// Get ReportsApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  ReportsApi getReportsApi() {
    return ReportsApi(dio, serializers);
  }

  /// Get RolesApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  RolesApi getRolesApi() {
    return RolesApi(dio, serializers);
  }

  /// Get SaasApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  SaasApi getSaasApi() {
    return SaasApi(dio, serializers);
  }

  /// Get SearchApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  SearchApi getSearchApi() {
    return SearchApi(dio, serializers);
  }

  /// Get ServiceApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  ServiceApi getServiceApi() {
    return ServiceApi(dio, serializers);
  }

  /// Get SkillsApi instance, base route and serializer can be overridden by a given but be careful,
  /// by doing that all interceptors will not be executed
  SkillsApi getSkillsApi() {
    return SkillsApi(dio, serializers);
  }
}
