//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//

import 'dart:async';

import 'package:built_value/serializer.dart';
import 'package:dio/dio.dart';

import 'package:built_collection/built_collection.dart';
import 'package:ibl_ai_data_manager_sdk/src/api_util.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/api_token_cost.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/credential.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/credential_request.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/iblai_platform_meta.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/iblai_platform_meta_request.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/iblai_platform_meta_update_request.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/integration_credential.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/patched_credential_request.dart';

class AiAccountApi {

  final Dio _dio;

  final Serializers _serializers;

  const AiAccountApi(this._dio, this._serializers);

  /// aiAccountOrgsCredentialCreate
  /// This is for creating llm credentials for a tenant.  Accessible to tenant admins only.  Raises:      NotFound: When tenant key is not found.  Returns:      400: When the data is not valid, when the name already exists for the same tenant.      400: When the name already exists for the same tenant.      400: When the name already exists for the same tenant.      201 : Llm credential details.  Example Response:      POST : /api/ai-account/orgs/main/credential/ .      Request:       {                         \&quot;name\&quot;: \&quot;openai\&quot;,                         \&quot;value\&quot;: {                             \&quot;key\&quot;: \&quot;sk-xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;                         },                         \&quot;platform\&quot;: \&quot;main\&quot;                     }       Response:       {                         \&quot;name\&quot;: \&quot;openai\&quot;,                         \&quot;value\&quot;: {                             \&quot;key\&quot;: \&quot;sk-xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;                         },                         \&quot;platform\&quot;: \&quot;main\&quot;                     }
  ///
  /// Parameters:
  /// * [org] 
  /// * [credentialRequest] 
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Credential] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Credential>> aiAccountOrgsCredentialCreate({ 
    required String org,
    required CredentialRequest credentialRequest,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/ai-account/orgs/{org}/credential/'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'POST',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      contentType: 'application/json',
      validateStatus: validateStatus,
    );

    dynamic _bodyData;

    try {
      const _type = FullType(CredentialRequest);
      _bodyData = _serializers.serialize(credentialRequest, specifiedType: _type);

    } catch(error, stackTrace) {
      throw DioException(
         requestOptions: _options.compose(
          _dio.options,
          _path,
        ),
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    final _response = await _dio.request<Object>(
      _path,
      data: _bodyData,
      options: _options,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Credential? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Credential),
      ) as Credential;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Credential>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// aiAccountOrgsCredentialPartialUpdate
  /// This is for updating llm credentials for a tenant.  Accessible to tenant admins only.  Raises:      NotFound: When tenant key is not found.      NotFound: When the name passed is not found.  Returns:      400: When the data is not valid, when the name already exists for the same tenant.      400: When the name already exists for the same tenant.      400: When the name already exists for the same tenant.      200 : Llm credential details.  Example Response:      POST : /api/ai-account/orgs/main/credential/ .      Request:       {                         \&quot;name\&quot;: \&quot;openai\&quot;,                         \&quot;value\&quot;: {                             \&quot;key\&quot;: \&quot;sk-xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;                         },                         \&quot;platform\&quot;: \&quot;main\&quot;                     }       Response:       {                         \&quot;name\&quot;: \&quot;openai\&quot;,                         \&quot;value\&quot;: {                             \&quot;key\&quot;: \&quot;sk-xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;                         },                         \&quot;platform\&quot;: \&quot;main\&quot;                     }
  ///
  /// Parameters:
  /// * [org] 
  /// * [patchedCredentialRequest] 
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Credential] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Credential>> aiAccountOrgsCredentialPartialUpdate({ 
    required String org,
    PatchedCredentialRequest? patchedCredentialRequest,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/ai-account/orgs/{org}/credential/'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'PATCH',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      contentType: 'application/json',
      validateStatus: validateStatus,
    );

    dynamic _bodyData;

    try {
      const _type = FullType(PatchedCredentialRequest);
      _bodyData = patchedCredentialRequest == null ? null : _serializers.serialize(patchedCredentialRequest, specifiedType: _type);

    } catch(error, stackTrace) {
      throw DioException(
         requestOptions: _options.compose(
          _dio.options,
          _path,
        ),
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    final _response = await _dio.request<Object>(
      _path,
      data: _bodyData,
      options: _options,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Credential? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Credential),
      ) as Credential;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Credential>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// aiAccountOrgsCredentialRetrieve
  /// This is for getting list of llm credentials for a tenant.  You can also filter the llm credentials by passing a query parameter name&#x3D;&lt;llm_name&gt;.  Accessible to tenant admins only.  Raises:      NotFound: When tenant key is not found.      NotFound: When the llm name passed in the paramter is not found.   Returns:      400: When the data is not valid.      200 : List of llm credentials.  Example Response:      GET : /api/ai-account/orgs/main/credential/ .      Response:       [                         {                             \&quot;name\&quot;: \&quot;openai\&quot;,                             \&quot;value\&quot;: {                                 \&quot;key\&quot;: \&quot;sk-xxxxxxxxxxxxxxxxxxxxx\&quot;                             },                             \&quot;platform\&quot;: \&quot;main\&quot;                         },                         {                             \&quot;name\&quot;: \&quot;google\&quot;,                             \&quot;value\&quot;: {                                 \&quot;type\&quot;: \&quot;service_account\&quot;,                                 \&quot;auth_uri\&quot;: \&quot;https://accounts.google.com/o/oauth2/auth\&quot;,                                 \&quot;client_id\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                                 \&quot;token_uri\&quot;: \&quot;https://oauth2.googleapis.com/token\&quot;,                                 \&quot;project_id\&quot;: \&quot;xxxxxxxxxxxxxx\&quot;,                                 \&quot;private_key\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                                 \&quot;client_email\&quot;: \&quot;xxx-xxx-sa@xx-xxxx.iam.gserviceaccount.com\&quot;,                                 \&quot;private_key_id\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                                 \&quot;universe_domain\&quot;: \&quot;googleapis.com\&quot;,                                 \&quot;client_x509_cert_url\&quot;: \&quot;https://www.googleapis.com/robot/v1/metadata/x509/xxxxxxxx.com\&quot;,                                 \&quot;auth_provider_x509_cert_url\&quot;: \&quot;https://www.googleapis.com/oauth2/v1/certs\&quot;                             },                             \&quot;platform\&quot;: \&quot;main\&quot;                         }                     ]
  ///
  /// Parameters:
  /// * [org] 
  /// * [name] - Name of the credential provider
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Credential] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Credential>> aiAccountOrgsCredentialRetrieve({ 
    required String org,
    String? name,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/ai-account/orgs/{org}/credential/'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (name != null) r'name': encodeQueryParameter(_serializers, name, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Credential? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Credential),
      ) as Credential;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Credential>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// aiAccountOrgsIntegrationCredentialCreate
  /// This is for creating integration credentials for a tenant.  Accessible to tenant admins only.  Raises:      NotFound: When tenant key is not found.  Returns:      400: When the data is not valid, when the name already exists for the same tenant.      400: When the name already exists for the same tenant.      201 : Tntegration credential details.  Example Response:      POST : /api/ai-account/orgs/main/integration-credential/ .      Request:       {                         \&quot;name\&quot;: \&quot;google-drive\&quot;,                         \&quot;value\&quot;: {                             \&quot;type\&quot;: \&quot;service_account\&quot;,                             \&quot;auth_uri\&quot;: \&quot;https://accounts.google.com/o/oauth2/auth\&quot;,                             \&quot;client_id\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                             \&quot;token_uri\&quot;: \&quot;https://oauth2.googleapis.com/token\&quot;,                             \&quot;project_id\&quot;: \&quot;xxxxxxxxxxxxxx\&quot;,                             \&quot;private_key\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                             \&quot;client_email\&quot;: \&quot;xxx-xxx-sa@xx-xxxx.iam.gserviceaccount.com\&quot;,                             \&quot;private_key_id\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                             \&quot;universe_domain\&quot;: \&quot;googleapis.com\&quot;,                             \&quot;client_x509_cert_url\&quot;: \&quot;https://www.googleapis.com/robot/v1/metadata/x509/xxxxxxxx.com\&quot;,                             \&quot;auth_provider_x509_cert_url\&quot;: \&quot;https://www.googleapis.com/oauth2/v1/certs\&quot;                         },                         \&quot;platform\&quot;: \&quot;main\&quot;                     }       Response:       {                         \&quot;name\&quot;: \&quot;google-drive\&quot;,                         \&quot;value\&quot;: {                             \&quot;type\&quot;: \&quot;service_account\&quot;,                             \&quot;auth_uri\&quot;: \&quot;https://accounts.google.com/o/oauth2/auth\&quot;,                             \&quot;client_id\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                             \&quot;token_uri\&quot;: \&quot;https://oauth2.googleapis.com/token\&quot;,                             \&quot;project_id\&quot;: \&quot;xxxxxxxxxxxxxx\&quot;,                             \&quot;private_key\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                             \&quot;client_email\&quot;: \&quot;xxx-xxx-sa@xx-xxxx.iam.gserviceaccount.com\&quot;,                             \&quot;private_key_id\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                             \&quot;universe_domain\&quot;: \&quot;googleapis.com\&quot;,                             \&quot;client_x509_cert_url\&quot;: \&quot;https://www.googleapis.com/robot/v1/metadata/x509/xxxxxxxx.com\&quot;,                             \&quot;auth_provider_x509_cert_url\&quot;: \&quot;https://www.googleapis.com/oauth2/v1/certs\&quot;                         },                         \&quot;platform\&quot;: \&quot;main\&quot;                     }
  ///
  /// Parameters:
  /// * [org] 
  /// * [credentialRequest] 
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [IntegrationCredential] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<IntegrationCredential>> aiAccountOrgsIntegrationCredentialCreate({ 
    required String org,
    required CredentialRequest credentialRequest,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/ai-account/orgs/{org}/integration-credential/'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'POST',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      contentType: 'application/json',
      validateStatus: validateStatus,
    );

    dynamic _bodyData;

    try {
      const _type = FullType(CredentialRequest);
      _bodyData = _serializers.serialize(credentialRequest, specifiedType: _type);

    } catch(error, stackTrace) {
      throw DioException(
         requestOptions: _options.compose(
          _dio.options,
          _path,
        ),
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    final _response = await _dio.request<Object>(
      _path,
      data: _bodyData,
      options: _options,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    IntegrationCredential? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(IntegrationCredential),
      ) as IntegrationCredential;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<IntegrationCredential>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// aiAccountOrgsIntegrationCredentialPartialUpdate
  /// This is for updating Integration credentials for a tenant.  Accessible to tenant admins only.  Raises:      NotFound: When tenant key is not found.      NotFound: When the name passed is not found.  Returns:      400: When the data is not valid, when the name already exists for the same tenant.      400: When the name already exists for the same tenant.      200 : Llm redential details.  Example Response:      POST : /api/ai-account/orgs/main/integration-credential/ .      Request:       {                         \&quot;name\&quot;: \&quot;google-drive\&quot;,                         \&quot;value\&quot;: {                             \&quot;type\&quot;: \&quot;service_account\&quot;,                             \&quot;auth_uri\&quot;: \&quot;https://accounts.google.com/o/oauth2/auth\&quot;,                             \&quot;client_id\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                             \&quot;token_uri\&quot;: \&quot;https://oauth2.googleapis.com/token\&quot;,                             \&quot;project_id\&quot;: \&quot;xxxxxxxxxxxxxx\&quot;,                             \&quot;private_key\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                             \&quot;client_email\&quot;: \&quot;xxx-xxx-sa@xx-xxxx.iam.gserviceaccount.com\&quot;,                             \&quot;private_key_id\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                             \&quot;universe_domain\&quot;: \&quot;googleapis.com\&quot;,                             \&quot;client_x509_cert_url\&quot;: \&quot;https://www.googleapis.com/robot/v1/metadata/x509/xxxxxxxx.com\&quot;,                             \&quot;auth_provider_x509_cert_url\&quot;: \&quot;https://www.googleapis.com/oauth2/v1/certs\&quot;                         },                         \&quot;platform\&quot;: \&quot;main\&quot;                     }       Response:       {                         \&quot;name\&quot;: \&quot;google-drive\&quot;,                         \&quot;value\&quot;: {                             \&quot;type\&quot;: \&quot;service_account\&quot;,                             \&quot;auth_uri\&quot;: \&quot;https://accounts.google.com/o/oauth2/auth\&quot;,                             \&quot;client_id\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                             \&quot;token_uri\&quot;: \&quot;https://oauth2.googleapis.com/token\&quot;,                             \&quot;project_id\&quot;: \&quot;xxxxxxxxxxxxxx\&quot;,                             \&quot;private_key\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                             \&quot;client_email\&quot;: \&quot;xxx-xxx-sa@xx-xxxx.iam.gserviceaccount.com\&quot;,                             \&quot;private_key_id\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                             \&quot;universe_domain\&quot;: \&quot;googleapis.com\&quot;,                             \&quot;client_x509_cert_url\&quot;: \&quot;https://www.googleapis.com/robot/v1/metadata/x509/xxxxxxxx.com\&quot;,                             \&quot;auth_provider_x509_cert_url\&quot;: \&quot;https://www.googleapis.com/oauth2/v1/certs\&quot;                         }                         \&quot;platform\&quot;: \&quot;main\&quot;                     }
  ///
  /// Parameters:
  /// * [org] 
  /// * [patchedCredentialRequest] 
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [IntegrationCredential] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<IntegrationCredential>> aiAccountOrgsIntegrationCredentialPartialUpdate({ 
    required String org,
    PatchedCredentialRequest? patchedCredentialRequest,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/ai-account/orgs/{org}/integration-credential/'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'PATCH',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      contentType: 'application/json',
      validateStatus: validateStatus,
    );

    dynamic _bodyData;

    try {
      const _type = FullType(PatchedCredentialRequest);
      _bodyData = patchedCredentialRequest == null ? null : _serializers.serialize(patchedCredentialRequest, specifiedType: _type);

    } catch(error, stackTrace) {
      throw DioException(
         requestOptions: _options.compose(
          _dio.options,
          _path,
        ),
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    final _response = await _dio.request<Object>(
      _path,
      data: _bodyData,
      options: _options,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    IntegrationCredential? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(IntegrationCredential),
      ) as IntegrationCredential;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<IntegrationCredential>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// aiAccountOrgsIntegrationCredentialRetrieve
  /// This is for getting  a list of integration credentials for a tenant.  You can also filter the integration credentials by passing a query parameter name&#x3D;&lt;llm_name&gt;.  Accessible to tenant admins only.  Raises:      NotFound: When tenant key is not found.      NotFound: When the  name passed in the paramter is not found.   Returns:      400: When the data is not valid.      200 : List of integration credentials.  Example Response:      GET : /api/ai-account/orgs/main/integration-credential/ .      Response:       [                         {                             \&quot;name\&quot;: \&quot;google-drive\&quot;,                             \&quot;value\&quot;: {                                 \&quot;type\&quot;: \&quot;service_account\&quot;,                                 \&quot;auth_uri\&quot;: \&quot;https://accounts.google.com/o/oauth2/auth\&quot;,                                 \&quot;client_id\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                                 \&quot;token_uri\&quot;: \&quot;https://oauth2.googleapis.com/token\&quot;,                                 \&quot;project_id\&quot;: \&quot;xxxxxxxxxxxxxx\&quot;,                                 \&quot;private_key\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                                 \&quot;client_email\&quot;: \&quot;xxx-xxx-sa@xx-xxxx.iam.gserviceaccount.com\&quot;,                                 \&quot;private_key_id\&quot;: \&quot;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\&quot;,                                 \&quot;universe_domain\&quot;: \&quot;googleapis.com\&quot;,                                 \&quot;client_x509_cert_url\&quot;: \&quot;https://www.googleapis.com/robot/v1/metadata/x509/xxxxxxxx.com\&quot;,                                 \&quot;auth_provider_x509_cert_url\&quot;: \&quot;https://www.googleapis.com/oauth2/v1/certs\&quot;                             },                             \&quot;platform\&quot;: \&quot;main\&quot;                         }                     ]
  ///
  /// Parameters:
  /// * [org] 
  /// * [name] - Name of the credential provider
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [IntegrationCredential] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<IntegrationCredential>> aiAccountOrgsIntegrationCredentialRetrieve({ 
    required String org,
    String? name,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/ai-account/orgs/{org}/integration-credential/'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (name != null) r'name': encodeQueryParameter(_serializers, name, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    IntegrationCredential? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(IntegrationCredential),
      ) as IntegrationCredential;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<IntegrationCredential>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// aiAccountOrgsPlatformMetadataCreate
  /// This is for  adding platform metadata. In order to use google as your LLM provider, you need to specify &#x60;google_project&#x60; (your google cloud project id) and &#x60;google_location&#x60;, which defaults to &#x60;us-central1&#x60;  Accessible to tenant admins only.  Raises:      NotFound: When platfom metadata is not found.  Returns:      201 : Platform metadata details.  Example Response:      GET : /api/ai-account/orgs/main/platform-metadata/ .      Request:        {                         \&quot;data\&quot;: {                             \&quot;services\&quot;: {                                 \&quot;google\&quot;: {                                     \&quot;credential\&quot;: {                                         \&quot;type\&quot;: \&quot;service_account\&quot;,                                         \&quot;auth_uri\&quot;: \&quot;https://accounts.google.com/o/oauth2/auth\&quot;,                                         \&quot;client_id\&quot;: \&quot;\&quot;,                                         \&quot;token_uri\&quot;: \&quot;https://oauth2.googleapis.com/token\&quot;,                                         \&quot;project_id\&quot;: \&quot;NO PROJECT ID IS PROVIDED\&quot;,                                         \&quot;private_key\&quot;: \&quot;\&quot;,                                         \&quot;client_email\&quot;: \&quot;\&quot;,                                         \&quot;private_key_id\&quot;: \&quot;\&quot;,                                         \&quot;universe_domain\&quot;: \&quot;googleapis.com\&quot;,                                         \&quot;client_x509_cert_url\&quot;: \&quot;\&quot;,                                         \&quot;auth_provider_x509_cert_url\&quot;: \&quot;https://www.googleapis.com/oauth2/v1/certs\&quot;                                     },                                     \&quot;llm_options\&quot;: {                                         \&quot;temperature\&quot;: 0.7                                     }                                 },                                 \&quot;openai\&quot;: {                                     \&quot;credential\&quot;: {                                         \&quot;key\&quot;: \&quot;NO KEY IS PROVIDED\&quot;                                     },                                     \&quot;llm_options\&quot;: {                                         \&quot;temperature\&quot;: 0.7                                     }                                 }                             },                             \&quot;active_llm\&quot;: \&quot;openai\&quot;,                             \&quot;active_stt\&quot;: \&quot;google\&quot;,                             \&quot;active_tts\&quot;: \&quot;google\&quot;                         }                     }      Response:       {                         \&quot;metadata\&quot;: {                             \&quot;services\&quot;: {                                 \&quot;google\&quot;: {                                     \&quot;credential\&quot;: {                                         \&quot;type\&quot;: \&quot;service_account\&quot;,                                         \&quot;auth_uri\&quot;: \&quot;https://accounts.google.com/o/oauth2/auth\&quot;,                                         \&quot;client_id\&quot;: \&quot;\&quot;,                                         \&quot;token_uri\&quot;: \&quot;https://oauth2.googleapis.com/token\&quot;,                                         \&quot;project_id\&quot;: \&quot;NO PROJECT ID IS PROVIDED\&quot;,                                         \&quot;private_key\&quot;: \&quot;\&quot;,                                         \&quot;client_email\&quot;: \&quot;\&quot;,                                         \&quot;private_key_id\&quot;: \&quot;\&quot;,                                         \&quot;universe_domain\&quot;: \&quot;googleapis.com\&quot;,                                         \&quot;client_x509_cert_url\&quot;: \&quot;\&quot;,                                         \&quot;auth_provider_x509_cert_url\&quot;: \&quot;https://www.googleapis.com/oauth2/v1/certs\&quot;                                     },                                     \&quot;llm_options\&quot;: {                                         \&quot;temperature\&quot;: 0.7                                     }                                 },                                 \&quot;openai\&quot;: {                                     \&quot;credential\&quot;: {                                         \&quot;key\&quot;: \&quot;NO KEY IS PROVIDED\&quot;                                     },                                     \&quot;llm_options\&quot;: {                                         \&quot;temperature\&quot;: 0.7                                     }                                 }                             },                             \&quot;active_llm\&quot;: \&quot;openai\&quot;,                             \&quot;active_stt\&quot;: \&quot;google\&quot;,                             \&quot;active_tts\&quot;: \&quot;google\&quot;                         }                     }
  ///
  /// Parameters:
  /// * [org] 
  /// * [iBLAIPlatformMetaRequest] 
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [IBLAIPlatformMeta] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<IBLAIPlatformMeta>> aiAccountOrgsPlatformMetadataCreate({ 
    required String org,
    required IBLAIPlatformMetaRequest iBLAIPlatformMetaRequest,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/ai-account/orgs/{org}/platform-metadata/'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'POST',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      contentType: 'application/json',
      validateStatus: validateStatus,
    );

    dynamic _bodyData;

    try {
      const _type = FullType(IBLAIPlatformMetaRequest);
      _bodyData = _serializers.serialize(iBLAIPlatformMetaRequest, specifiedType: _type);

    } catch(error, stackTrace) {
      throw DioException(
         requestOptions: _options.compose(
          _dio.options,
          _path,
        ),
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    final _response = await _dio.request<Object>(
      _path,
      data: _bodyData,
      options: _options,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    IBLAIPlatformMeta? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(IBLAIPlatformMeta),
      ) as IBLAIPlatformMeta;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<IBLAIPlatformMeta>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// aiAccountOrgsPlatformMetadataList
  /// This is for getting platform metadata.  Accessible to tenant admins only.  Raises:      NotFound: When platfom metadata is not found.  Returns:      200 : Platform metadata details.  Example Response:      GET : /api/ai-account/orgs/main/platform-metadata/ .      Response:       {                         \&quot;metadata\&quot;: {                             \&quot;services\&quot;: {                                 \&quot;google\&quot;: {                                     \&quot;credential\&quot;: {                                         \&quot;type\&quot;: \&quot;service_account\&quot;,                                         \&quot;auth_uri\&quot;: \&quot;https://accounts.google.com/o/oauth2/auth\&quot;,                                         \&quot;client_id\&quot;: \&quot;\&quot;,                                         \&quot;token_uri\&quot;: \&quot;https://oauth2.googleapis.com/token\&quot;,                                         \&quot;project_id\&quot;: \&quot;NO PROJECT ID IS PROVIDED\&quot;,                                         \&quot;private_key\&quot;: \&quot;\&quot;,                                         \&quot;client_email\&quot;: \&quot;\&quot;,                                         \&quot;private_key_id\&quot;: \&quot;\&quot;,                                         \&quot;universe_domain\&quot;: \&quot;googleapis.com\&quot;,                                         \&quot;client_x509_cert_url\&quot;: \&quot;\&quot;,                                         \&quot;auth_provider_x509_cert_url\&quot;: \&quot;https://www.googleapis.com/oauth2/v1/certs\&quot;                                     },                                     \&quot;llm_options\&quot;: {                                         \&quot;temperature\&quot;: 0.7                                     }                                 },                                 \&quot;openai\&quot;: {                                     \&quot;credential\&quot;: {                                         \&quot;key\&quot;: \&quot;NO KEY IS PROVIDED\&quot;                                     },                                     \&quot;llm_options\&quot;: {                                         \&quot;temperature\&quot;: 0.7                                     }                                 }                             },                             \&quot;active_llm\&quot;: \&quot;openai\&quot;,                             \&quot;active_stt\&quot;: \&quot;google\&quot;,                             \&quot;active_tts\&quot;: \&quot;google\&quot;                         }                     }
  ///
  /// Parameters:
  /// * [org] 
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [BuiltList<IBLAIPlatformMeta>] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<BuiltList<IBLAIPlatformMeta>>> aiAccountOrgsPlatformMetadataList({ 
    required String org,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/ai-account/orgs/{org}/platform-metadata/'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    BuiltList<IBLAIPlatformMeta>? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(BuiltList, [FullType(IBLAIPlatformMeta)]),
      ) as BuiltList<IBLAIPlatformMeta>;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<BuiltList<IBLAIPlatformMeta>>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// aiAccountOrgsPlatformMetadataUpdate
  /// This is for  updating platform metadata.  Accessible to tenant admins only.  Raises:      NotFound: When platfom metadata is not found.  Returns:      200 : Platform metadata details.  Example Response:      GET : /api/ai-account/orgs/main/platform-metadata/ .      Request:        {                         \&quot;active_llm\&quot;: \&quot;openai\&quot;,                         \&quot;llms\&quot;: [\&quot;google\&quot;, \&quot;openai\&quot;]                     }      Response:       {                         \&quot;metadata\&quot;: {                             \&quot;services\&quot;: {                                 \&quot;google\&quot;: {                                     \&quot;credential\&quot;: {                                         \&quot;type\&quot;: \&quot;service_account\&quot;,                                         \&quot;auth_uri\&quot;: \&quot;https://accounts.google.com/o/oauth2/auth\&quot;,                                         \&quot;client_id\&quot;: \&quot;\&quot;,                                         \&quot;token_uri\&quot;: \&quot;https://oauth2.googleapis.com/token\&quot;,                                         \&quot;project_id\&quot;: \&quot;NO PROJECT ID IS PROVIDED\&quot;,                                         \&quot;private_key\&quot;: \&quot;\&quot;,                                         \&quot;client_email\&quot;: \&quot;\&quot;,                                         \&quot;private_key_id\&quot;: \&quot;\&quot;,                                         \&quot;universe_domain\&quot;: \&quot;googleapis.com\&quot;,                                         \&quot;client_x509_cert_url\&quot;: \&quot;\&quot;,                                         \&quot;auth_provider_x509_cert_url\&quot;: \&quot;https://www.googleapis.com/oauth2/v1/certs\&quot;                                     },                                     \&quot;llm_options\&quot;: {                                         \&quot;temperature\&quot;: 0.7                                     }                                 },                                 \&quot;openai\&quot;: {                                     \&quot;credential\&quot;: {                                         \&quot;key\&quot;: \&quot;NO KEY IS PROVIDED\&quot;                                     },                                     \&quot;llm_options\&quot;: {                                         \&quot;temperature\&quot;: 0.7                                     }                                 }                             },                             \&quot;active_llm\&quot;: \&quot;openai\&quot;,                             \&quot;active_stt\&quot;: \&quot;google\&quot;,                             \&quot;active_tts\&quot;: \&quot;google\&quot;                         }                     }
  ///
  /// Parameters:
  /// * [org] 
  /// * [iBLAIPlatformMetaUpdateRequest] 
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [BuiltList<IBLAIPlatformMeta>] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<BuiltList<IBLAIPlatformMeta>>> aiAccountOrgsPlatformMetadataUpdate({ 
    required String org,
    IBLAIPlatformMetaUpdateRequest? iBLAIPlatformMetaUpdateRequest,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/ai-account/orgs/{org}/platform-metadata/'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'PUT',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      contentType: 'application/json',
      validateStatus: validateStatus,
    );

    dynamic _bodyData;

    try {
      const _type = FullType(IBLAIPlatformMetaUpdateRequest);
      _bodyData = iBLAIPlatformMetaUpdateRequest == null ? null : _serializers.serialize(iBLAIPlatformMetaUpdateRequest, specifiedType: _type);

    } catch(error, stackTrace) {
      throw DioException(
         requestOptions: _options.compose(
          _dio.options,
          _path,
        ),
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    final _response = await _dio.request<Object>(
      _path,
      data: _bodyData,
      options: _options,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    BuiltList<IBLAIPlatformMeta>? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(BuiltList, [FullType(IBLAIPlatformMeta)]),
      ) as BuiltList<IBLAIPlatformMeta>;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<BuiltList<IBLAIPlatformMeta>>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// aiAccountOrgsTokensList
  /// This is for getting weekly tokens.  You can also filter the list  by passing a query parameter username&#x3D;&lt;username&gt; and session_id&#x3D;&lt;session_id&gt;.  Accessible to tenant admins only.  Raises:      NotFound: When organization is not found.      NotFound: When session id is not found.   Returns:      400: When the data is not valid.      200 : List of tokens.  Example Response:      GET : /api/ai-account/orgs/main/tokens/ .      Response:       [                         {                             \&quot;date\&quot;: \&quot;2024-02-05\&quot;,                             \&quot;completion_tokens\&quot;: 2147483647,                             \&quot;prompt_tokens\&quot;: 123456785                         }                     ]
  ///
  /// Parameters:
  /// * [org] 
  /// * [sessionId] - session id of the user's chat
  /// * [username] - Username of the user
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [BuiltList<APITokenCost>] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<BuiltList<APITokenCost>>> aiAccountOrgsTokensList({ 
    required String org,
    String? sessionId,
    String? username,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/ai-account/orgs/{org}/tokens/'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (sessionId != null) r'session_id': encodeQueryParameter(_serializers, sessionId, const FullType(String)),
      if (username != null) r'username': encodeQueryParameter(_serializers, username, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    BuiltList<APITokenCost>? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(BuiltList, [FullType(APITokenCost)]),
      ) as BuiltList<APITokenCost>;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<BuiltList<APITokenCost>>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

}
