//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//

import 'dart:async';

import 'package:built_value/serializer.dart';
import 'package:dio/dio.dart';

import 'package:ibl_ai_data_manager_sdk/src/api_util.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/average_overtime.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/course_completion_per_course.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/engagement_per_course.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/overtime.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/overtime_with_change_info.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/per_learner_time_spent_in_course_tree.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/time_detail.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/time_spent_by_users_in_course.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/time_spent_per_course.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/video_engagement_per_course.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/videos_in_course_summary.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/videos_specific_course.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/watched_videos_per_user.dart';

class EngagementApi {

  final Dio _dio;

  final Serializers _serializers;

  const EngagementApi(this._dio, this._serializers);

  /// engagementOrgsActivityRetrieve
  /// Engagement information on a per-course basis
  ///
  /// Parameters:
  /// * [org] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [length] - Size of data to return
  /// * [page] - Page offset
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [EngagementPerCourse] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<EngagementPerCourse>> engagementOrgsActivityRetrieve({ 
    required String org,
    String? format = 'json',
    int? groupId,
    int? length,
    int? page,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/activity'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (length != null) r'length': encodeQueryParameter(_serializers, length, const FullType(int)),
      if (page != null) r'page': encodeQueryParameter(_serializers, page, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    EngagementPerCourse? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(EngagementPerCourse),
      ) as EngagementPerCourse;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<EngagementPerCourse>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsCourseCompletionPerCourseRetrieve
  /// Aggregated table of enrollments,and completed count on a per-course basis
  ///
  /// Parameters:
  /// * [org] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [length] - Size of data to return
  /// * [page] - Page offset
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [CourseCompletionPerCourse] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<CourseCompletionPerCourse>> engagementOrgsCourseCompletionPerCourseRetrieve({ 
    required String org,
    String? format = 'json',
    int? groupId,
    int? length,
    int? page,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/course_completion/per-course'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (length != null) r'length': encodeQueryParameter(_serializers, length, const FullType(int)),
      if (page != null) r'page': encodeQueryParameter(_serializers, page, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    CourseCompletionPerCourse? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(CourseCompletionPerCourse),
      ) as CourseCompletionPerCourse;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<CourseCompletionPerCourse>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsCoursesTimeAverageRetrieve
  /// Average time spent in secs on a per-day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10 3. course_id &lt;optional&gt;  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [AverageOvertime] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<AverageOvertime>> engagementOrgsCoursesTimeAverageRetrieve({ 
    required String courseId,
    required String org,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/courses/{course_id}/time/average'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    AverageOvertime? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(AverageOvertime),
      ) as AverageOvertime;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<AverageOvertime>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsCoursesTimeDetailRetrieve
  /// Time spent per course in secs in a tree like form  Kwargs course_id e.g course-v1:Org+Course4+Run  Query Params 1. start_date &lt;optional&gt; e.g 2020-10-01 2. end_date &lt;optional&gt; e.g 2020-10-10
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [TimeDetail] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<TimeDetail>> engagementOrgsCoursesTimeDetailRetrieve({ 
    required String courseId,
    required String org,
    String? format = 'json',
    int? groupId,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/courses/{course_id}/time/detail'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    TimeDetail? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(TimeDetail),
      ) as TimeDetail;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<TimeDetail>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsCoursesTimeOverTimeRetrieve
  /// Time spent per course in secs on a per-day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10 Kwargs 3. course_id  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Overtime] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Overtime>> engagementOrgsCoursesTimeOverTimeRetrieve({ 
    required String courseId,
    required String org,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/courses/{course_id}/time/over-time'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Overtime? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Overtime),
      ) as Overtime;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Overtime>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsCoursesTimeUsersDetailRetrieve
  /// Time spent within a course in ordered hierarchical format  Kwargs 1. course_id  e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email) Query Params 3. start_date &lt;optional&gt; e.g 2020-10-01 4. end_date &lt;optional&gt; e.g 2020-10-10
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [userId] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [PerLearnerTimeSpentInCourseTree] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<PerLearnerTimeSpentInCourseTree>> engagementOrgsCoursesTimeUsersDetailRetrieve({ 
    required String courseId,
    required String org,
    required String userId,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/courses/{course_id}/time/users/{user_id}/detail'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    PerLearnerTimeSpentInCourseTree? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(PerLearnerTimeSpentInCourseTree),
      ) as PerLearnerTimeSpentInCourseTree;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<PerLearnerTimeSpentInCourseTree>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsCoursesTimeUsersOverTimeRetrieve
  /// Time spent in secs on a per-day basis  Query Params 1. course_id &lt;optional&gt; e.g course-v1:Org+Course4+Run 2. user_id &lt;optional&gt; e.g developer@ibleducation.com or dev123 (username|email) 3. start_date e.g 2020-10-01 4. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [userId] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Overtime] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Overtime>> engagementOrgsCoursesTimeUsersOverTimeRetrieve({ 
    required String courseId,
    required String org,
    required String userId,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/courses/{course_id}/time/users/{user_id}/over-time'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Overtime? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Overtime),
      ) as Overtime;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Overtime>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsCoursesTimeUsersRetrieve
  /// Time spent by users in a course  Query Params course_id  e.g course-v1:Org+Course4+Run
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [length] - Size of data to return
  /// * [page] - Page offset
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [TimeSpentByUsersInCourse] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<TimeSpentByUsersInCourse>> engagementOrgsCoursesTimeUsersRetrieve({ 
    required String courseId,
    required String org,
    String? endDate,
    String? format = 'json',
    int? groupId,
    int? length,
    int? page,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/courses/{course_id}/time/users'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (length != null) r'length': encodeQueryParameter(_serializers, length, const FullType(int)),
      if (page != null) r'page': encodeQueryParameter(_serializers, page, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    TimeSpentByUsersInCourse? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(TimeSpentByUsersInCourse),
      ) as TimeSpentByUsersInCourse;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<TimeSpentByUsersInCourse>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsCoursesVideosOverTimeRetrieve
  ///  Watched Videos count on a per-day basis  Kwargs  1. course_id &lt;optional&gt; e.g course-v1:Org+Course4+Run  2. user_id &lt;optional&gt; e.g developer@ibleducation.com or dev123 (username|email)   Query Params  3. start_date e.g 2020-10-01  4. end_date e.g 2020-10-10   Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Overtime] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Overtime>> engagementOrgsCoursesVideosOverTimeRetrieve({ 
    required String courseId,
    required String org,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/courses/{course_id}/videos/over-time'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Overtime? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Overtime),
      ) as Overtime;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Overtime>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsCoursesVideosRetrieve
  /// Engagement information (video) for a specific course
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [VideosSpecificCourse] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<VideosSpecificCourse>> engagementOrgsCoursesVideosRetrieve({ 
    required String courseId,
    required String org,
    String? format = 'json',
    int? groupId,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/courses/{course_id}/videos/'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    VideosSpecificCourse? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(VideosSpecificCourse),
      ) as VideosSpecificCourse;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<VideosSpecificCourse>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsCoursesVideosSummaryRetrieve
  /// Returns a Simplified tree structure of videos watched in course Kwargs course_id  e.g course-v1:Org+Course4+Run
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [VideosInCourseSummary] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<VideosInCourseSummary>> engagementOrgsCoursesVideosSummaryRetrieve({ 
    required String courseId,
    required String org,
    String? format = 'json',
    int? groupId,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/courses/{course_id}/videos/summary'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    VideosInCourseSummary? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(VideosInCourseSummary),
      ) as VideosInCourseSummary;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<VideosInCourseSummary>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsCoursesVideosUsersRetrieve
  /// List of users&#39; videos completed records for a specific course  Kwargs course_id  e.g course-v1:Org+Course4+Run
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [WatchedVideosPerUser] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<WatchedVideosPerUser>> engagementOrgsCoursesVideosUsersRetrieve({ 
    required String courseId,
    required String org,
    String? format = 'json',
    int? groupId,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/courses/{course_id}/videos/users'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    WatchedVideosPerUser? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(WatchedVideosPerUser),
      ) as WatchedVideosPerUser;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<WatchedVideosPerUser>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsTimeAveragePerlearnerPercourseRetrieve
  /// Average time spent by a learner in enrolled courses. Gives a rough estimate of whats the average time that would be spent by a learner in a course  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10
  ///
  /// Parameters:
  /// * [org] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [AverageOvertime] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<AverageOvertime>> engagementOrgsTimeAveragePerlearnerPercourseRetrieve({ 
    required String org,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/time/average-perlearner-percourse'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    AverageOvertime? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(AverageOvertime),
      ) as AverageOvertime;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<AverageOvertime>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsTimeAverageWithOverTimeRetrieve
  /// Average time spent in secs on a per-day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10 3. course_id &lt;optional&gt;  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  /// * [org] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [AverageOvertime] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<AverageOvertime>> engagementOrgsTimeAverageWithOverTimeRetrieve({ 
    required String org,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/time/average-with-over-time'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    AverageOvertime? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(AverageOvertime),
      ) as AverageOvertime;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<AverageOvertime>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsTimeOverTimeRetrieve
  /// Time spent in secs on a per-day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  /// * [org] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [OvertimeWithChangeInfo] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<OvertimeWithChangeInfo>> engagementOrgsTimeOverTimeRetrieve({ 
    required String org,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/time/over-time'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    OvertimeWithChangeInfo? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(OvertimeWithChangeInfo),
      ) as OvertimeWithChangeInfo;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<OvertimeWithChangeInfo>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsTimePerCourseRetrieve
  /// Aggregated time spent value on a per course basis
  ///
  /// Parameters:
  /// * [org] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [length] - Size of data to return
  /// * [page] - Page offset
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [TimeSpentPerCourse] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<TimeSpentPerCourse>> engagementOrgsTimePerCourseRetrieve({ 
    required String org,
    String? endDate,
    String? format = 'json',
    int? groupId,
    int? length,
    int? page,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/time/per-course'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (length != null) r'length': encodeQueryParameter(_serializers, length, const FullType(int)),
      if (page != null) r'page': encodeQueryParameter(_serializers, page, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    TimeSpentPerCourse? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(TimeSpentPerCourse),
      ) as TimeSpentPerCourse;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<TimeSpentPerCourse>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsVideosOverTimeRetrieve
  ///  Watched Videos count on a per-day basis  Kwargs  1. course_id &lt;optional&gt; e.g course-v1:Org+Course4+Run  2. user_id &lt;optional&gt; e.g developer@ibleducation.com or dev123 (username|email)   Query Params  3. start_date e.g 2020-10-01  4. end_date e.g 2020-10-10   Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  /// * [org] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Overtime] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Overtime>> engagementOrgsVideosOverTimeRetrieve({ 
    required String org,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/videos/over-time'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Overtime? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Overtime),
      ) as Overtime;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Overtime>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// engagementOrgsVideosRetrieve
  /// Video Engagement information on a per-course basis
  ///
  /// Parameters:
  /// * [org] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [length] - Size of data to return
  /// * [page] - Page offset
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [VideoEngagementPerCourse] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<VideoEngagementPerCourse>> engagementOrgsVideosRetrieve({ 
    required String org,
    String? format = 'json',
    int? groupId,
    int? length,
    int? page,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/engagement/orgs/{org}/videos/'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (length != null) r'length': encodeQueryParameter(_serializers, length, const FullType(int)),
      if (page != null) r'page': encodeQueryParameter(_serializers, page, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    VideoEngagementPerCourse? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(VideoEngagementPerCourse),
      ) as VideoEngagementPerCourse;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<VideoEngagementPerCourse>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

}
