//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//

import 'dart:async';

import 'package:built_value/serializer.dart';
import 'package:dio/dio.dart';

import 'package:ibl_ai_data_manager_sdk/src/api_util.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/average.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/avg_course_grade_with_cutoff.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/course_grade_summary.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/course_grading_detail.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/grading_per_user.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/performance_grades_per_course.dart';

class PerformanceApi {

  final Dio _dio;

  final Serializers _serializers;

  const PerformanceApi(this._dio, this._serializers);

  /// performanceOrgsCoursesGradingAverageRetrieve
  /// Average grade value for platform, course, or user.  Query Params course_id &lt;optional&gt;  e.g course-v1:Org+Course4+Run learner_id &lt;optional&gt; e.g std123 , student@email.com
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Average] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Average>> performanceOrgsCoursesGradingAverageRetrieve({ 
    required String courseId,
    required String org,
    String? format = 'json',
    int? groupId,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/performance/orgs/{org}/courses/{course_id}/grading/average'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Average? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Average),
      ) as Average;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Average>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// performanceOrgsCoursesGradingAverageWithCutoffRetrieve
  /// Returns average course grade and grade cuttoff  e.g &#x60;&#x60;&#x60; {     \&quot;data\&quot;: {         \&quot;grade_cutoffs\&quot;: {             \&quot;A\&quot;: 90,             \&quot;B\&quot;: 80,             \&quot;C\&quot;: 70,         },         \&quot;average_grade\&quot;: 50.0,     } } &#x60;&#x60;&#x60;  Kwargs course_id
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [AvgCourseGradeWithCutoff] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<AvgCourseGradeWithCutoff>> performanceOrgsCoursesGradingAverageWithCutoffRetrieve({ 
    required String courseId,
    required String org,
    String? format = 'json',
    int? groupId,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/performance/orgs/{org}/courses/{course_id}/grading/average-with-cutoff'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    AvgCourseGradeWithCutoff? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(AvgCourseGradeWithCutoff),
      ) as AvgCourseGradeWithCutoff;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<AvgCourseGradeWithCutoff>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// performanceOrgsCoursesGradingDetailRetrieve
  /// Grading summary for the entire course overview in a tree-like format  Kwargs course_id &lt;required&gt;
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [CourseGradingDetail] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<CourseGradingDetail>> performanceOrgsCoursesGradingDetailRetrieve({ 
    required String courseId,
    required String org,
    String? format = 'json',
    int? groupId,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/performance/orgs/{org}/courses/{course_id}/grading/detail'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    CourseGradingDetail? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(CourseGradingDetail),
      ) as CourseGradingDetail;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<CourseGradingDetail>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// performanceOrgsCoursesGradingPerLearnerRetrieve
  /// Grading information per enrolled user in a course  Kwargs course_id &lt;required&gt;
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [GradingPerUser] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<GradingPerUser>> performanceOrgsCoursesGradingPerLearnerRetrieve({ 
    required String courseId,
    required String org,
    String? format = 'json',
    int? groupId,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/performance/orgs/{org}/courses/{course_id}/grading/per-learner'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    GradingPerUser? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(GradingPerUser),
      ) as GradingPerUser;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<GradingPerUser>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// performanceOrgsCoursesGradingSummaryRetrieve
  /// Returns average grades across various assignment types in a course  Query Params course_id  Returns:     dict     {         \&quot;data\&quot;: [             {                 \&quot;assignment_type&#39;: &lt;str&gt;,                 \&quot;weight\&quot;: &lt;float&gt;,                 \&quot;average_weighted_grade\&quot;: &lt;float&gt;,                 \&quot;average_section_grade\&quot;: &lt;float&gt;             }, ...         ]     }
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [CourseGradeSummary] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<CourseGradeSummary>> performanceOrgsCoursesGradingSummaryRetrieve({ 
    required String courseId,
    required String org,
    String? format = 'json',
    int? groupId,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/performance/orgs/{org}/courses/{course_id}/grading/summary'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    CourseGradeSummary? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(CourseGradeSummary),
      ) as CourseGradeSummary;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<CourseGradeSummary>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// performanceOrgsGradingAverageRetrieve
  /// Average grade value for platform, course, or user.  Query Params course_id &lt;optional&gt;  e.g course-v1:Org+Course4+Run learner_id &lt;optional&gt; e.g std123 , student@email.com
  ///
  /// Parameters:
  /// * [org] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Average] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Average>> performanceOrgsGradingAverageRetrieve({ 
    required String org,
    String? format = 'json',
    int? groupId,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/performance/orgs/{org}/grading/average'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Average? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Average),
      ) as Average;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Average>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// performanceOrgsGradingPerCourseRetrieve
  /// Returns grade related performance data per course  Returns:     dict     {         \&quot;data\&quot;: [             {                 \&quot;course_id&#39;: &lt;str&gt;,                 \&quot;name&#39;: &lt;str&gt;,                 \&quot;num_enrollments\&quot;: &lt;int&gt;,                 \&quot;num_passed\&quot;: &lt;int&gt;,                 \&quot;avg_grade\&quot;: &lt;int&gt;             }, ...         ]     }
  ///
  /// Parameters:
  /// * [org] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [length] - Size of data to return
  /// * [page] - Page offset
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [PerformanceGradesPerCourse] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<PerformanceGradesPerCourse>> performanceOrgsGradingPerCourseRetrieve({ 
    required String org,
    String? format = 'json',
    int? groupId,
    int? length,
    int? page,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/performance/orgs/{org}/grading/per-course'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (length != null) r'length': encodeQueryParameter(_serializers, length, const FullType(int)),
      if (page != null) r'page': encodeQueryParameter(_serializers, page, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    PerformanceGradesPerCourse? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(PerformanceGradesPerCourse),
      ) as PerformanceGradesPerCourse;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<PerformanceGradesPerCourse>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

}
