//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//

import 'dart:async';

import 'package:built_value/serializer.dart';
import 'package:dio/dio.dart';

import 'package:ibl_ai_data_manager_sdk/src/api_util.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/activity_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/average.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/detailed_grade_view.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/learner_information_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/overtime.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/per_learner_course_videos_watched.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/per_learner_last_access.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/perlearner_engagement_videos_watched_per_course.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/perlearner_grade_summary.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/perlearner_grade_with_cut_off.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/perlearner_grading_per_course_api.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/perlearner_user_list.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/value.dart';

class PerlearnerApi {

  final Dio _dio;

  final Serializers _serializers;

  const PerlearnerApi(this._dio, this._serializers);

  /// perlearnerOrgsUsersActivityRetrieve
  /// Provides information on user enrollments  Params user_id e.g developer@ibleducation.com| developer
  ///
  /// Parameters:
  /// * [org] 
  /// * [userId] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [ActivityAPI] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<ActivityAPI>> perlearnerOrgsUsersActivityRetrieve({ 
    required String org,
    required String userId,
    String? format = 'json',
    int? groupId,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/activity/'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    ActivityAPI? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(ActivityAPI),
      ) as ActivityAPI;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<ActivityAPI>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersCoursesGradingCutoffsRetrieve
  /// Provides about a learner current grade in a course with the course cut Kwargs 1. course_id e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [userId] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [PerlearnerGradeWithCutOff] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<PerlearnerGradeWithCutOff>> perlearnerOrgsUsersCoursesGradingCutoffsRetrieve({ 
    required String courseId,
    required String org,
    required String userId,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/grading/cutoffs'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    PerlearnerGradeWithCutOff? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(PerlearnerGradeWithCutOff),
      ) as PerlearnerGradeWithCutOff;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<PerlearnerGradeWithCutOff>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersCoursesGradingDetailRetrieve
  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [userId] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [DetailedGradeView] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<DetailedGradeView>> perlearnerOrgsUsersCoursesGradingDetailRetrieve({ 
    required String courseId,
    required String org,
    required String userId,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/grading/detail'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    DetailedGradeView? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(DetailedGradeView),
      ) as DetailedGradeView;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<DetailedGradeView>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersCoursesGradingSummaryRetrieve
  /// Query Params 1. course_id e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [userId] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [PerlearnerGradeSummary] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<PerlearnerGradeSummary>> perlearnerOrgsUsersCoursesGradingSummaryRetrieve({ 
    required String courseId,
    required String org,
    required String userId,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/grading/summary'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    PerlearnerGradeSummary? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(PerlearnerGradeSummary),
      ) as PerlearnerGradeSummary;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<PerlearnerGradeSummary>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersCoursesOverviewEngagementIndexRetrieve
  /// Average of days with atleast an activity within ENGAGEMENT_INDEX_PERIOD consecutive days for a learner in a course
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [userId] 
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Value] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Value>> perlearnerOrgsUsersCoursesOverviewEngagementIndexRetrieve({ 
    required String courseId,
    required String org,
    required String userId,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/overview/engagement-index'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Value? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Value),
      ) as Value;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Value>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersCoursesOverviewGradeRetrieve
  /// Provides about a learner current grade in a course with the course cut Kwargs 1. course_id e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [userId] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [PerlearnerGradeWithCutOff] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<PerlearnerGradeWithCutOff>> perlearnerOrgsUsersCoursesOverviewGradeRetrieve({ 
    required String courseId,
    required String org,
    required String userId,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/overview/grade'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    PerlearnerGradeWithCutOff? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(PerlearnerGradeWithCutOff),
      ) as PerlearnerGradeWithCutOff;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<PerlearnerGradeWithCutOff>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersCoursesOverviewPerformanceIndexRetrieve
  /// Evaluates performance index for platform, per course, per user and per user-per course  Query Params course_id &lt;optional&gt; learner_id &lt;optional&gt;
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [userId] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Value] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Value>> perlearnerOrgsUsersCoursesOverviewPerformanceIndexRetrieve({ 
    required String courseId,
    required String org,
    required String userId,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/overview/performance-index'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Value? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Value),
      ) as Value;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Value>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersCoursesOverviewTimeOverTimeRetrieve
  /// Time spent within a course in secs on a per-day basis  Kwargs 1. course_id  e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email) Query Params 3. start_date e.g 2020-10-01 4. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [userId] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Overtime] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Overtime>> perlearnerOrgsUsersCoursesOverviewTimeOverTimeRetrieve({ 
    required String courseId,
    required String org,
    required String userId,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/overview/time/over-time'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Overtime? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Overtime),
      ) as Overtime;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Overtime>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersCoursesVideosOverTimeRetrieve
  ///  Watched Videos count on a per-day basis  Kwargs  1. course_id &lt;optional&gt; e.g course-v1:Org+Course4+Run  2. user_id &lt;optional&gt; e.g developer@ibleducation.com or dev123 (username|email)   Query Params  3. start_date e.g 2020-10-01  4. end_date e.g 2020-10-10   Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [userId] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Overtime] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Overtime>> perlearnerOrgsUsersCoursesVideosOverTimeRetrieve({ 
    required String courseId,
    required String org,
    required String userId,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/videos/over-time'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Overtime? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Overtime),
      ) as Overtime;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Overtime>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersCoursesVideosRetrieve
  /// List of videos within a course a learner has watched  Kwargs 1. course_id e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email)  Default result when no query param is added is [], 0
  ///
  /// Parameters:
  /// * [courseId] 
  /// * [org] 
  /// * [userId] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [PerLearnerCourseVideosWatched] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<PerLearnerCourseVideosWatched>> perlearnerOrgsUsersCoursesVideosRetrieve({ 
    required String courseId,
    required String org,
    required String userId,
    String? format = 'json',
    int? groupId,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/videos'.replaceAll('{' r'course_id' '}', encodeQueryParameter(_serializers, courseId, const FullType(String)).toString()).replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    PerLearnerCourseVideosWatched? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(PerLearnerCourseVideosWatched),
      ) as PerLearnerCourseVideosWatched;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<PerLearnerCourseVideosWatched>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersGradesPerCourseRetrieve
  /// Summary Grading Information for a learner on a per-enrollment basis  Query Params 1. user_id e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Parameters:
  /// * [org] 
  /// * [userId] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [PerlearnerGradingPerCourseAPI] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<PerlearnerGradingPerCourseAPI>> perlearnerOrgsUsersGradesPerCourseRetrieve({ 
    required String org,
    required String userId,
    String? format = 'json',
    int? groupId,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/grades/per-course'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    PerlearnerGradingPerCourseAPI? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(PerlearnerGradingPerCourseAPI),
      ) as PerlearnerGradingPerCourseAPI;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<PerlearnerGradingPerCourseAPI>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersInfoRetrieve
  /// Returns dictionary of user PII
  ///
  /// Parameters:
  /// * [org] 
  /// * [userId] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [meta] - Include extra analytics information?  * `y` - y * `yes` - yes * `true` - true * `True` - True * `n` - n * `no` - no * `false` - false * `False` - False
  /// * [search] 
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [LearnerInformationAPI] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<LearnerInformationAPI>> perlearnerOrgsUsersInfoRetrieve({ 
    required String org,
    required String userId,
    String? format = 'json',
    int? groupId,
    String? meta = 'n',
    String? search,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/info'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (meta != null) r'meta': encodeQueryParameter(_serializers, meta, const FullType(String)),
      if (search != null) r'search': encodeQueryParameter(_serializers, search, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    LearnerInformationAPI? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(LearnerInformationAPI),
      ) as LearnerInformationAPI;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<LearnerInformationAPI>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersLastAccessRetrieve
  /// Last course accessed by a learner, includes upto unit information as well
  ///
  /// Parameters:
  /// * [org] 
  /// * [userId] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [PerLearnerLastAccess] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<PerLearnerLastAccess>> perlearnerOrgsUsersLastAccessRetrieve({ 
    required String org,
    required String userId,
    String? format = 'json',
    int? groupId,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/last-access'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    PerLearnerLastAccess? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(PerLearnerLastAccess),
      ) as PerLearnerLastAccess;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<PerLearnerLastAccess>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersOverviewEngagementIndexRetrieve
  /// Average of days with atleast an activity within ENGAGEMENT_INDEX_PERIOD consecutive days
  ///
  /// Parameters:
  /// * [org] 
  /// * [userId] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Value] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Value>> perlearnerOrgsUsersOverviewEngagementIndexRetrieve({ 
    required String org,
    required String userId,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/overview/engagement-index'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Value? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Value),
      ) as Value;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Value>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersOverviewGradesAverageRetrieve
  /// Average grade value for platform, course, or user.  Query Params course_id &lt;optional&gt;  e.g course-v1:Org+Course4+Run learner_id &lt;optional&gt; e.g std123 , student@email.com
  ///
  /// Parameters:
  /// * [org] 
  /// * [userId] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Average] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Average>> perlearnerOrgsUsersOverviewGradesAverageRetrieve({ 
    required String org,
    required String userId,
    String? format = 'json',
    int? groupId,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/overview/grades/average'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Average? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Average),
      ) as Average;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Average>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersOverviewPerformanceIndexRetrieve
  /// Evaluates performance index for platform, per course, per user and per user-per course  Query Params course_id &lt;optional&gt; learner_id &lt;optional&gt;
  ///
  /// Parameters:
  /// * [org] 
  /// * [userId] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Value] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Value>> perlearnerOrgsUsersOverviewPerformanceIndexRetrieve({ 
    required String org,
    required String userId,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/overview/performance-index'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Value? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Value),
      ) as Value;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Value>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersOverviewTimeOverTimeRetrieve
  /// Time spent in secs on a per-day basis  Query Params 1. course_id &lt;optional&gt; e.g course-v1:Org+Course4+Run 2. user_id &lt;optional&gt; e.g developer@ibleducation.com or dev123 (username|email) 3. start_date e.g 2020-10-01 4. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  /// * [org] 
  /// * [userId] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Overtime] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Overtime>> perlearnerOrgsUsersOverviewTimeOverTimeRetrieve({ 
    required String org,
    required String userId,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/overview/time/over-time'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Overtime? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Overtime),
      ) as Overtime;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Overtime>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersRetrieve
  /// List of entire learners on the platform with aggregated enrollments, completions and time spent
  ///
  /// Parameters:
  /// * [org] 
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [length] - Size of data to return
  /// * [page] - Page offset
  /// * [search] - Search string for learner
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [PerlearnerUserList] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<PerlearnerUserList>> perlearnerOrgsUsersRetrieve({ 
    required String org,
    String? format = 'json',
    int? groupId,
    int? length,
    int? page,
    String? search,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (length != null) r'length': encodeQueryParameter(_serializers, length, const FullType(int)),
      if (page != null) r'page': encodeQueryParameter(_serializers, page, const FullType(int)),
      if (search != null) r'search': encodeQueryParameter(_serializers, search, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    PerlearnerUserList? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(PerlearnerUserList),
      ) as PerlearnerUserList;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<PerlearnerUserList>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersVideosOverTimeRetrieve
  ///  Watched Videos count on a per-day basis  Kwargs  1. course_id &lt;optional&gt; e.g course-v1:Org+Course4+Run  2. user_id &lt;optional&gt; e.g developer@ibleducation.com or dev123 (username|email)   Query Params  3. start_date e.g 2020-10-01  4. end_date e.g 2020-10-10   Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  /// * [org] 
  /// * [userId] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [Overtime] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<Overtime>> perlearnerOrgsUsersVideosOverTimeRetrieve({ 
    required String org,
    required String userId,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/videos/over-time'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    Overtime? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(Overtime),
      ) as Overtime;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<Overtime>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// perlearnerOrgsUsersVideosPerCourseRetrieve
  /// Summary Videos watched data for a learner per enrollment  Query Params 1. user_id e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Parameters:
  /// * [org] 
  /// * [userId] 
  /// * [endDate] - end date. ISO 8601
  /// * [format] - Format  * `json` - json
  /// * [groupId] - Cohort Group ID
  /// * [startDate] - start date. ISO 8601
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [PerlearnerEngagementVideosWatchedPerCourse] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<PerlearnerEngagementVideosWatchedPerCourse>> perlearnerOrgsUsersVideosPerCourseRetrieve({ 
    required String org,
    required String userId,
    String? endDate,
    String? format = 'json',
    int? groupId,
    String? startDate,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/perlearner/orgs/{org}/users/{user_id}/videos/per-course'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString()).replaceAll('{' r'user_id' '}', encodeQueryParameter(_serializers, userId, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _queryParameters = <String, dynamic>{
      if (endDate != null) r'end_date': encodeQueryParameter(_serializers, endDate, const FullType(String)),
      if (format != null) r'format': encodeQueryParameter(_serializers, format, const FullType(String)),
      if (groupId != null) r'group_id': encodeQueryParameter(_serializers, groupId, const FullType(int)),
      if (startDate != null) r'start_date': encodeQueryParameter(_serializers, startDate, const FullType(String)),
    };

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      queryParameters: _queryParameters,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    PerlearnerEngagementVideosWatchedPerCourse? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(PerlearnerEngagementVideosWatchedPerCourse),
      ) as PerlearnerEngagementVideosWatchedPerCourse;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<PerlearnerEngagementVideosWatchedPerCourse>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

}
