//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//

import 'dart:async';

import 'package:built_value/serializer.dart';
import 'package:dio/dio.dart';

import 'package:built_collection/built_collection.dart';
import 'package:ibl_ai_data_manager_sdk/src/api_util.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/report_create.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/report_list.dart';
import 'package:ibl_ai_data_manager_sdk/src/model/report_request.dart';

class ReportsApi {

  final Dio _dio;

  final Serializers _serializers;

  const ReportsApi(this._dio, this._serializers);

  /// reportsOrgsList
  /// Returns list of report available in the system to download.     &#x60;extra_query_params&#x60; defines additional query params that can be passed to the report create body If the report has been previously requested, it returns the status of the report
  ///
  /// Parameters:
  /// * [org] 
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [BuiltList<ReportList>] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<BuiltList<ReportList>>> reportsOrgsList({ 
    required String org,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/reports/orgs/{org}/'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'GET',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      validateStatus: validateStatus,
    );

    final _response = await _dio.request<Object>(
      _path,
      options: _options,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    BuiltList<ReportList>? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(BuiltList, [FullType(ReportList)]),
      ) as BuiltList<ReportList>;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<BuiltList<ReportList>>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

  /// reportsOrgsNewCreate
  /// Triggers a new report generation.  If the report has been previously requested, it returns the status of the report  The current duration for generated report &#x60;{settings.REPORT_EXPIRY_SECONDS/3600}&#x60; hours.  Given a sample result of the api call  &#x60;&#x60;&#x60;json     [       {         \&quot;data\&quot;: [           {             \&quot;display_name\&quot;: \&quot;User Report 1\&quot;,             \&quot;description\&quot;: \&quot;A short Description of Report 1\&quot;,             \&quot;report_name\&quot;: \&quot;report-1\&quot;,             \&quot;icon\&quot;: \&quot;http://some-icon.png\&quot;,             \&quot;extra_query_params\&quot;: [               \&quot;course_id\&quot;, \&quot;learner_id\&quot;             ],             \&quot;status\&quot;: {}           }         ]       }     ] &#x60;&#x60;&#x60;  The body of the request would be &#x60;&#x60;&#x60;json     {         \&quot;report_name\&quot;: \&quot;report-1\&quot;,         \&quot;owner\&quot;: \&quot;owner-name\&quot;         \&quot;learner_id\&quot;: \&quot;learner-id\&quot;,         \&quot;course_id\&quot;: \&quot;course-id\&quot;,     } &#x60;&#x60;&#x60;
  ///
  /// Parameters:
  /// * [org] 
  /// * [reportRequest] 
  /// * [cancelToken] - A [CancelToken] that can be used to cancel the operation
  /// * [headers] - Can be used to add additional headers to the request
  /// * [extras] - Can be used to add flags to the request
  /// * [validateStatus] - A [ValidateStatus] callback that can be used to determine request success based on the HTTP status of the response
  /// * [onSendProgress] - A [ProgressCallback] that can be used to get the send progress
  /// * [onReceiveProgress] - A [ProgressCallback] that can be used to get the receive progress
  ///
  /// Returns a [Future] containing a [Response] with a [ReportCreate] as data
  /// Throws [DioException] if API call or serialization fails
  Future<Response<ReportCreate>> reportsOrgsNewCreate({ 
    required String org,
    required ReportRequest reportRequest,
    CancelToken? cancelToken,
    Map<String, dynamic>? headers,
    Map<String, dynamic>? extra,
    ValidateStatus? validateStatus,
    ProgressCallback? onSendProgress,
    ProgressCallback? onReceiveProgress,
  }) async {
    final _path = r'/api/reports/orgs/{org}/new'.replaceAll('{' r'org' '}', encodeQueryParameter(_serializers, org, const FullType(String)).toString());
    final _options = Options(
      method: r'POST',
      headers: <String, dynamic>{
        ...?headers,
      },
      extra: <String, dynamic>{
        'secure': <Map<String, String>>[],
        ...?extra,
      },
      contentType: 'application/json',
      validateStatus: validateStatus,
    );

    dynamic _bodyData;

    try {
      const _type = FullType(ReportRequest);
      _bodyData = _serializers.serialize(reportRequest, specifiedType: _type);

    } catch(error, stackTrace) {
      throw DioException(
         requestOptions: _options.compose(
          _dio.options,
          _path,
        ),
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    final _response = await _dio.request<Object>(
      _path,
      data: _bodyData,
      options: _options,
      cancelToken: cancelToken,
      onSendProgress: onSendProgress,
      onReceiveProgress: onReceiveProgress,
    );

    ReportCreate? _responseData;

    try {
      final rawResponse = _response.data;
      _responseData = rawResponse == null ? null : _serializers.deserialize(
        rawResponse,
        specifiedType: const FullType(ReportCreate),
      ) as ReportCreate;

    } catch (error, stackTrace) {
      throw DioException(
        requestOptions: _response.requestOptions,
        response: _response,
        type: DioExceptionType.unknown,
        error: error,
        stackTrace: stackTrace,
      );
    }

    return Response<ReportCreate>(
      data: _responseData,
      headers: _response.headers,
      isRedirect: _response.isRedirect,
      requestOptions: _response.requestOptions,
      redirects: _response.redirects,
      statusCode: _response.statusCode,
      statusMessage: _response.statusMessage,
      extra: _response.extra,
    );
  }

}
