//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//

// ignore_for_file: unused_element
import 'package:ibl_ai_data_manager_sdk/src/model/state_enum.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

part 'report_status.g.dart';

/// ReportStatus
///
/// Properties:
/// * [reportId] - Used to download the report
/// * [reportName] - Report slug, this is passed when calling the create report endpoint
/// * [state] - Report States

* `pending` - Pending
* `running` - Running
* `accumulating` - Accumulating
* `processing` - Processing
* `storing` - Storing
* `completed` - Completed
* `cancelled` - Cancelled
* `error` - Error
/// * [startedOn] - Report request timestamp (ISO 8601)
/// * [owner] - Report Owner
/// * [expires] - When report would expire and not available for download anymore
/// * [url] - Download link for report when available
@BuiltValue()
abstract class ReportStatus implements Built<ReportStatus, ReportStatusBuilder> {
  /// Used to download the report
  @BuiltValueField(wireName: r'report_id')
  String? get reportId;

  /// Report slug, this is passed when calling the create report endpoint
  @BuiltValueField(wireName: r'report_name')
  String? get reportName;

  /// Report States

* `pending` - Pending
* `running` - Running
* `accumulating` - Accumulating
* `processing` - Processing
* `storing` - Storing
* `completed` - Completed
* `cancelled` - Cancelled
* `error` - Error
  @BuiltValueField(wireName: r'state')
  StateEnum? get state;
  // enum stateEnum {  pending,  running,  accumulating,  processing,  storing,  completed,  cancelled,  error,  };

  /// Report request timestamp (ISO 8601)
  @BuiltValueField(wireName: r'started_on')
  String? get startedOn;

  /// Report Owner
  @BuiltValueField(wireName: r'owner')
  String? get owner;

  /// When report would expire and not available for download anymore
  @BuiltValueField(wireName: r'expires')
  String? get expires;

  /// Download link for report when available
  @BuiltValueField(wireName: r'url')
  String? get url;

  ReportStatus._();

  factory ReportStatus([void updates(ReportStatusBuilder b)]) = _$ReportStatus;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReportStatusBuilder b) => b;

  @BuiltValueSerializer(custom: true)
  static Serializer<ReportStatus> get serializer => _$ReportStatusSerializer();
}

class _$ReportStatusSerializer implements PrimitiveSerializer<ReportStatus> {
  @override
  final Iterable<Type> types = const [ReportStatus, _$ReportStatus];

  @override
  final String wireName = r'ReportStatus';

  Iterable<Object?> _serializeProperties(
    Serializers serializers,
    ReportStatus object, {
    FullType specifiedType = FullType.unspecified,
  }) sync* {
    if (object.reportId != null) {
      yield r'report_id';
      yield serializers.serialize(
        object.reportId,
        specifiedType: const FullType(String),
      );
    }
    if (object.reportName != null) {
      yield r'report_name';
      yield serializers.serialize(
        object.reportName,
        specifiedType: const FullType(String),
      );
    }
    if (object.state != null) {
      yield r'state';
      yield serializers.serialize(
        object.state,
        specifiedType: const FullType(StateEnum),
      );
    }
    if (object.startedOn != null) {
      yield r'started_on';
      yield serializers.serialize(
        object.startedOn,
        specifiedType: const FullType(String),
      );
    }
    if (object.owner != null) {
      yield r'owner';
      yield serializers.serialize(
        object.owner,
        specifiedType: const FullType(String),
      );
    }
    if (object.expires != null) {
      yield r'expires';
      yield serializers.serialize(
        object.expires,
        specifiedType: const FullType(String),
      );
    }
    if (object.url != null) {
      yield r'url';
      yield serializers.serialize(
        object.url,
        specifiedType: const FullType(String),
      );
    }
  }

  @override
  Object serialize(
    Serializers serializers,
    ReportStatus object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    return _serializeProperties(serializers, object, specifiedType: specifiedType).toList();
  }

  void _deserializeProperties(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
    required List<Object?> serializedList,
    required ReportStatusBuilder result,
    required List<Object?> unhandled,
  }) {
    for (var i = 0; i < serializedList.length; i += 2) {
      final key = serializedList[i] as String;
      final value = serializedList[i + 1];
      switch (key) {
        case r'report_id':
          final valueDes = serializers.deserialize(
            value,
            specifiedType: const FullType(String),
          ) as String;
          result.reportId = valueDes;
          break;
        case r'report_name':
          final valueDes = serializers.deserialize(
            value,
            specifiedType: const FullType(String),
          ) as String;
          result.reportName = valueDes;
          break;
        case r'state':
          final valueDes = serializers.deserialize(
            value,
            specifiedType: const FullType(StateEnum),
          ) as StateEnum;
          result.state = valueDes;
          break;
        case r'started_on':
          final valueDes = serializers.deserialize(
            value,
            specifiedType: const FullType(String),
          ) as String;
          result.startedOn = valueDes;
          break;
        case r'owner':
          final valueDes = serializers.deserialize(
            value,
            specifiedType: const FullType(String),
          ) as String;
          result.owner = valueDes;
          break;
        case r'expires':
          final valueDes = serializers.deserialize(
            value,
            specifiedType: const FullType(String),
          ) as String;
          result.expires = valueDes;
          break;
        case r'url':
          final valueDes = serializers.deserialize(
            value,
            specifiedType: const FullType(String),
          ) as String;
          result.url = valueDes;
          break;
        default:
          unhandled.add(key);
          unhandled.add(value);
          break;
      }
    }
  }

  @override
  ReportStatus deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) {
    final result = ReportStatusBuilder();
    final serializedList = (serialized as Iterable<Object?>).toList();
    final unhandled = <Object?>[];
    _deserializeProperties(
      serializers,
      serialized,
      specifiedType: specifiedType,
      serializedList: serializedList,
      unhandled: unhandled,
      result: result,
    );
    return result.build();
  }
}

